# web
This is the web part of PUMA.
It requires the server part (canone3) and is implemented in HTML, JavaScript, 
JQuery, Bootstrap and PHP

## prerequisites
Prerequisites are Canone3, a web server (Apache or NGINX) with SSL certificate, 
PHP and PostgreSQL (MySQL isn't officialy supported but may be an alternative).

A user authentication system (only keycloak and LDAP are supported).

## installation
- Download all files
- Setup the database (use file init_pg.sql)
- fill all required configurations in conf.php, in js/conf.js, in spa/js/conf.js
and in lib/conf_jive.js

## authentication
PUMA emphasize user customization, that's why authentication is important.

There is a module to authenticate using keycloak or LDAP, please insert your method in file 
auth.php.

Only for test/quick start pourpose, there is a trivial method which allows all 
non empty usernames without password.

Any non trivial authentication require SSL certificate.

## SPA (single-page application)
in folder spa, index.html is used as a loader of some JavaScript files and a
configurable html file.
This loaded file can be pure HTML or can include some JavaScript and is referred as a _screen_.

Every HTML tag can be animated by inserting 'puma' (for older versions 'pwma') 
in the class list and a valid epics or tango attribute naming in the data-src 
attribute, e.g.
```html
<span id="myid" class="puma other-optional-classes" data-src="localhost:20000/test/device/1/long_scalar"></span>
```

the same method can be used also in SVG tags, for example:

```html
<rect x='0' y='0' width='110' height='12' style='fill:white; stroke:gray; stroke-width:1;' id="rect1" class="puma" data-src="datasrc1" data-onupdate="updateStateColor"></rect>
<use id='cam1' xlink:href="#cam" x='1800' y='5' style='stroke:gray;' class="puma" data-src="datasrc2" data-onupdate="updateCam" />	
<text x='2' y='14' style='fill:black' font-family="sans-serif" font-size="6" id="bpm1" class="puma hidden" data-src="datasrc3" data-onupdate="updateBpm"></text>
```
Screens can be saved on filesystem, database or a GIT repository as configured on server side.

More detail are described in page spa/index.html?version=template

## Designer
A designer produce adaptive screens using CSS3 flexbox. All saved screens can be imported as a widget.

## Text editor
For HTML and SVG files there is a text editor with automatic and instant preview.Files can be stored on filesystem, database or gitlab repository.

## SVG editor
The SVG part of any file is extracted and sent to the SVG editor.On save the edited SVG part is inserted again in the same file substituting the old SVG part.
_id_ and _class_ attribute are editable in evidence,also two non custom attributes are editable: _data-src_ and _data-onupdate_.
There is the possibility to pick up and drop on the plot some custom SVG easy elements (paths).
A _precision_ parameter discretize position of drogged elements 

## Demo
A few demos are available on Youtube [channel](https://www.youtube.com/channel/UCumWGWvXvlTbomoO88rWh7g/videos)




