<?php
	require_once("./conf.php");

	//-----------------------------------------------------------------------------
	function ldap_auth($_username, $_password) {
		$ldap_error = false;
		$ldap_url = 'ldaps://'.LDAP_SERVER.':636/';
		if (!function_exists('ldap_connect')) {
			$ldap_error = "LDAP module not installed in PHP";
			return $ldap_error;
		}
		$ldap = ldap_connect($ldap_url);
		$ldap_error = "$ldap_url\n";
		if (!$ldap) {
			$ldap_error = "Could not connect to $ldap_url";
			return $ldap_error;
		}
		ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
		$password = trim(stripslashes($_password));
		$username = trim(stripslashes($_username));
		if (empty($password)) {
			@ldap_close($ldap);
			$ldap_error = "empty password";
			return $ldap_error;
		}
		if ($ldap) {
			$user_search = ldap_search($ldap, LDAP_DN, "(uid=$username)");
			if (!$user_search) {
				$ldap_error ="Error in search query ($ldap_url): ".ldap_error($ldap);
				return $ldap_error;
			}
			$user_get = ldap_get_entries($ldap, $user_search);
			if (!$user_get) {
				$ldap_error = 'user not found';
				@ldap_close($ldap);
				return $ldap_error;
			}
			$user_entry = ldap_first_entry($ldap, $user_search);
			if (!$user_entry) {
				$ldap_error = 'user not found';
				@ldap_close($ldap);
				return $ldap_error;
			}
			$user_dn = ldap_get_dn($ldap, $user_entry);
			if (!$user_dn) {
				$ldap_error = 'user not found';
				@ldap_close($ldap);
				return $ldap_error;
			}
			if (@ldap_bind($ldap, $user_dn, $password)) {
				$ldap_error = 'alias';
				if ($user_get && $user_get['count']) {
					// $login = array('realname' => $user_get[0]['cn'][0]);
					$ldap_error = 'Login OK';
				}
				@ldap_close($ldap);
			} 
			else {
				$ldap_error = 'Attention! Wrong password, please try again';
				@ldap_close($ldap);
				return $ldap_error;
			}
		} 
		else {
			$ldap_error = 'ldap connection';
		}
		return $ldap_error;
	}
	function exec_cmd2($var, $value) {
		$url = "https://puma-01.elettra.eu:8443/bu/xec-bundle";
		if (isset($_REQUEST['url'])) $url = $_REQUEST['url']; // "https://pwma-dev.elettra.eu/testcurl.php";
		session_start();
		$id = session_id();
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

		// curl_setopt($ch, CURLOPT_COOKIEJAR, '/tmp/cookies.txt');
		curl_setopt($ch, CURLOPT_COOKIEFILE, '');
		curl_setopt($ch, CURLOPT_COOKIE, "PHPSESSID=$id");

		// $fields = array("srcs"=>array(array("method"=>"write","src"=>$var)));
		// $fields = '{"srcs":[{"method":"write","src":"'.strtr($var, array('/'=>'\/')).'"}]}';
		$fields = '{"srcs":[{"method":"write","src":"'.$var.'"}]}';
		if (!empty($value) || $value===false) {
			// $fields = '{"srcs":[{"method":"write","src":"'.$var.'('.$value.')"}]}';
			$fields = json_encode(array("srcs"=>array(array("method"=>"write","src"=>$var, "cmd"=>$value))));
		}
		// curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
		curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
		if (isset($_REQUEST['debug'])) echo '<br>Cookie: PHPSESSID='.$id.'\n<br>POSTFIELDS: '.json_encode($fields)."<br><br>".'<!--example POSTFIELDS: {"srcs":[{"method":"write","src":"srv-tango-srf-01.fcs.elettra.trieste.it:20000/kg05/mod/timer_kg05.02->Stop"}]}\r\n\r\n-->';
		$err = '';
		$result = curl_exec($ch);
		if (isset($_REQUEST['debug'])) echo("<br>\nexec_cmd2(), result: ".json_encode($result)."<br>\n");
		if ($result === false) {
			$err = curl_error($ch); // .' - '.curl_strerror($errno);
		}
		curl_close($ch);
		return array($result, $err);
	}
	function exec_cmd($var, $value) {
		$url = "https://pwma.elettra.eu:10443/v1/cs/$var";

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		if (!empty($value) || $value===false) {
			$fields = array('value' => $value);
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
		}
		if (isset($_REQUEST['debug'])) echo ' - fields: '.json_encode($fields)."<br>\n";
		$err = '';
		$result = curl_exec($ch);
		if (isset($_REQUEST['debug'])) echo "<br>\nexec_cmd(), result: $result<br>\n";
		if ($result === false) {
			$err = curl_error($ch); // .' - '.curl_strerror($errno);
		}
		curl_close($ch);
		return array($result, $err);
	}
	$sql = open_db();	
	$cmdunrestricted = $sql->sql_secure("SELECT * FROM cmdunrestricted WHERE src=$1", array($_REQUEST['cmd']));
	if (isset($_REQUEST['debug'])) echo "SELECT * FROM cmdunrestricted WHERE src='{$_REQUEST['cmd']}';<br>".json_encode($cmdunrestricted);
	if (empty($cmdunrestricted)) {
		session_start();
		$username = '';
		if (isset($_SESSION['token'])) {
			$yy = date('Y');
			$webtokenExpirationSeconds = 36000; // 10 hh
			$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND EXTRACT(EPOCH FROM NOW()-date)<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
			if (!empty($data)) $username = $data[0]['username'];
		}

		if (empty($username)) {
			if (!function_exists('ldap_connect')) die(json_encode(array('error'=>"LDAP module not installed in PHP")));
			$username = $_SERVER['PHP_AUTH_USER'];
			$password = $_SERVER['PHP_AUTH_PW'];
			$r = ldap_auth($username, $password);
			if ($r != "Login OK") die(json_encode(array('error'=>"authentication failed")));
		}
	}
	$number_array_types = array(
		"DevVarShortArray",
        "DevVarLongArray",
        "DevVarFloatArray",
        "DevVarDoubleArray",
        "DevVarUShortArray",
        "DevVarULongArray"
	);

	if (in_array($_REQUEST['type'], $number_array_types) && strpos($_REQUEST['params'], ',')!==false) {
		$value = explode(',', $_REQUEST['params']);
		foreach ($value as $i=>$v) {
			if (is_numeric($v)) $value[$i] = $v-0;
		}
	}
	else if ($_REQUEST['type']=='DevBoolean') {
		$value = $_REQUEST['params']=='true'? true: false;
	}
	else {
		$value = is_numeric($_REQUEST['params'])? $_REQUEST['params']-0: $_REQUEST['params'];
	}
	$time = date('d/m/Y H:i:s');
	$var = $_REQUEST['cmd'];
	if (!empty($_REQUEST['cmd2'])) list($result, $err) = exec_cmd2($_REQUEST['cmd2'], $value);
	else {
		if (strpos($var,'tango://')===false) $var = 'tango://'.$var;
		list($result, $err) = exec_cmd($var, $value);
	}
	if ($result === false) {
		json_encode(array('result'=>"ERROR, curl_exec() returned: $err", 'time'=>$time, 'cmd'=>$_REQUEST['cmd'])); }
	else echo json_encode(array('result'=>$result, 'time'=>$time, 'cmd'=>$_REQUEST['cmd']));
	$yy = date('Y');
	if (empty($cmdunrestricted)) {
		$sql->sql_secure("INSERT INTO cmdlog_$yy (username, date, ip, cmd, param) VALUES ($1, NOW(), $2, $3, $4)", array($username, $_SERVER['REMOTE_ADDR'], $_REQUEST['cmd'], empty($_REQUEST['params'])? '': $_REQUEST['params']));
		$query = "INSERT INTO cmdlog_$yy (username, date, ip, cmd, param) VALUES ('$username', '$time', '{$_SERVER['REMOTE_ADDR']}', '{$_REQUEST['cmd']}', '{$_REQUEST['params']}');";
		$myfile = file_put_contents('cmd_log.sql', $query.PHP_EOL , FILE_APPEND | LOCK_EX);
	}



/*
	function exec_cmd($var, $value) {
		if (!empty($value)) $var .= '('.$value.')';
		$result = file_get_contents("/rchan.php?json&src=$var");
		return array($result);
	}
	require_once("./conf.php");
	$sql = open_db();	
	$cmdunrestricted = $sql->sql_secure("SELECT * FROM cmdunrestricted WHERE src=$1", array($_REQUEST['cmd']));
	if (isset($_REQUEST['debug'])) echo "SELECT * FROM cmdunrestricted WHERE src='{$_REQUEST['cmd']}';<br>".json_encode($cmdunrestricted);
	if (empty($cmdunrestricted)) {
		session_start();
		$username = '';
		if (isset($_SESSION['token'])) {
			$yy = date('Y');
			$webtokenExpirationSeconds = 36000; // 10 hh
			$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND EXTRACT(EPOCH FROM NOW()-date)<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
			if (!empty($data)) $username = $data[0]['username'];
		}

		if (empty($username)) {
			if (!function_exists('ldap_connect')) die(json_encode(array('error'=>"LDAP module not installed in PHP")));
			$username = $_SERVER['PHP_AUTH_USER'];
			$password = $_SERVER['PHP_AUTH_PW'];
			$r = ldap_auth($username, $password);
			if ($r != "Login OK") die(json_encode(array('error'=>"authentication failed")));
		}
	}
	$number_array_types = array(
		"DevVarShortArray",
        "DevVarLongArray",
        "DevVarFloatArray",
        "DevVarDoubleArray",
        "DevVarUShortArray",
        "DevVarULongArray"
	);

	if (in_array($_REQUEST['type'], $number_array_types) && strpos($_REQUEST['params'], ',')!==false) {
		$value = explode(',', $_REQUEST['params']);
		foreach ($value as $i=>$v) {
			if (is_numeric($v)) $value[$i] = $v-0;
		}
	}
	else if ($_REQUEST['type']=='DevBoolean') {
		$value = $_REQUEST['params']=='true'? true: false;
	}
	else {
		$value = is_numeric($_REQUEST['params'])? $_REQUEST['params']-0: $_REQUEST['params'];
	}
	$time = date('d/m/Y H:i:s');
	list($result, $err) = exec_cmd($_REQUEST['cmd'], $value);
	if ($result === false) {
		json_encode(array('result'=>"ERROR, curl_exec() returned: $err", 'time'=>$time, 'cmd'=>$_REQUEST['cmd'])); }
	else echo json_encode(array('result'=>$result, 'time'=>$time, 'cmd'=>$_REQUEST['cmd']));
	$yy = date('Y');
	if (empty($cmdunrestricted)) {
		$sql->sql_secure("INSERT INTO cmdlog_$yy (username, date, ip, cmd, param) VALUES ($1, NOW(), $2, $3, $4)", array($username, $_SERVER['REMOTE_ADDR'], $_REQUEST['cmd'], empty($_REQUEST['params'])? '': $_REQUEST['params']));
		$query = "INSERT INTO cmdlog_$yy (username, date, ip, cmd, param) VALUES ('$username', '$time', '{$_SERVER['REMOTE_ADDR']}', '{$_REQUEST['cmd']}', '{$_REQUEST['params']}');";
		$myfile = file_put_contents('cmd_log.sql', $query.PHP_EOL , FILE_APPEND | LOCK_EX);
	}
*/
?>
