var handleDropEvent;

initConf();

var designer = (function() {

	var editCmptSection = document.createElement("div");
	editCmptSection.className = "popover bottom";
	editCmptSection.style.display = "none";

	var editCmptSectionArrow = document.createElement("div");
	editCmptSection.appendChild(editCmptSectionArrow);

	var editCmptSectionContent = document.createElement("div");
	editCmptSectionContent.className = "popover-content";
	editCmptSection.appendChild(editCmptSectionContent);

	var editCmptSectionForm = document.createElement("form");
	editCmptSectionContent.appendChild(editCmptSectionForm);

	var editCmptSectionFields = document.createElement("div");
	editCmptSectionFields.id = "edit-cmpt-section-fields";
	editCmptSectionForm.appendChild(editCmptSectionFields);

	var editCmptSectionBtnContainer = document.createElement("div");
	editCmptSectionBtnContainer.className = "form-group";
	editCmptSectionForm.appendChild(editCmptSectionBtnContainer);

	var updateBtn = document.createElement("input");
	updateBtn.type = "button";
	updateBtn.className = "button success";
	updateBtn.value = "Update";

	editCmptSectionBtnContainer.appendChild(updateBtn);

	var closeBtn = document.createElement("input");
	closeBtn.type = "button";
	closeBtn.className = "button";
	closeBtn.value = "Close";
	closeBtn.onclick = closeEditCmptSection;

	editCmptSectionBtnContainer.appendChild(document.createTextNode(" "));
	editCmptSectionBtnContainer.appendChild(closeBtn);


	function updateCmptParams(cmpt, params) {

		var values = {};
		for(var i = 0; i < params.length; i++) {

			var param = params[i];
			if(param.cardinality == paramsCardinality.MANY) {

				values[param.key] = [];
				$("[id^=" + cmpt.getId() + "-" + param.key + "]").each(function(i, elm) {
					values[param.key].push(elm.value);
				});

			} else {

				var $elm = $("#" + cmpt.getId() + "-" + param.key);
				if($elm.length > 0) {

					var value = $elm.val();

					if(param.type == paramsTypes.SRC) {

						if(cmpt.category == categories.ARRAYS && value && cmpt.getSrc() != value) {
							var srcsValue = srcsMap[value.toLowerCase()].values; console.log(srcsValue);
							cmpt.initFlags(srcsValue && srcsValue.length > 0 ? srcsValue[0].value.length : []);    
						}

						subscribeSrc(cmpt, value);
						values[param.key] = value;

					} else if(param.type == paramsTypes.SCREEN) {

						var screenName = value, screenId = $("#" + cmpt.getId() + "-screen-id").val();

						if(!screenName || screenName.trim().length == 0) {//TODO modificare
							screenId = undefined;
						}

						if(screenId != cmpt.getScreenId()) {

							cmpt.reset();

							if(screenId) {
								$.ajax({
									url: screenLoader,
									method: "POST",
									data: {openScreenId: screenId},
									error: function(jqXHR, textStatus, errorThrown) {
										console.log("error", jqXHR, textStatus, errorThrown);
									},
									success: function(data, textStatus, jqXHR) {

										for(var i = 0; i < data.cmpts.length; i++) {
											var cmptDefinition = data.cmpts[i];
											cmpt.addChild(buildCmpt(cmptDefinition, cmpt, cmpt.getNestedGrid(), true));
										}
									}
								});
							}
						}

						values[param.key] = {name: screenName, id: screenId};

					} else {
						values[param.key] = value;
					}
				}
			}
		}

		cmpt.setEditParamsValues(values);
		closeEditCmptSection();
	}

	function closeEditCmptSection() {
		editCmptSection.style.display = "none";
	}

	function onMouseDownRemoveEditCmptSection(e) {

		var mouseX = e.originalEvent.clientX;
		var mouseY = e.originalEvent.clientY;

		var editCmptSectionX = editCmptSection.getBoundingClientRect().left;
		var editCmptSectionY = editCmptSection.getBoundingClientRect().top;

		var editCmptSectionWidth = editCmptSection.getBoundingClientRect().width;
		var editCmptSectionHeight = editCmptSection.getBoundingClientRect().height;

		if(!(editCmptSectionX <= mouseX && mouseX <= editCmptSectionX + editCmptSectionWidth && editCmptSectionY <= mouseY && mouseY <= editCmptSectionY + editCmptSectionHeight)) {
			$(".container-fluid").off("mousedown", onMouseDownRemoveEditCmptSection);
			closeEditCmptSection();
		}
	}

	var categories = {
		LAYOUT: "PwmaLayout", 
		SCREENS: "PwmaScreen", 
		CONTAINERS: "PwmaContainer", 
		CHARTS: "PwmaChart", 
		ARRAYS: "PwmaLedArray", 
		SCALARS: "PwmaScalar", 
		TEXT: "PwmaText"
	};

	var paramsTypes = {
		TEXT: "TEXT",
		SRC: "SRC",
		SCREEN: "SCREEN"
	};

	var paramsCardinality = {
		ONE: "ONE",
		MANY: "MANY"
	};

	var GRID_STACK_DRAGGABLE_OPTS = {helper: "original", containment: null, cursorAt: false, revert: false};
	var DESIGNER_DRAGGABLE_OPTS = {helper: draggableHelper, drag: drag, containment: $("div.container-fluid"), cursorAt: {left: 60, top: 50}, revert: "invalid"};

	var cmptsFactories = [];
	cmptsMapById = {}, srcsMap = {}; //TODO portarle dentro
	var widgetsMapByCmptsId = {}, placeholderWidget;

	var registerCmptFactory = function(cmptFactory) {
		cmptsFactories.push(cmptFactory);
	};

	var numericalSequence = (function() {
		var n = 0;
		return {next: function() {return n++;}};
	})();

	var baseCmpt = function(anId, aName, aGrid, aParent, anX, anY, aWidth, anHeight, readOnly) {

		var id = anId, cmptName = aName, grid = aGrid, parent = aParent, children = [];
		var x = anX, y = anY, width = aWidth, height = anHeight;

		var header = document.createElement("div");
		header.className = "cmpt-header";

		var headerName = document.createElement("span");
		headerName.className = "cmpt-header-text";
		headerName.appendChild(document.createTextNode(aName));
		header.appendChild(headerName);

		var removeCmptBtn = document.createElement("i");
		removeCmptBtn.className = "far fa-trash-alt";
		removeCmptBtn.onclick = function() { designer.removeCmpt(anId); };
		removeCmptBtn.style.display = readOnly ? "none" : "inline-block";
		header.appendChild(removeCmptBtn);

		var editCmptBtn = document.createElement("i");
		editCmptBtn.className = "fa fa-edit";
		editCmptBtn.onclick = function() { designer.editCmpt(anId); };
		editCmptBtn.style.display = readOnly ? "none" : "inline-block";
		header.appendChild(editCmptBtn);

		return {
			setId: function(anId) { id = anId; },
			getId: function() { return id; },

			setCmptName: function(aName) { cmptName = aName; headerName.innerHTML = aName; },
			getCmptName: function() { return cmptName; },

			setGrid: function(aGrid) { grid = aGrid; },
			getGrid: function() { return grid; },

			setParent: function(aParent) { parent = aParent; },
			getParent: function() { return parent; },

			addChild: function(child) { children.push(child); },
			getChildren: function() { return children; },

			setX: function(anX) { x = anX; },
			getX: function() { return x; },

			setY: function(anY) { y = anY; },
			getY: function() { return y; },

			setWidth: function(aWidth) { width = aWidth; },
			getWidth: function() { return width; },

			setHeight: function(anHeight) { height = anHeight; },
			getHeight: function() { return height; },

			setReadOnly: function(readOnly) { 
				removeCmptBtn.style.display = readOnly ? "none" : "inline-block"; 
				editCmptBtn.style.display = readOnly ? "none" : "inline-block";
			},

			getHeader: function() { return header; },
			addBtnHeader: function(btn) { header.appendChild(btn); },

			getBaseEditParamsDefinition: function() { return [{key: "name", type: designer.paramsTypes.TEXT, label: "Name", value: cmptName}] },
			setBaseEditParamsValues: function(values) {
				this.setCmptName(values["name"]);
			},

			basePropsToObject: function() {
				return {
					label: cmptName, x: x, y: y, width: width, height: height
				}; 
			}
		};
	};

	var containerCmpt = function(id, name, grid, parent, x, y, width, height, readOnly) {

		var nestedGrid;

		return Object.assign({
			setNestedGrid: function(aNestedGrid) { nestedGrid = aNestedGrid; },
			getNestedGrid: function() { return nestedGrid; }
		}, baseCmpt(id, name, grid, parent, x, y, width, height, readOnly));
	};

	var statusCmpt = function(id, name, grid, parent, x, y, width, height, readOnly) {

		var src;

		return Object.assign({
			setSrc: function(aSrc) { src = aSrc; if(!aSrc) { this.reset(); } },
			getSrc: function() { return src; },

			getStatusEditParamsDefinition: function() { return [{key: "src", type: designer.paramsTypes.SRC, label: "Source", value: src}] },
			setStatusEditParamsValues: function(values) {
				this.setSrc(values["src"]);
			},

			statusPropsToObject: function() {
				return {
					src: src
				}; 
			}
		}, baseCmpt(id, name, grid, parent, x, y, width, height, readOnly));
	};

	attachDragAndResizeListeners = function($grid) {

		$grid.on('change', function(event, items) {

			//it could happen when resetting screeens
			if(!items) {
				return;  
			}

			for(var i = 0; i < items.length; i++) {

				//it could happen due to placeholderWidget
				if(!items[i].id) {
					return;  
				}

				var item = items[i], cmpt = cmptsMapById[item.id];
				cmpt.setX(item.x);
				cmpt.setY(item.y);
				cmpt.setWidth(item.width);
				cmpt.setHeight(item.height);
			}
		});
	};

	function draggableHelper(e) {

		placeholderWidget = null;

		var helper = document.createElement("div");
		helper.className = "drag-helper";

		var cmptIcon = document.createElement("i");
		cmptIcon.className = this.cmptFactory.CSSIconClass;

		var cmptName = document.createElement("div");
		cmptName.appendChild(document.createTextNode(this.cmptFactory.defaults.name.toUpperCase()));

		helper.appendChild(cmptIcon);
		helper.appendChild(cmptName);

		document.body.appendChild(helper);
		return helper;
	}

	function drag(event, ui) {

		var grid = activeScreen.currentGrid, $currentDropArea = activeScreen.$currentDropArea;

		var $currentDropAreaParent = $currentDropArea.parent();
		var dropAreaHeight = $currentDropAreaParent.height() - ($currentDropArea.offset().top - $currentDropAreaParent.offset().top);
		var dropAreaWidth = $currentDropArea.width();

		if(!($currentDropArea.offset().left <= event.clientX && event.clientX <= $currentDropArea.offset().left + dropAreaWidth &&
			 $currentDropArea.offset().top <= event.clientY && event.clientY <= $currentDropArea.offset().top + dropAreaHeight)) {

			if(placeholderWidget) {
				grid.removeWidget(placeholderWidget);
				placeholderWidget = null;
			}

			return;
		}

		var helperLeftRelativeToGrid = ui.offset.left - grid.container.offset().left;
		var helperTopRelativeToGrid = ui.offset.top - grid.container.offset().top;

		var col = Math.trunc(helperLeftRelativeToGrid / (grid.container.width() * 8.3/100))
		var row = Math.trunc(helperTopRelativeToGrid / (grid.cellHeight() + grid.verticalMargin()));

		if(!placeholderWidget) {

			placeholderWidget = $(
				"<div class='grid-stack-item' data-gs-width='" + this.cmptFactory.defaults.width + "' " +
				"                             data-gs-height='" + this.cmptFactory.defaults.height + "'>" +
				"  <div class='grid-stack-item-content' style='border: thin dashed #d3d3d3;'></div>" +
				"</div>");

			grid.addWidget(placeholderWidget, col, row);

		} else {
			grid.update(placeholderWidget, col, row, null, null, true); //il parametro true è una mia modifica alla libreria
		}

		//TODO sembra inutile, controllare
		//activeScreen.tab.content.grid.container.css({height: $(activeScreen.tab.content).height()});
	}

	handleDropEvent = function(event, ui) {

		if(!placeholderWidget) return;

		var cmpt, x = parseInt(placeholderWidget.attr("data-gs-x")), y = parseInt(placeholderWidget.attr("data-gs-y"));

		if(ui.draggable.hasClass("grid-stack-item")) {

			var $gridStackItem = ui.draggable;
			var cmpt = cmptsMapById[$gridStackItem.get(0).id]; 

			cmpt.setX(x); 
			cmpt.setY(y);

			var freshCmpt = buildCmpt(cmpt.propsToObject(), activeScreen.currentGrid.hostCmpt, activeScreen.currentGrid);

			removeCmpt(cmpt.getId());

			console.log(freshCmpt);

			if(activeScreen.currentGrid.hostCmpt) {
				activeScreen.currentGrid.hostCmpt.addChild(freshCmpt);
			} else {
				activeScreen.cmpts.push(freshCmpt);
			}

		} else {

			var cmptFactory = ui.draggable.get(0).cmptFactory;
			var cmptId = "cmpt-" + numericalSequence.next();
			var cmptParent = activeScreen.currentGrid != activeScreen.tab.content.grid ? activeScreen.currentGrid.hostCmpt : null;

			cmpt = cmptFactory.createCmpt(cmptId, activeScreen.currentGrid, cmptParent, x, y);
			cmptsMapById[cmptId] = cmpt;

			if(cmptParent) {
				cmptParent.addChild(cmpt);
			} else {
				activeScreen.cmpts.push(cmpt);
			}

			var gridStackItem = document.createElement("div");
			gridStackItem.id = cmptId;
			gridStackItem.cmptFactory = cmptFactory;
			gridStackItem.className = "grid-stack-item cmpt";
			gridStackItem.setAttribute("data-gs-id", cmptId);
			gridStackItem.setAttribute("data-gs-width", cmptFactory.defaults.width);
			gridStackItem.setAttribute("data-gs-height", cmptFactory.defaults.height);

			var gridStackItemContent = document.createElement("div");
			gridStackItemContent.className = "grid-stack-item-content named-grid-stack-item-content";
			gridStackItemContent.appendChild(cmpt.getView());

			if(cmptFactory.category == categories.CONTAINERS || cmptFactory.category == categories.SCREENS) {

				var innerGridStack = document.createElement("div");
				innerGridStack.id = "grid-stack-" + cmptId;
				innerGridStack.className = "grid-stack";

				gridStackItemContent.appendChild(innerGridStack);

				var $innerGridStack = $(innerGridStack);
				var nestedGrid = $innerGridStack.gridstack({
					float: true,
					resizable: {
						handles: 'e, se, s, sw, w'
					}
				}).data('gridstack');

				attachDragAndResizeListeners($innerGridStack);

				nestedGrid.zIndex = numericalSequence.next();
				cmpt.setNestedGrid(nestedGrid);

				nestedGrid.hostCmpt = cmpt;
			}

			gridStackItem.appendChild(gridStackItemContent);

			widgetsMapByCmptsId[cmptId] = activeScreen.currentGrid.addWidget(gridStackItem, cmpt.getX(), cmpt.getY());
			widgetsMapByCmptsId[cmptId].data("_gridstack_node")._origY = cmpt.getY(); //questa è una mia modifica alla libreria
		}

		activeScreen.currentGrid.removeWidget(placeholderWidget);
		placeholderWidget = null;

		activeScreen.isChanged = true;
	}

	function editCmpt(cmptId) {

		var cmpt = cmptsMapById[cmptId], params = cmpt.getEditParamsDefinition();

		$(document.body).append(fancyTreeContainer.hide().detach());
		$("#tree").fancytree("getTree").reload(); 

		editCmptSectionFields.innerHTML = "";

		for(var i = 0; i < params.length; i++) {

			var param = params[i];
			if(param.type == paramsTypes.TEXT) {

				if(param.cardinality == paramsCardinality.MANY) {

					var flagsContainer = document.createElement("div");
					flagsContainer.id = "flags-container";
					flagsContainer.style.height = "200px";
					flagsContainer.style.overflowY = "auto";
					flagsContainer.style.display = param.value.length ? "block" : "none";

					editCmptSectionFields.appendChild(flagsContainer);

					for(var j = 0; j < param.value.length; j++) { 

						var flagContainer = document.createElement("div");
						flagContainer.className = "form-group";

						var flagLabel = document.createElement("label");
						flagLabel.appendChild(document.createTextNode(param.label + "-" + j));
						flagContainer.appendChild(flagLabel);

						var flagInput = document.createElement("input");
						flagInput.id = cmptId + "-" + param.key + "-" + j;
						flagInput.type = "text";
						flagInput.value = param.value[j] ? param.value[j] : "";
						flagContainer.appendChild(flagInput);

						flagsContainer.appendChild(flagContainer);
					}

				} else {

					var nameContainer = document.createElement("div");
					nameContainer.className = "form-group";

					var nameLabel = document.createElement("label");
					nameLabel.appendChild(document.createTextNode(param.label));
					nameContainer.appendChild(nameLabel);

					var nameInput = document.createElement("input");
					nameInput.id = cmptId + "-" + param.key;
					nameInput.type = "text";
					nameInput.value = param.value ? param.value : "";

					if(param.CSSClass) {
						var rowDiv = document.createElement("div");
						rowDiv.className = "row";

						var cellDiv = document.createElement("div");
						cellDiv.className = param.CSSClass;

						cellDiv.appendChild(nameInput);
						rowDiv.appendChild(cellDiv);

						nameContainer.appendChild(rowDiv);

					} else {
						nameContainer.appendChild(nameInput);
					}

					editCmptSectionFields.appendChild(nameContainer);
				}





			} else if(param.type == paramsTypes.SRC) {

				var srcContainer = document.createElement("div");
				srcContainer.className = "form-group";

				var nameLabel = document.createElement("label");
				nameLabel.appendChild(document.createTextNode(param.label));
				srcContainer.appendChild(nameLabel);

				var srcInput = document.createElement("input");
				srcInput.id = cmptId + "-" + param.key;
				srcInput.type = "text";
				srcInput.value = param.value ? param.value : "";

				srcInput.setAttribute("data-role", "input");
				srcInput.setAttribute("data-search-button", "true");
				srcInput.setAttribute("data-search-button-click", "custom");
				srcInput.setAttribute("data-on-search-button-click", "searchForSource");

				srcContainer.appendChild(srcInput);
				srcContainer.appendChild(fancyTreeContainer.get(0));

				for(var j = 0; j < eventListeners.length; j++) {

					var eventListener = eventListeners[j];

					if(srcInput.addEventListener) {
						srcInput.addEventListener(eventListener.evName, function(e) { eventListener.evFunction(e, cmpt); });
					} else {
						srcInput.attachEvent("on" + eventListener.evName, function(e) { eventListener.evFunction(e, cmpt); });
					}
				}

				editCmptSectionFields.appendChild(srcContainer);

			} else if(param.type == paramsTypes.SCREEN) {

				var srcContainer = document.createElement("div");
				srcContainer.className = "form-group";

				var nameLabel = document.createElement("label");
				nameLabel.appendChild(document.createTextNode(param.label));
				srcContainer.appendChild(nameLabel);

				var srcInput = document.createElement("input");
				srcInput.id = cmptId + "-" + param.key;
				srcInput.type = "text";
				srcInput.value = param.value.name ? param.value.name : "";

				srcInput.setAttribute("data-role", "input");
				srcInput.setAttribute("data-search-button", "true");
				srcInput.setAttribute("data-search-button-click", "custom");
				srcInput.setAttribute("data-on-search-button-click", "searchForScreen");
				srcInput.setAttribute("data-search-button-icon", "<span class='fi fi-folder'></span>");

				srcContainer.appendChild(srcInput);
				srcContainer.appendChild(screensTreeContainer.get(0));

				editCmptSectionFields.appendChild(srcContainer);

				var screenIdElm = document.createElement("input");
				screenIdElm.id = cmptId + "-screen-id";
				screenIdElm.type = "hidden";
				screenIdElm.value = param.value.id ? param.value.id : "";
				srcContainer.appendChild(screenIdElm);

				editCmptSectionFields.appendChild(srcContainer);
			}
		}

		if(cmpt.category == categories.CHARTS || cmpt.category == categories.SCALARS) {
			filter = "scalar";
		} else if(cmpt.category == categories.ARRAYS) {
			filter = "boolarray";
		} else if(cmpt.category == categories.TEXT) {
			filter = "text";
		}

		updateBtn.onclick = function() { updateCmptParams(cmpt, params); };

		var editElm = $("#" + cmptId + " .fa.fa-edit").get(0);
		var editElmBottom = editElm.getBoundingClientRect().bottom;
		var editElmWidth = editElm.getBoundingClientRect().width;

		editCmptSectionArrow.className = "arrow-top-left";

		editCmptSection.style = {};
		editCmptSection.style.top = (editElmBottom + 10) + "px";
		editCmptSection.style.left = (editElm.getBoundingClientRect().left - 19 /*25 - magic number*/) + "px";  //left: (event.clientX - 27) + "px"});

		var editCmptSectionRight = editCmptSection.getBoundingClientRect().left;
		var editCmptSectionBottom = editCmptSection.getBoundingClientRect().bottom;

		var $tabsContent = $("#tabs-content");
		var tabsContentRight = $tabsContent.get(0).getBoundingClientRect().right;
		var tabsContentBottom = $tabsContent.get(0).getBoundingClientRect().bottom;

		var overflowRight = false;  var $editCmptSection = $(editCmptSection);

		if(event.clientX - 27 + parseInt($editCmptSection.css("width")) > tabsContentRight) {
			editCmptSection.style.left = "auto" /*(editElm.getBoundingClientRect().right - $editCmptSection.outerWidth()) + "px"*/;
			editCmptSection.style.right = (window.innerWidth - editElm.getBoundingClientRect().right - 16 /* 16 è lunghezza freccia/2 */) + "px";
			editCmptSectionArrow.className = "arrow-top-right";
			overflowRight = true;
		}

		if(editElmBottom + 10 + parseInt($editCmptSection.css("height")) + 200 > tabsContentBottom) {
			editCmptSection.style.top = (editElm.getBoundingClientRect().top - 10 - parseInt($editCmptSection.css("height"))) + "px";
			editCmptSectionArrow.className = overflowRight ? "arrow-bottom-right" : "arrow-bottom-left";
		}

		editCmptSection.style.display = "block";

		$(".container-fluid").on("mousedown", onMouseDownRemoveEditCmptSection);
	}

	function removeCmpt(cmptId) {

		var cmpt = cmptsMapById[cmptId];

		if(cmpt.getChildren()) {
			while(cmpt.getChildren().length > 0) {
				removeCmpt(cmpt.getChildren()[0].getId());
			}
		}

		cmpt.getGrid().removeWidget(widgetsMapByCmptsId[cmptId]);

		if(cmpt.getSrc && cmpt.getSrc()) {
			var cmptsWithSameSrc = srcsMap[cmpt.getSrc().toLowerCase()].cmpts;
			var cmptIndex = cmptsWithSameSrc.indexOf(cmpt);
			cmptsWithSameSrc.splice(cmptIndex, 1);

			if(cmptsWithSameSrc.length == 0) {
				unsubscribeVar(cmpt.getSrc());
				delete srcsMap[cmpt.getSrc()];
			}
		}
		/*
		if(cmpt.chart) {
		  cmpt.chart.destroy();
		}*/

		var parent = cmpt.getParent();
		if(parent) {
			parent.getChildren().splice(parent.getChildren().indexOf(cmpt), 1);
		} else {
			for(var i = 0; i < screens.length; i++) {
				var cmptIndex = screens[i].cmpts.indexOf(cmpt); 
				if(cmptIndex != -1) {
					screens[i].cmpts.splice(cmptIndex, 1);
					break;
				}
			}
		}

		delete widgetsMapByCmptsId[cmptId];
		delete cmptsMapById[cmptId];
	}

	function buildCmpt(cmptDefinition, parent, grid, readOnly) {

		var cmpt, cmptFactory;
		for(var i = 0; i < cmptsFactories.length; i++) {
			if(cmptDefinition.component == cmptsFactories[i].category) {

				var cmptFactory = cmptsFactories[i];

				var cmptId = "cmpt-" + numericalSequence.next();
				cmpt = cmptFactory.createCmptFromDefinition(cmptId, grid, parent, cmptDefinition, readOnly);
				break;
			}
		}

		cmptsMapById[cmptId] = cmpt;

		var gridStackItem = document.createElement("div");
		gridStackItem.id = cmpt.getId();
		gridStackItem.cmptFactory = cmptFactory;
		gridStackItem.className = "grid-stack-item cmpt";
		gridStackItem.setAttribute("data-gs-id", cmpt.getId());
		gridStackItem.setAttribute("data-gs-width", cmpt.getWidth());
		gridStackItem.setAttribute("data-gs-height", cmpt.getHeight());

		var gridStackItemContent = document.createElement("div");
		gridStackItemContent.className = "grid-stack-item-content named-grid-stack-item-content";
		gridStackItemContent.appendChild(cmpt.getView());

		if(cmptFactory.category == categories.CONTAINERS || cmptFactory.category == categories.SCREENS) {

			var innerGridStack = document.createElement("div");
			innerGridStack.id = "grid-stack-" + cmpt.getId();
			innerGridStack.className = "grid-stack";

			gridStackItemContent.appendChild(innerGridStack);

			var $innerGridStack = $(innerGridStack);
			var nestedGrid = $innerGridStack.gridstack({
				float: true,
				resizable: {
					handles: 'e, se, s, sw, w'
				},
				disableDrag: readOnly || cmptFactory.category == categories.SCREENS,
				disableResize: readOnly || cmptFactory.category == categories.SCREENS
			}).data('gridstack');

			attachDragAndResizeListeners($innerGridStack);

			nestedGrid.zIndex = numericalSequence.next();
			cmpt.setNestedGrid(nestedGrid);

			nestedGrid.hostCmpt = cmpt;

			if(cmptFactory.category == categories.SCREENS) {

				$.ajax({
					url: screenLoader,
					method: "POST",
					data: {openScreenId: cmpt.getScreenId()},
					error: function(jqXHR, textStatus, errorThrown) {
						console.log("error", jqXHR, textStatus, errorThrown);
					},
					success: function(data, textStatus, jqXHR) {

						for(var i = 0; i < data.cmpts.length; i++) {
							var cmptDefinition = data.cmpts[i];
							cmpt.addChild(buildCmpt(cmptDefinition, cmpt, nestedGrid, true));
						}
					}
				});
			}
		}

		gridStackItem.appendChild(gridStackItemContent);

		widgetsMapByCmptsId[cmpt.getId()] = grid.addWidget(gridStackItem, cmpt.getX(), cmpt.getY());
		widgetsMapByCmptsId[cmpt.getId()].data("_gridstack_node")._origY = cmpt.getY(); //questa è una mia modifica alla libreria

		if(readOnly) {
			grid.resizable(widgetsMapByCmptsId[cmpt.getId()], false);
			grid.dd.draggable(widgetsMapByCmptsId[cmpt.getId()], "disable");
			gridStackItem.originalDrag = widgetsMapByCmptsId[cmpt.getId()].draggable("option", "drag");
		}

		if(cmptDefinition.children) {
			for(var i = 0; i < cmptDefinition.children.length; i++) {
				var childCmpt = buildCmpt(cmptDefinition.children[i], cmpt, cmpt.getNestedGrid(), readOnly);
				cmpt.addChild(childCmpt);
			}
		}

		if([categories.CHARTS, categories.ARRAYS, categories.SCALARS, categories.TEXT].indexOf(cmpt.category) != -1) {
			var cmptSrc = cmpt.getSrc(); cmpt.setSrc("myFunnySrc");
			subscribeSrc(cmpt, cmptSrc);
			cmpt.setSrc(cmptSrc);
		}

		return cmpt;
	}

	function buildScreen(cmptsDefinitions, readOnly) {

		for(var i = 0; i < cmptsDefinitions.length; i++) {

			var cmptDefinition = cmptsDefinitions[i];
			var cmpt = buildCmpt(cmptDefinition, null, activeScreen.tab.content.grid, readOnly);

			activeScreen.cmpts.push(cmpt);
		}
	}

	var toggleDropArea = function(cmptId) {

		activeScreen.$currentDropArea.droppable("destroy");

		var cmpt = cmptsMapById[cmptId];
		var setCSSClassDropDisabledOnContainers = function(cmpts) {

			for(var i = 0; i < cmpts.length; i++) {

				var cmpt = cmpts[i];
				if(cmpt.getChildren() && cmpt.getChildren().length > 0) {
					setCSSClassDropDisabledOnContainers(cmpt.getChildren());
				}

				var cmptWidget = widgetsMapByCmptsId[cmpt.getId()];
				if(cmpt.getId() == cmptId) {

					cmpt.setDroppable(!cmpt.isDroppable());

					var $gridStackItemContent = $("> .grid-stack-item-content", cmptWidget).removeClass("droppable-disabled droppable-enabled")
					.addClass(cmpt.isDroppable() ? "droppable-enabled" : "droppable-disabled");
					$("#tabs-content").css({backgroundColor: cmpt.isDroppable() ? "#fffff5" : "#ffffe0"});
					activeScreen.tab.header.style.backgroundColor = cmpt.isDroppable() ? "#fffff5" : "#ffffe0";

					activeScreen.currentGrid = cmpt.isDroppable() ? cmpt.getNestedGrid() : activeScreen.tab.content.grid;
					activeScreen.$currentDropArea = $("> .grid-stack", cmpt.isDroppable() ? $gridStackItemContent : activeScreen.tab.content).droppable({
						drop: handleDropEvent
					});


				} else if(cmpt.category == categories.CONTAINERS && cmpt.getId() != cmptId) {

					$("> .grid-stack-item-content", cmptWidget).removeClass("droppable-enabled").addClass("droppable-disabled");
					cmpt.setDroppable(false);
				}
			}
		};

		setCSSClassDropDisabledOnContainers(activeScreen.cmpts);

		var setDraggableHelper = function(cmpts) {

			for(var i = 0; i < cmpts.length; i++) {

				var cmpt = cmpts[i];
				if(cmpt.getChildren() && cmpt.getChildren().length > 0) {
					setDraggableHelper(cmpt.getChildren());
				}

				if(cmpt.category == categories.CONTAINERS) {
					$(cmpt.getNestedGrid().container.children('.' + cmpt.getNestedGrid().opts.itemClass).each(function(index, el) {
						var $el = $(el);
						if(!el.originalDrag) {
							el.originalDrag = $el.draggable("option", "drag");
						}

						if(cmpt.getId() == cmptId) {
							cmpt.getNestedGrid().dd.draggable($el, "enable");
							if(cmpt.isDroppable()) {
								$el.draggable("option", $.extend({}, GRID_STACK_DRAGGABLE_OPTS, {drag: el.originalDrag}));
								cmptsMapById[el.id].setReadOnly(false);
								cmpt.getNestedGrid().resizable($el, true);
							} else {
								$el.draggable("option", DESIGNER_DRAGGABLE_OPTS);
								cmptsMapById[el.id].setReadOnly(true);
								cmpt.getNestedGrid().resizable($el, false);
							}
							return;
						}

						if(el.id == cmptId && cmpt.isDroppable()) {
							cmpt.getNestedGrid().dd.draggable($el, "disable");
							cmpt.getNestedGrid().resizable($el, true);
							cmptsMapById[el.id].setReadOnly(false);
						} else {
							cmpt.getNestedGrid().dd.draggable($el, "enable");
							$el.draggable("option", activeScreen.currentGrid == cmpt.getNestedGrid() ? $.extend({}, GRID_STACK_DRAGGABLE_OPTS, {drag: el.originalDrag}) : DESIGNER_DRAGGABLE_OPTS);
							cmpt.getNestedGrid().resizable($el, false);
							cmptsMapById[el.id].setReadOnly(true);
						}
					}));
				}
			}
		};

		setDraggableHelper(activeScreen.cmpts);

		var grid = activeScreen.tab.content.grid;
		$(grid.container.children('.' + grid.opts.itemClass).each(function(index, el) {
			var $el = $(el);
			if(!el.originalDrag) {
				el.originalDrag = $el.draggable("option", "drag");
			}
			if(el.id == cmptId && cmpt.isDroppable()) {
				grid.dd.draggable($el, "disable");
				grid.resizable($el, true);
				cmptsMapById[el.id].setReadOnly(false);
			} else {
				grid.dd.draggable($el, "enable");
				$el.draggable("option", activeScreen.currentGrid == grid ? $.extend({}, GRID_STACK_DRAGGABLE_OPTS, {drag: el.originalDrag}) : DESIGNER_DRAGGABLE_OPTS);
				grid.resizable($el, activeScreen.currentGrid == grid);
				cmptsMapById[el.id].setReadOnly(activeScreen.currentGrid != grid);
			}
		}));
	};

	var getActiveScreenCmptsPropsToObject = function() {

		var activeScreenCmptsPropsToObject = [];
		for(var i = 0; i < activeScreen.cmpts.length; i++) {
			activeScreenCmptsPropsToObject.push(activeScreen.cmpts[i].propsToObject());
		}

		return activeScreenCmptsPropsToObject;    
	};

	var tmpXXX = function() {
		return activeScreen;
	};
	
	var init = function() {

		var componentsList = document.getElementById("components-list");
		for(var i = 0; i < cmptsFactories.length; i++) {

			var cmptFactory = cmptsFactories[i];

			var cmptNode = document.createElement("li");
			cmptNode.className = "drag";
			cmptNode.cmptFactory = cmptFactory;

			var a = document.createElement("a"); //TODO eliminare questo link
			a.href = "#";

			var iconSpan = document.createElement("span");
			iconSpan.className = cmptFactory.CSSIconClass + " icon";

			var titleSpan = document.createElement("span");
			titleSpan.className = "title";
			titleSpan.appendChild(document.createTextNode(cmptFactory.defaults.name));

			a.appendChild(iconSpan);
			a.appendChild(titleSpan);

			cmptNode.appendChild(a);

			componentsList.append(cmptNode);
		}

		$('#components-list li.drag').draggable({
			helper: draggableHelper,
			drag: drag,
			containment: $(document.body),
			cursorAt: {left: 80, top: 50},
			revert: "invalid"
		});

		document.body.appendChild(editCmptSection);

		$tabsHeader = $("#tabs-header"), $tabsContent = $("#tabs-content");
		activeScreen = createScreen(undefined, true, undefined);
	};

	return {
		categories: categories,
		paramsTypes: paramsTypes,
		paramsCardinality: paramsCardinality,
		registerCmptFactory: registerCmptFactory,
		numericalSequence: numericalSequence,
		baseCmpt: baseCmpt,
		containerCmpt: containerCmpt,
		statusCmpt: statusCmpt,
		editCmpt: editCmpt,
		removeCmpt: removeCmpt,
		buildScreen: buildScreen,
		toggleDropArea: toggleDropArea,
		getActiveScreenCmptsPropsToObject: getActiveScreenCmptsPropsToObject,
		tmpXXX: tmpXXX,
		init: init
	};

})();








/**************************************************
 *
 *                      SCREEN
 *
 **************************************************/
var Screen = {
	CSSIconClass: "fi fi-checkbox-passive",
	category: designer.categories.SCREENS,
	defaults: {
		name: "screen",
		width: 6,
		height: 8
	},

	createCmpt: function(id, grid, parent, x, y) {

		var screenId, screenName;

		var getEditParamsDefinition = function() {
			return this.getBaseEditParamsDefinition()
				.concat([{key: "screen", type: designer.paramsTypes.SCREEN, label: "Screen", value: {id: screenId, name: screenName}}]);
		};

		var setEditParamsValues = function(params) {
			this.setBaseEditParamsValues(params);
			this.setScreenId(params["screen"]["id"]);
			screenName = params["screen"]["name"];
		};

		var propsToObject = function() {
			return Object.assign({component: this.category, screenId: screenId, screenName: screenName}, this.basePropsToObject());
		};

		var reset = function() {

			var children = this.getChildren();
			while(children.length > 0) {
				designer.removeCmpt(children[0].getId());
			}
		};

		var getView = function() {
			return this.getHeader();
		};

		return Object.assign({
			setScreenId: function(aScreenId) { screenId = aScreenId; if(!aScreenId) { this.reset(); } },
			getScreenId: function() { return screenId; },
			setScreenName: function(aScreenName) { screenName = aScreenName; },
			getScreenName: function() { return screenName; },
			category: this.category,
			getEditParamsDefinition: getEditParamsDefinition,
			setEditParamsValues: setEditParamsValues,
			propsToObject: propsToObject,
			reset: reset,
			getView: getView
		},
							 designer.containerCmpt(id, this.defaults.name, grid, parent, x, y, this.defaults.width, this.defaults.height)
							);
	},
	createCmptFromDefinition: function(id, grid, parent, definition) {

		var name = definition.label;
		var x = parseInt(definition.x), y = parseInt(definition.y);
		var width = parseInt(definition.width), height = parseInt(definition.height);

		var cmpt = this.createCmpt(id, grid, parent, x, y);
		cmpt.setCmptName(name);
		cmpt.setWidth(width);
		cmpt.setHeight(height);

		cmpt.setScreenId(definition.screenId);
		cmpt.setScreenName(definition.screenName);

		return cmpt;
	}
};

designer.registerCmptFactory(Screen);




/**************************************************
 *
 *                      CONTAINER
 *
 **************************************************/
var Container = {
	CSSIconClass: "fi fi-codepen",
	category: designer.categories.CONTAINERS,
	defaults: {
		name: "container",
		width: 6,
		height: 6
	},

	createCmpt: function(id, grid, parent, x, y, readOnly) {

		var droppable;

		var getEditParamsDefinition = function() {
			return this.getBaseEditParamsDefinition();
		};

		var setEditParamsValues = function(params) {
			this.setBaseEditParamsValues(params);
		};

		var propsToObject = function() {

			var childrenPropsToObject = [], children = this.getChildren();
			for(var i = 0; i < children.length; i++) {
				childrenPropsToObject.push(children[i].propsToObject());
			}

			return Object.assign({component: this.category, children: childrenPropsToObject}, this.basePropsToObject());
		};

		var enableDropBtn = document.createElement("i");
		enableDropBtn.className = "icon-pin-outline";
		enableDropBtn.style.float = "right";
		enableDropBtn.style.margin = "0 6px 0 0";
		enableDropBtn.onclick = function() { designer.toggleDropArea(id); };

		var getView = function() {
			return this.getHeader();
		};

		var cmpt = Object.assign({
			isDroppable: function() { return droppable; },
			setDroppable: function(isDroppable) {

				droppable = isDroppable;

				enableDropBtn.className = isDroppable ? "icon-pin" : "icon-pin-outline"; 
				enableDropBtn.style.transform = isDroppable ? "rotate(-45deg)" : "";

			},
			category: this.category,
			getEditParamsDefinition: getEditParamsDefinition,
			setEditParamsValues: setEditParamsValues,
			propsToObject: propsToObject,
			getView: getView
		}, 
								 designer.containerCmpt(id, this.defaults.name, grid, parent, x, y, this.defaults.width, this.defaults.height, readOnly)
								);

		if(!readOnly) {
			cmpt.addBtnHeader(enableDropBtn);
		}

		return cmpt;
	},
	createCmptFromDefinition: function(id, grid, parent, definition, readOnly) {

		var name = definition.label;
		var x = parseInt(definition.x), y = parseInt(definition.y);
		var width = parseInt(definition.width), height = parseInt(definition.height);

		var cmpt = this.createCmpt(id, grid, parent, x, y, readOnly);
		cmpt.setCmptName(name);
		cmpt.setWidth(width);
		cmpt.setHeight(height);

		return cmpt;
	}
};

designer.registerCmptFactory(Container);




/**************************************************
 *
 *                      CHART
 *
 **************************************************/
var Charta = {
	CSSIconClass: "fi fi-line-chart",
	category: designer.categories.CHARTS,
	defaults: {
		name: "line chart",
		width: 12,
		height: 6
	},

	createCmpt: function(id, grid, parent, x, y, readOnly) {

		var getEditParamsDefinition = function() {
			return this.getBaseEditParamsDefinition().concat(this.getStatusEditParamsDefinition());
		};

		var setEditParamsValues = function(params) {
			this.setBaseEditParamsValues(params);
			this.setStatusEditParamsValues(params);
		};

		var propsToObject = function() {
			return Object.assign({component: this.category}, this.basePropsToObject(), this.statusPropsToObject());
		};

		var update = function(value, label) {

			if(!canvas) {

				canvas = document.createElement("canvas");
				canvas.style.width = "100%";
				canvas.style.height = "300px";

				graphContainer.appendChild(canvas);
				chart = createChart(canvas);
			}

			chart.data.labels.push(label || moment().format("HH:mm"));
			chart.data.datasets.forEach((dataset) => {
				dataset.data.push(value);
			});
			chart.chart.update();
		};

		var reset = function() {

			graphContainer.innerHTML = "";
			canvas = null;
		};

		var canvas, chart;
		var graphContainer = document.createElement("div");

		var getView = function() {

			var view = document.createElement("div");
			view.appendChild(this.getHeader());
			view.appendChild(graphContainer);

			return view;
		};

		return Object.assign({
			category: this.category,
			getEditParamsDefinition: getEditParamsDefinition,
			setEditParamsValues: setEditParamsValues,
			propsToObject: propsToObject,
			propsToObject: propsToObject,
			getView: getView,
			update: update,
			reset: reset
		}, 
							 designer.statusCmpt(id, this.defaults.name, grid, parent, x, y, this.defaults.width, this.defaults.height, readOnly)
							);
	},
	createCmptFromDefinition: function(id, grid, parent, definition, readOnly) {

		var name = definition.label;
		var x = parseInt(definition.x), y = parseInt(definition.y);
		var width = parseInt(definition.width), height = parseInt(definition.height);

		var cmpt = this.createCmpt(id, grid, parent, x, y, readOnly);
		cmpt.setCmptName(name);
		cmpt.setWidth(width);
		cmpt.setHeight(height);
		cmpt.setSrc(definition.src);

		mu = definition.mu;

		return cmpt;
	}
};

designer.registerCmptFactory(Charta);




/**************************************************
 *
 *                      LED ARRAY
 *
 **************************************************/
var LedArray = {
	CSSIconClass: "fi fi-nav-icon-list-a",
	category: designer.categories.ARRAYS,
	defaults: {
		name: "led array",
		width: 2,
		height: 6
	},

	createCmpt: function(id, grid, parent, x, y, readOnly) {

		var flagsContainer = document.createElement("div");
		flagsContainer.style.marginLeft = "10px";

		var flagsLabels = [];
		var flagsValues = [];

		var initFlags = function(numberOfFlags, flags) {

			flagsContainer.innerHTML = "";

			flagsLabels = [];
			flagsValues = [];

			for(var i = 0; i < numberOfFlags; i++) {

				var flagDiv = document.createElement("div");

				var flagLabel = document.createElement("span");
				flagLabel.appendChild(document.createTextNode(flags ? flags[i] : "Flag-" + i));

				var flagImage = document.createElement("img");
				flagImage.src = "/img/ledgrey.png";

				flagDiv.appendChild(flagImage);
				flagDiv.appendChild(document.createTextNode(" "));
				flagDiv.appendChild(flagLabel);

				flagsContainer.appendChild(flagDiv);

				flagsLabels.push(flagLabel);
				flagsValues.push(flagImage);
			}
		};

		var setFlagsLabels = function(labels) {

			for(var i = 0; i < flagsLabels.length; i++) {
				flagsLabels[i].innerHTML = labels[i] ? labels[i] : "Flag-" + i;
			}
		};

		var getFlagsLabels = function() {

			var labels = [];
			for(var i = 0; i < flagsLabels.length; i++) {
				labels.push(flagsLabels[i].innerHTML)
			}

			return labels;
		};

		var getEditParamsDefinition = function() {
			return this.getBaseEditParamsDefinition()
				.concat(this.getStatusEditParamsDefinition(), [{key: "flag", type: designer.paramsTypes.TEXT, cardinality: designer.paramsCardinality.MANY, label: "Flag", value: this.getFlagsLabels()}]);
		};

		var setEditParamsValues = function(params) {

			this.setBaseEditParamsValues(params);
			this.setStatusEditParamsValues(params);

			this.setFlagsLabels(params["flag"]);
		};

		var propsToObject = function() {
			return Object.assign({component: this.category, labels: this.getFlagsLabels()}, this.basePropsToObject(), this.statusPropsToObject());
		};

		var update = function(values) {
			for(var i = 0; i < values.length; i ++) {
				flagsValues[i].src = values[i] === undefined ? "/img/ledgrey.png" : (values[i] ? "/img/ledgreen.png" : "/img/ledred.png");
			}
		};

		var reset = function() {//TODO evitare reset on init

			flagsLabels = [];
			flagsValues = [];

			flagsContainer.innerHTML = "";
		};

		var getView = function() {

			var view = document.createElement("div");

			view.appendChild(this.getHeader());
			view.appendChild(flagsContainer);

			return view;
		};

		return Object.assign({
			setFlagsLabels: setFlagsLabels,
			getFlagsLabels: getFlagsLabels,
			initFlags: initFlags,
			category: this.category,
			getEditParamsDefinition: getEditParamsDefinition,
			setEditParamsValues: setEditParamsValues,
			propsToObject: propsToObject,
			getView: getView,
			update: update,
			reset: reset
		}, 
							 designer.statusCmpt(id, this.defaults.name, grid, parent, x, y, this.defaults.width, this.defaults.height, readOnly)
							);
	},
	createCmptFromDefinition: function(id, grid, parent, definition, readOnly) {

		var name = definition.label;
		var x = parseInt(definition.x), y = parseInt(definition.y);
		var width = parseInt(definition.width), height = parseInt(definition.height);

		var cmpt = this.createCmpt(id, grid, parent, x, y, readOnly);
		cmpt.setCmptName(name);
		cmpt.setWidth(width);
		cmpt.setHeight(height);

		cmpt.setSrc(definition.src);
		cmpt.initFlags(definition.labels.length, definition.labels);

		return cmpt;
	}
};

designer.registerCmptFactory(LedArray);




/**************************************************
 *
 *                      SCALAR
 *
 **************************************************/
var Scalar = {
	CSSIconClass: "fi fi-subscript",
	category: designer.categories.SCALARS,
	defaults: {
		name: "scalar",
		width: 1,
		height: 2
	},

	createCmpt: function(id, grid, parent, x, y, readOnly) {

		var mu;

		var getEditParamsDefinition = function() {
			return this.getBaseEditParamsDefinition()
				.concat(this.getStatusEditParamsDefinition(), [{key: "mu", type: designer.paramsTypes.TEXT, label: "Measure Unit", value: mu, CSSClass: "cell-4"}]);
		};

		var setEditParamsValues = function(params) {

			this.setBaseEditParamsValues(params);
			this.setStatusEditParamsValues(params);

			this.setMu(params["mu"]); 
		};

		var propsToObject = function() {
			return Object.assign({component: this.category, unit: mu}, this.basePropsToObject(), this.statusPropsToObject());
		};

		var update = function(value) {
			valueElement.innerHTML = $.isNumeric(value) ? value.toFixed(2) : value;
		};

		var reset = function() {
			valueElement.innerHTML = ""; 
		};

		var valueElement = document.createElement("span");
		valueElement.style.fontWeight = "bold";
		valueElement.style.fontSize = "32px";

		var muElement = document.createElement("span");
		muElement.style.fontWeight = "bold";
		muElement.style.fontSize = "18px";

		var getView = function() {

			var view = document.createElement("div");

			var valueContainer = document.createElement("div");
			valueContainer.style.marginLeft = "20px";
			valueContainer.appendChild(valueElement);
			valueContainer.appendChild(document.createTextNode(" "));
			valueContainer.appendChild(muElement);

			view.appendChild(this.getHeader());
			view.appendChild(valueContainer);

			return view;
		};

		return Object.assign({
			setMu: function(anMu) { mu = anMu; muElement.innerHTML = anMu ? anMu : ""; },
			getMu: function() { return mu; },
			category: this.category,
			getEditParamsDefinition: getEditParamsDefinition,
			setEditParamsValues: setEditParamsValues,
			propsToObject: propsToObject,
			getView: getView,
			update: update,
			reset: reset
		}, 
							 designer.statusCmpt(id, this.defaults.name, grid, parent, x, y, this.defaults.width, this.defaults.height, readOnly)
							);
	},
	createCmptFromDefinition: function(id, grid, parent, definition, readOnly) {

		var name = definition.label;
		var x = parseInt(definition.x), y = parseInt(definition.y);
		var width = parseInt(definition.width), height = parseInt(definition.height);

		var cmpt = this.createCmpt(id, grid, parent, x, y, readOnly);
		cmpt.setCmptName(name);
		cmpt.setWidth(width);
		cmpt.setHeight(height);

		cmpt.setSrc(definition.src);
		cmpt.setMu(definition.unit);

		return cmpt;
	}
};

designer.registerCmptFactory(Scalar);




/**************************************************
 *
 *                      TEXT
 *
 **************************************************/
var Textual = {
	CSSIconClass: "fi fi-font",
	category: designer.categories.TEXT,
	defaults: {
		name: "text",
		width: 2,
		height: 2
	},
	maxWidth: 4,
	maxHeight: 2,

	createCmpt: function(id, grid, parent, x, y, readOnly) {

		var getEditParamsDefinition = function() {
			return this.getBaseEditParamsDefinition().concat(this.getStatusEditParamsDefinition());
		};

		var setEditParamsValues = function(params) {
			this.setBaseEditParamsValues(params);
			this.setStatusEditParamsValues(params);
		};

		var propsToObject = function() {
			return Object.assign({component: this.category}, this.basePropsToObject(), this.statusPropsToObject());
		};

		var update = function(value) {
			valueElement.innerHTML = value;
		};

		var reset = function() {
			valueElement.innerHTML = ""; 
		};

		var valueElement = document.createElement("span");
		valueElement.style.fontWeight = "bold";
		valueElement.style.fontSize = "32px";

		var getView = function() {

			var view = document.createElement("div");

			var valueContainer = document.createElement("div");
			valueContainer.style.marginLeft = "20px";
			valueContainer.appendChild(valueElement);

			view.appendChild(this.getHeader());
			view.appendChild(valueContainer);

			return view;
		};

		return Object.assign({
			category: this.category,
			getEditParamsDefinition: getEditParamsDefinition,
			setEditParamsValues: setEditParamsValues,
			propsToObject: propsToObject,
			getView: getView,
			update: update,
			reset: reset
		}, 
							 designer.statusCmpt(id, this.defaults.name, grid, parent, x, y, this.defaults.width, this.defaults.height, readOnly)
							);
	},
	createCmptFromDefinition: function(id, grid, parent, definition, readOnly) {

		var name = definition.label;
		var x = parseInt(definition.x), y = parseInt(definition.y);
		var width = parseInt(definition.width), height = parseInt(definition.height);

		var cmpt = this.createCmpt(id, grid, parent, x, y, readOnly);
		cmpt.setCmptName(name);
		cmpt.setWidth(width);
		cmpt.setHeight(height);
		cmpt.setSrc(definition.src);

		return cmpt;
	}
};

designer.registerCmptFactory(Textual);






var eventListeners = [];
eventListeners.push({evName: "paste", evFunction: function(e, cmpt) {

	if(cmpt.category != designer.categories.SCALARS) {
		return;
	}

	var clipboardData = e.clipboardData || window.clipboardData;
	var pastedData = clipboardData.getData("Text");

	var prevSrc = cmpt.getSrc(), src = pastedData;
	prevSrc = prevSrc ? prevSrc : "";
	src = src ? src.trim().toLowerCase() : "";

	if(prevSrc !== src) {
		getSrcInfo(src, cmpt);
	}
}});
/*
eventListeners.push({evName: "keyup", evFunction: function(e, cmpt) {

}});*/

var onAjaxError = function(jqXHR, textStatus, errorThrown) {
	console.log("error", jqXHR, textStatus, errorThrown);
};

function getSrcInfo(src, cmpt) {

	var retrieveMeasureUnit = function(data, textStatus, jqXHR) {

		data = eval(data);
		if(data.indexOf("display_unit") != -1) {
			$.ajax({
				url: REST_SERVER + "/cs/" + src + "/display_unit",
				method: "GET",
				error: onAjaxError,
				success: displayMeasureUnit
			});
		}
	};

	var displayMeasureUnit = function(data, textStatus, jqXHR) {

		var evaluedData = eval(data);    
		if(evaluedData && evaluedData.toLowerCase() != "no display unit") {
			$("#" + cmpt.getId() + "-mu").val(evaluedData);  //TODO brutta dipendenza!!! e bisogna anche capire se il componente in editazione è nel frattempo cambiato
		}
	};

	$.ajax({
		url: REST_SERVER + "/cs/" + src + "/*",
		method: "GET",
		error: onAjaxError,
		success: retrieveMeasureUnit
	});
}

function subscribeSrc(cmpt, src) {

	var prevSrc = cmpt.getSrc();

	prevSrc = prevSrc ? prevSrc.trim().toLowerCase() : "";
	src = src ? src.trim().toLowerCase() : "";

	if(prevSrc !== src || cmpt.category == designer.categories.ARRAY) {

		if(prevSrc && prevSrc != 'myfunnysrc') {
			var cmptsWithSameSrc = srcsMap[prevSrc].cmpts;
			var cmptIndex = cmptsWithSameSrc.indexOf(cmpt);
			cmptsWithSameSrc.splice(cmptIndex, 1);

			if(cmptsWithSameSrc.length == 0) {
				unsubscribeVar(prevSrc);
				delete srcsMap[prevSrc];
			}
		}

		if(src) {
			var srcsMapEntry = srcsMap[src];
			if(srcsMapEntry) {
				srcsMapEntry.cmpts.push(cmpt);
			} else {
				srcsMap[src] = {values: [], cmpts: [cmpt]};
				subscribeVar(src);
			}



			if(cmpt.category == designer.categories.CHARTS) {









				if(srcsMap[src].storicoRetrieved) {

					for(var i = 0; i < srcsMap[src].values.length - 1; i++) {
						var value = srcsMap[src].values[i];

						var label = moment(value.date).format("HH:mm");
						cmpt.update(value.value, label);
					}

				} else {
					console.log('src', src, QUERY_STRING_DEFAULT_PARAMETERS);
					if(src.indexOf(ELETTRA) !== -1) {
						offset = ELETTRA.length;
						url = "https://pwma.elettra.eu/egiga2m/lib/service/hdb_plot_service.php?conf=elettra&start=last 12 hours&s=" + src.substring(offset) + QUERY_STRING_DEFAULT_PARAMETERS;
					} else if(src.indexOf(PADRES) !== -1) {
						offset = PADRES.length;
						url = "https://pwma.elettra.eu/egiga2m/lib/service/hdbpp_plot_service.php?conf=fermi&start=last 12 hours&s=" + src.substring(offset) + QUERY_STRING_DEFAULT_PARAMETERS;
					} else if(src.indexOf(INFRASTRUCTURES) !== -1) {
						offset = INFRASTRUCTURES.length;
						url = "https://pwma.elettra.eu/egiga2m/lib/service/hdbpp_plot_service.php?conf=infrastructure&start=last 48 hours&s=" + src.substring(offset) + QUERY_STRING_DEFAULT_PARAMETERS;
					} else  {
						url = "http://fcsproxy.elettra.eu/docs/egiga2m/lib/service/hdbpp_plot_service.php?conf=fermi&start=last 12 hours&s=" + src.substring(DEFAULT_OFFSET) + QUERY_STRING_DEFAULT_PARAMETERS;
					}
					console.log('url', url);
					fetch(url, {mode: 'no-cors'})
					.then(function(response) {
						return response.json();
						// return response.text();
					})
					.then(function(data) {
						console.log('data', data);
						srcsMap[src].values = [];
						var rawData = data.ts[0].data;

						if(!data) {
							return;
						}

						for(var i = 0; i < rawData.length - 1; i++) {
							var value = {date: new Date(rawData[i][0]), value: rawData[i][1]};

							srcsMap[src].values.push(value);

							var label = moment(new Date(rawData[i][0])).format("HH:mm"), data = rawData[i][1];
							cmpt.update(data, label);
						}

						srcsMap[src].storicoRetrieved = true;
					});
				}














			} else {

				if(srcsMap[src] && srcsMap[src].values.length > 0) {
					var srcValues = srcsMap[src].values;
					cmpt.update(srcValues[srcValues.length-1].value);
				} else {
					cmpt.update("n.a.");
				}
			}
		}
	}
}









var numericalSequence = (function() {
	var n = 0;
	return {next: function() {return n++;}};
})();

var getStatus = function() {

	var status = {}, childrenStatuses = [];

	if(this.children) {
		for(var i = 0; i < this.children.length; i++) {
			childrenStatuses.push(this.children[i].getStatus());
		}
	}

	status = {component: this.componentType, label: this.name.innerHTML, src: this.src, unit: this.mu ? this.mu.innerHTML : null,
			  width: this.attr("data-gs-width"), height: this.attr("data-gs-height"), x: this.attr("data-gs-x"), y: this.attr("data-gs-y")};

	if(this.flags) {
		status.labels = [];
		for(var i = 0; i < this.flags.length; i++) {
			status.labels.push(this.flags[i].flagLabel.innerHTML);
		}
	}

	if(childrenStatuses.length > 0) {
		status.children = childrenStatuses;
	}

	return status;
};

function closeEditForm(closeBtn) {
	$(closeBtn).closest("[id^=popover]").hide();
}

var ELETTRA = "tango://tom.ecs.elettra.trieste.it:20000/";
var PADRES = "tango://srv-padres-srf.fcs.elettra.trieste.it:20000/";
var INFRASTRUCTURES = "tango://infra-control-01.elettra.trieste.it:20000/";
var DEFAULT_OFFSET = 54;
var QUERY_STRING_DEFAULT_PARAMETERS = "&no_pretimer&no_posttimer&decimation_samples=300&ts=00046,1,1";

function onPopoverShow(popover) {
	$(".popover-close-button", popover).remove();
	$("#src-field-container", popover).append(fancyTreeContainer);

	var editIcon = this;
	$("input[data-pwma=close-btn]", popover).on("click", function() {
		$(document.body).append(fancyTreeContainer.detach());
		$(editIcon).data("popover").hide();
	});

	$("input[data-pwma=update-btn]", popover).on("click", function() {
		$(document.body).append(fancyTreeContainer.detach());
		$(editIcon).data("popover").hide();
	});
}

function searchForSource() {
	fancyTreeContainer.toggle();
}

function searchForScreen() {

	var screens = [];

	$.ajax({
		url: screenLoader,
		method: "POST",
		data: {list: ""},
		error: function(jqXHR, textStatus, errorThrown) {
			console.log("error", jqXHR, textStatus, errorThrown);
		},
		success: function(data, textStatus, jqXHR) {

			var screensMap = {}, screensWithoutUser = {user: null, screens: []};

			screens = [];
			screens.push(screensWithoutUser);

			for(var i = 0; i < data.length; i++) {

				var screen = data[i], folder = screensMap[screen.username];
				if(!folder) {
					if(!screen.username) {
						folder = screensWithoutUser;
					} else {
						folder = {user: screen.username, screens: []};
						screens.push(folder);
						screensMap[screen.username] = folder;
					}
				}

				folder.screens.push(screen);
			}

			screens.sort(function(a, b) {

				if(!a.user && !b.user) {
					return 0;
				} else if(!a.user) {
					return 1;
				} else if(!b.user) {
					return -1;
				}

				var userA = a.user.toUpperCase();
				var userB = b.user.toUpperCase();

				if(userA < userB) {
					return -1;
				}

				if(userA > userB) {
					return 1;
				}

				return 0;
			});

			initScreensTree();
		}
	});

	screensTreeContainer.toggle();

	function initScreensTree() {

		var tree = [];
		for(var i = 0; i < screens.length; i++) {

			if(screens[i].user) {
				var node = {title: screens[i].user, folder: true, children: []};

				for(var j = 0; j < screens[i].screens.length; j++) {
					node.children.push({title: screens[i].screens[j].title, key: screens[i].screens[j].id});
				}
				tree.push(node);
			} else {
				for(var j = 0; j < screens[i].screens.length; j++) {
					tree.push({title: screens[i].screens[j].title, key: screens[i].screens[j].id});
				}
			}
		}  

		screensTreeContainer.fancytree({
			autoScroll: true,
			source: tree,
			click: function(event, data) {

				if(data.node.children || (data.targetType != "icon" && data.targetType != "title")) {
					return true;
				}

				$("[id$=-screen]").val(data.node.title);
				$("[id$=-screen-id]").val(data.node.key);

				screensTreeContainer.toggle();
				return true;
			},
			clickFolderMode: 2
		});
	}
}

function createChart(canvas, labels, data) {

	return Chart.Line(canvas, {
		type: "line",
		data: {
			labels: labels || [],
			datasets: [{
				label: "",
				fill: false,
				lineTension: 0.1,
				backgroundColor: "rgba(75,192,192,0.4)",
				borderColor: "rgba(75,192,192,1)",
				borderCapStyle: 'butt',
				borderDash: [],
				borderDashOffset: 0.0,
				borderJoinStyle: 'miter',
				pointBorderColor: "rgba(75,192,192,1)",
				pointBackgroundColor: "#fff",
				pointBorderWidth: 1,
				pointHoverRadius: 5,
				pointHoverBackgroundColor: "rgba(75,192,192,1)",
				pointHoverBorderColor: "rgba(220,220,220,1)",
				pointHoverBorderWidth: 2,
				pointRadius: 1,
				pointHitRadius: 10,
				data: data || [],
				spanGaps: false,
			}]
		},
		options: {legend: {display: false}}
	});
}

var editCmptForm = {};

var widget;

function getDroppableGrid(x, y) {

	if($currentDropArea.parent().get(0).id.startsWith("screen-")) {
		return activeScreen.tab.content.grid;
	}

	return cmptsMapById[$currentDropArea.parent().parent().get(0).id].nestedGrid;

	var droppableGridsSorter = function(a, b) {return b.zIndex - a.zIndex;};
	var droppableGrids = [];

	for(var i = 0; i < activeScreen.cmpts.length; i++) {

		var cmpt = activeScreen.cmpts[i];
		if(cmpt.attr("data-cmpt-type") != CONTAINER) {
			continue;
		}

		//var cmptX = parseInt(cmpt.attr("data-gs-x")), cmptY = parseInt(cmpt.attr("data-gs-y"));

		var cmpRelativeLeft = cmpt.offset().left - activeScreen.tab.content.grid.container.offset().left;
		var cmpRelativeTop = cmpt.offset().top - activeScreen.tab.content.grid.container.offset().top;
		//var cmptX = Math.trunc(relativeLeft/(grid.container.width()*8.3/100)), cmptY = Math.trunc(relativeTop/(60 + 20));

		//var cmptWidth = parseInt(cmpt.attr("data-gs-width")), cmptHeight = parseInt(cmpt.attr("data-gs-height"));
		var cmptWidth = cmpt.width(), cmptHeight = cmpt.height();

		//console.log(cmptX, cmptY, cmptX + cmptWidth, cmptY + cmptHeight, cmpt.nestedGrid);
		if(cmpRelativeLeft <= x && x < cmpRelativeLeft + cmptWidth && cmpRelativeTop <= y && y < cmpRelativeTop + cmptHeight) {
			droppableGrids.push(cmpt.nestedGrid);
		}
		/*
    var cmptX = Math.trunc(relativeLeft/(grid.container.width()*8.3/100)), cmptY = Math.trunc(relativeTop/(60 + 20));

    var cmptWidth = parseInt(cmpt.attr("data-gs-width")), cmptHeight = parseInt(cmpt.attr("data-gs-height"));
    console.log(cmptX, cmptY, cmptX + cmptWidth, cmptY + cmptHeight, cmpt.nestedGrid);
    if(cmptX <= x && x < cmptX + cmptWidth && cmptY <= y && y < cmptY + cmptHeight) {
      droppableGrids.push(cmpt.nestedGrid);
    }*/
	}

	return droppableGrids.length > 0 ? droppableGrids.sort(droppableGridsSorter)[0] : activeScreen.tab.content.grid;
}

var SLOT_HEIGHT = 80;

var cmptGrid;

var FIELD_HTML =/*
  "<div class='btns-wrap'>" +
  "  <div class='btn-add'>" +
  "    <div class='preview' style='color: white;'>FIELD_NAME</div>" +  
  "  </div>" +    
  "</div>"*/
	"<div class='form-group'>" +
	"  <label>FIELD_NAME</label>" +
	"</div>";

function addNameField(cmptId) {

	var $nameField = $(FIELD_HTML.replace(/FIELD_NAME/, "Name"));
	var nameInput = document.createElement("input");
	nameInput.id = "cmpt-name";
	nameInput.type = "text";
	nameInput.value = cmptsMapById[cmptId].name.innerHTML;
	nameInput.setAttribute("data-role", "input");
	//nameInput.class = "active";
	//nameInput.style.width = "100%";

	$nameField.append(nameInput);
	$editCmptSectionFields.append($nameField);
}

function addScreenFileField(cmptId, eventListeners) {

	var $sourceField = $(FIELD_HTML.replace(/FIELD_NAME/, "Screen File"));

	var srcInput = document.createElement("input");
	srcInput.id = "cmpt-screen-file";
	srcInput.type = "text";
	srcInput.value = cmptsMapById[cmptId].screenFile ? cmptsMapById[cmptId].screenFile : "";

	srcInput.setAttribute("data-role", "input");
	srcInput.setAttribute("data-search-button", "true");
	srcInput.setAttribute("data-search-button-click", "custom");
	srcInput.setAttribute("data-on-search-button-click", "searchForSource");

	$sourceField.append(srcInput);
	$editCmptSectionFields.append($sourceField);
}

function addSourceField(cmptId, eventListeners) {

	var $sourceField = $(FIELD_HTML.replace(/FIELD_NAME/, "Source"));/*
  $(".preview", $sourceField).append("<div class='float-right popover-info' style='display: inline; float: none !important;'>" +
                                     "  <i class='fas fa-question-circle' onclick='fancyTreeContainer.toggle();'></i>" +
                                     "</div>");*/

	var formulaInput = document.createElement("input");
	formulaInput.id = "formula";
	formulaInput.type = "hidden";

	var srcInput = document.createElement("input");
	srcInput.id = "cmpt-src";
	srcInput.type = "text";
	srcInput.value = cmptsMapById[cmptId].src ? cmptsMapById[cmptId].src : "";
	//srcInput.class = "active";
	//srcInput.style.width = "100%";

	srcInput.setAttribute("data-role", "input");
	srcInput.setAttribute("data-search-button", "true");
	srcInput.setAttribute("data-search-button-click", "custom");
	srcInput.setAttribute("data-on-search-button-click", "searchForSource");

	if(eventListeners) {
		for(var i = 0; i < eventListeners.length; i++) {

			var eventListener = eventListeners[i];

			if(srcInput.addEventListener) {
				srcInput.addEventListener(eventListener.evName, eventListener.evFunction);
			} else {
				srcInput.attachEvent("on" + eventListener.evName, eventListener.evFunction);
			}
		}
	}

	$sourceField.append(formulaInput).append(srcInput).append(fancyTreeContainer);
	$editCmptSectionFields.append($sourceField);
}

function addMeasureUnit(cmptId) {

	var $measureUnitField = $(FIELD_HTML.replace(/FIELD_NAME/, "Measure Unit"));

	var muInput = document.createElement("input");
	muInput.id = "cmpt-mu";
	muInput.type = "text";
	muInput.value = cmptsMapById[cmptId].mu.innerHTML ? cmptsMapById[cmptId].mu.innerHTML : "";
	//muInput.class = "active";
	muInput.style.width = "20%";

	$measureUnitField.append(muInput);
	$editCmptSectionFields.append($measureUnitField);
}

function createContainerEditForm(containerId) {
	addNameField(containerId);
}

function createScreenEditForm(screenId) {

	addNameField(screenId);
	addScreenFileField(screenId);
}

function createChartEditForm(chartId) {

	addNameField(chartId);
	addSourceField(chartId);
}

function createScalarEditForm(scalarId) {

	addNameField(scalarId);
	addSourceField(scalarId);
	addMeasureUnit(scalarId);
}

function createLedArrayEditForm(ledArrayId) {

	var eventListeners = [];
	eventListeners.push({evName: 'paste', evFunction: function(e) {    

		var clipboardData, pastedData;

		// Stop data actually being pasted into div
		//e.stopPropagation();
		//e.preventDefault();

		// Get pasted data via clipboard API
		clipboardData = e.clipboardData || window.clipboardData;
		pastedData = clipboardData.getData('Text');

		//TODO check validity
		var cmpt = cmptsMapById[ledArrayId];

		var prevSrc = cmpt.src, src = pastedData; //document.getElementById("cmpt-src").value;
		prevSrc = prevSrc ? prevSrc : "";
		src = src ? src.trim().toLowerCase() : "";

		if(prevSrc !== src) {

			if(prevSrc) {
				var cmptsWithSameSrc = srcsMap[prevSrc].cmpts;
				var cmptIndex = cmptsWithSameSrc.indexOf(cmpt);
				cmptsWithSameSrc.splice(cmptIndex, 1);

				if(cmptsWithSameSrc.length == 0) {
					unsubscribeVar(prevSrc);
					delete srcsMap[prevSrc];
				}
			}

			if(src) {
				var srcsMapEntry = srcsMap[src];
				if(srcsMapEntry) {
					srcsMapEntry.cmpts.push(cmpt);
					cmpt.update = updateLedArrayTmp;
					updateLedArrayTmp(srcsMapEntry.values[srcsMapEntry.values.length - 1].value);
				} else {
					srcsMap[src] = {values: [], cmpts: [cmpt]};
					cmpt.update = updateLedArrayTmp;
					subscribeVar(src);
				}
			}
		}

		cmpt.name.innerHTML = document.getElementById("cmpt-name").value;
		cmpt.prevSrc = cmpt.src;
		cmpt.src = src;    
	}});

	addNameField(ledArrayId);
	addSourceField(ledArrayId, eventListeners);

	var cmpt = cmptsMapById[ledArrayId];
	if(cmpt.flags) {

		var $flagsContainer = $("<div id='flags-container'></div>");
		var $editCmptSectionFields = $("#edit-cmpt-section-fields");

		$editCmptSectionFields.append($flagsContainer);
		$flagsContainer.css({height: "200px", overflowY: "auto"});   

		for(var i = 0; i < cmpt.flags.length; i++) { 

			var $flagField = $(FIELD_HTML.replace(/FIELD_NAME/, "Flag-" + i));
			var flagInput = document.createElement("input");
			flagInput.id = "cmpt-flag-" + i;
			flagInput.type = "text";
			flagInput.value = cmpt.flags[i].flagName;
			//flagInput.class = "active";
			//flagInput.style.width = "100%";

			$flagField.append(flagInput);
			$flagsContainer.append($flagField);
		}
	}  
}

function editContainer(containerId) {
	cmptsMapById[containerId].name.innerHTML = document.getElementById("cmpt-name").value;
}

function editScreen(screenId) {
	cmptsMapById[screenId].name.innerHTML = document.getElementById("cmpt-name").value;
}

function editChart(chartId) {

	var cmpt = cmptsMapById[chartId];

	var prevSrc = cmpt.src, src = document.getElementById("cmpt-src").value;
	prevSrc = prevSrc ? prevSrc : "";
	src = src ? src.trim().toLowerCase() : "";

	if(prevSrc !== src) {

		if(prevSrc) {
			var cmptsWithSameSrc = srcsMap[prevSrc].cmpts;
			var cmptIndex = cmptsWithSameSrc.indexOf(cmpt);
			cmptsWithSameSrc.splice(cmptIndex, 1);

			if(cmptsWithSameSrc.length == 0) {
				unsubscribeVar(prevSrc);
				delete srcsMap[prevSrc];
			}
		}

		if(src) {
			var srcsMapEntry = srcsMap[src];
			if(srcsMapEntry) {
				srcsMapEntry.cmpts.push(cmpt);
			} else {
				srcsMap[src] = {values: [], cmpts: [cmpt]};
				subscribeVar(src);
			}

			if(srcsMap[src].storicoRetrieved) {
				for(var i = 0; i < srcsMap[src].values.length - 1; i++) {
					var value = srcsMap[src].values[i];

					var label = moment(value.date).format("HH:mm");
					cmpt.update(value.value, label);
				}
			} else {

				if(src.indexOf(ELETTRA) !== -1) {
					offset = ELETTRA.length;
					url = "https://pwma.elettra.eu/egiga2m/lib/service/hdb_plot_service.php?conf=elettra&start=last 12 hours&s=" + src.substring(offset) + QUERY_STRING_DEFAULT_PARAMETERS;
				} else if(src.indexOf(PADRES) !== -1) {
					offset = PADRES.length;
					url = "https://pwma.elettra.eu/egiga2m/lib/service/hdbpp_plot_service.php?conf=fermi&start=last 12 hours&s=" + src.substring(offset) + QUERY_STRING_DEFAULT_PARAMETERS;
				} else if(src.indexOf(INFRASTRUCTURES) !== -1) {
					offset = INFRASTRUCTURES.length;
					url = "http://fcsproxy.elettra.eu/docs/egiga2m/lib/service/hdbpp_plot_service.php?conf=infrastructure&start=last 48 hours&s=" + src.substring(offset) + QUERY_STRING_DEFAULT_PARAMETERS;
				} else  {
					url = "https://pwma.elettra.eu/egiga2m/lib/service/hdbpp_plot_service.php?conf=fermi&start=last 12 hours&s=" + src.substring(DEFAULT_OFFSET) + QUERY_STRING_DEFAULT_PARAMETERS;
				}

				fetch(url, {mode: 'no-cors'})
					.then(function(response) {
					return response.json();
				})
					.then(function(data) {

					srcsMap[src].values = [];
					var rawData = data.ts[0].data;

					for(var i = 0; i < rawData.length - 1; i++) {
						var value = {date: new Date(rawData[i][0]), value: rawData[i][1]};
						//cmpt.data.push(value);
						srcsMap[src].values.push(value);

						var label = moment(new Date(rawData[i][0])).format("HH:mm"), data = rawData[i][1];
						cmpt.update(data, label);
					}
					/*

			   var svgWidth = 1200, svgHeight = 400;
			   var margin = { top: 20, right: 20, bottom: 30, left: 50 };
			   var width = svgWidth - margin.left - margin.right;
			   var height = svgHeight - margin.top - margin.bottom;
			   var svg = d3.select('#' + chartId + ' svg[data-tag-role=component-graph]').attr("width", svgWidth).attr("height", svgHeight);

			   var g = svg.append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

			   var x = d3.scaleTime().rangeRound([0, width]);
			   var y = d3.scaleLinear().rangeRound([height, 0]);

			   x.domain(d3.extent(cmpt.data, function(d) { return d.date }));
			   y.domain(d3.extent(cmpt.data, function(d) { return d.value }));

			var line = d3.line()
			   .x(function(d) { return x(d.date)})
			   .y(function(d) { return y(d.value)});

			g.append("g")
			   .attr("transform", "translate(0," + height + ")")
			   .call(d3.axisBottom(x))
			   .select(".domain")
			   .remove();

			g.append("g")
			   .call(d3.axisLeft(y))
			   .append("text")
			   .attr("fill", "#000")
			   .attr("transform", "rotate(-90)")
			   .attr("y", 6)
			   .attr("dy", "0.71em")
			   .attr("text-anchor", "end")
			   .text("ma");

			g.append("path")
			.datum(cmpt.data)
			.attr("fill", "none")
			.attr("stroke", "steelblue")
			.attr("stroke-linejoin", "round")
			.attr("stroke-linecap", "round")
			.attr("stroke-width", 1.5)
			.attr("d", line);*/

					srcsMap[src].storicoRetrieved = true;
				});
			}
		}
	}

	cmpt.name.innerHTML = document.getElementById("cmpt-name").value;
	cmpt.src = src;
}

function editScalar(scalarId) {

	var cmpt = cmptsMapById[scalarId];

	var prevSrc = cmpt.src, src = document.getElementById("cmpt-src").value;
	prevSrc = prevSrc ? prevSrc : "";
	src = src ? src.trim().toLowerCase() : "";

	if(prevSrc !== src) {

		if(prevSrc) {
			var cmptsWithSameSrc = srcsMap[prevSrc].cmpts;
			var cmptIndex = cmptsWithSameSrc.indexOf(cmpt);
			cmptsWithSameSrc.splice(cmptIndex, 1);

			if(cmptsWithSameSrc.length == 0) {
				unsubscribeVar(prevSrc);
				delete srcsMap[prevSrc];
			}
		}

		if(src) {
			var srcsMapEntry = srcsMap[src];
			if(srcsMapEntry) {
				srcsMapEntry.cmpts.push(cmpt);
			} else {
				srcsMap[src] = {values: [], cmpts: [cmpt]};
				subscribeVar(src);
			}
		}
	}

	cmpt.name.innerHTML = document.getElementById("cmpt-name").value;

	if(srcsMap[src] && srcsMap[src].values.length > 0) {
		var values = srcsMap[src].values;
		cmpt.srcValue.innerHTML = $.isNumeric(values[values.length-1].value) ? values[values.length-1].value.toFixed(2) : values[values.length-1].value;
	} else {
		cmpt.srcValue.innerHTML = "n.a.";
	}

	cmpt.mu.innerHTML = document.getElementById("cmpt-mu").value;
	cmpt.src = src;
}

function editLedArray(ledArrayId) {

	var cmpt = cmptsMapById[ledArrayId];

	var prevSrc = cmpt.prevSrc, src = document.getElementById("cmpt-src").value;
	prevSrc = prevSrc ? prevSrc : "";
	src = src ? src.trim().toLowerCase() : "";

	if(prevSrc !== src) {
		cmpt.flagsContainer.empty();
		cmpt.flags = [];

		if(srcsMap[cmpt.src] != null) {

			var values = srcsMap[cmpt.src].values;
			lastValue = values.length > 0 ? values[values.length-1].value : [];

			$("#edit-cmpt-section-fields input[id^=cmpt-flag]").each(function(i, elm) {

				var flagDiv = document.createElement("div");

				var flagLabel = document.createElement("span");
				flagName = elm.value.trim() ? elm.value : "Flag-" + i;
				flagLabel.appendChild(document.createTextNode(elm.value.trim() ? elm.value : "Flag-" + i));

				var flagImage = document.createElement("img");
				flagImage.src = lastValue[i] === undefined ? "/img/ledgrey.png" : (lastValue[i] ? "/img/ledgreen.png" : "/img/ledred.png");

				flagDiv.appendChild(flagImage);
				flagDiv.appendChild(flagLabel);

				cmpt.flagsContainer.append(flagDiv);
				cmpt.flags.push({flagImage: flagImage, flagName: elm.value.trim(), flagLabel: flagLabel});
			});
		}
	}

	cmpt.name.innerHTML = document.getElementById("cmpt-name").value;
	cmpt.update = updateLedArray;
}

function updateChart(value, label) {

	this.chart.data.labels.push(label || moment().format("HH:mm"));
	this.chart.data.datasets.forEach((dataset) => {
		dataset.data.push(value);
	});
	this.chart.update();
	/*
  this.data.push({date: new Date(), value: value});
  d3.select("#" + this.attr("id") + " svg[data-tag-role=component-graph] g").remove();

var cmpt = this;

		   var svgWidth = 1200, svgHeight = 400;
		   var margin = { top: 20, right: 20, bottom: 30, left: 50 };
		   var width = svgWidth - margin.left - margin.right;
		   var height = svgHeight - margin.top - margin.bottom;
		   var svg = d3.select('#' + this.attr("id") + ' svg[data-tag-role=component-graph]').attr("width", svgWidth).attr("height", svgHeight);

		   var g = svg.append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

		   var x = d3.scaleTime().rangeRound([0, width]);
		   var y = d3.scaleLinear().rangeRound([height, 0]);

		   x.domain(d3.extent(cmpt.data, function(d) { return d.date }));
		   y.domain(d3.extent(cmpt.data, function(d) { return d.value }));

		var line = d3.line()
		   .x(function(d) { return x(d.date)})
		   .y(function(d) { return y(d.value)});

		g.append("g")
		   .attr("transform", "translate(0," + height + ")")
		   .call(d3.axisBottom(x))
		   .select(".domain")
		   .remove();

		g.append("g")
		   .call(d3.axisLeft(y))
		   .append("text")
		   .attr("fill", "#000")
		   .attr("transform", "rotate(-90)")
		   .attr("y", 6)
		   .attr("dy", "0.71em")
		   .attr("text-anchor", "end")
		   .text("ma");

		g.append("path")
		.datum(cmpt.data)
		.attr("fill", "none")
		.attr("stroke", "steelblue")
		.attr("stroke-linejoin", "round")
		.attr("stroke-linecap", "round")
		.attr("stroke-width", 1.5)
		.attr("d", line);*/
}

function updateScalar(value) {
	this.srcValue.innerHTML = $.isNumeric(value) ? value.toFixed(2) : value;
}

function updateLedArray(values) {

	for(var i = 0; i < values.length; i++) {
		var value = values[i];
		this.flags[i].flagImage.src = "/img/" + (value ? "ledgreen.png" : "ledred.png");
	}
}

function updateLedArrayTmp(values) {

	$("#flags-container").remove();

	var $editCmptSectionFields = $("#edit-cmpt-section-fields");

	var $flagsContainer = $("<div id='flags-container'></div>").css({height: "200px", overflowY: "auto"});
	$editCmptSectionFields.append($flagsContainer);

	for(var i = 0; i < values.length; i++) {

		var $flagField = $(FIELD_HTML.replace(/FIELD_NAME/, "Flag-" + i));
		var flagInput = document.createElement("input");
		flagInput.id = "cmpt-flag-" + i;
		flagInput.type = "text";
		//flagInput.class = "active";
		//flagInput.style.width = "100%";

		$flagField.append(flagInput);
		$flagsContainer.append($flagField);
	}

	this.update = function() {}; 
}

function toggleDrop(cmptId) {

	for(var i = 0; i < activeScreen.cmpts.length; i++) { //TODO fare ricorsivamente per considerare i contenitori dentro i contenitori
		if(activeScreen.cmpts[i].componentType == CONTAINER && activeScreen.cmpts[i].get(0).id != cmptId) {
			$("> .grid-stack-item-content", activeScreen.cmpts[i]).css({backgroundColor: "white", boxShadow: "none", borderColor: "#dfdfdf", outline: "none"});
			activeScreen.cmpts[i].dropEnabled = false;
		} 
	}

	var cmptToEdit = cmptsMapById[cmptId];
	var gridStackItemContent = $("> .grid-stack-item-content", cmptToEdit);

	$currentDropArea.droppable("destroy");

	if(cmptToEdit.dropEnabled) {
		gridStackItemContent.css({backgroundColor: "white", boxShadow: "none", border: "thin solid #dfdfdf", outline: "none"});
		$("#tabs-content").css({backgroundColor: "#ffffe0"});
		activeScreen.tab.header.style.backgroundColor = "#ffffe0";

		$currentDropArea = $("> .grid-stack", activeScreen.tab.content).droppable({
			drop: handleDropEvent
		});

	} else {
		gridStackItemContent.css({backgroundColor: "#ffffe0", boxShadow: "0px 0px 20px 1px #13709e", borderColor: "transparent", outline: "2px solid #13709e"});
		$("#tabs-content").css({backgroundColor: "#fffff5"});
		activeScreen.tab.header.style.backgroundColor = "#fffff5";

		$currentDropArea = $("> .grid-stack", gridStackItemContent).droppable({
			drop: handleDropEvent
		});
	}

	cmptToEdit.dropEnabled = !cmptToEdit.dropEnabled;
}

var cmptToEdit;
var editDoneCallback;

function updateCmpt() {
	editDoneCallback();
	closeEditModal();
}

function closeEditModal() {
	$editCmptSection.hide();
}

function updateName(name) {
	editCmptForm.title.innerHTML = name;
	$("[data-component-name]", cmptToEdit).attr("data-component-name", name);
}

var $sidebarNav, $designerContainer;

var fancyTreeContainer, $screensListModal, $screensList;

var toJSON = function() {

	var cmptsState = [];
	for(var i = 0; i < this.cmpts.length; i++) {
		cmptsState.push(this.cmpts[i].getStatus());
	}

	return JSON.stringify(cmptsState);
}

var EXPANDED_SIDEBAR_OFFSET = 210;

function onTabSelected(tab, elem) {

	var tabAsDomObj = tab.get(0);
	for(var i = 0; i < screens.length; i++) {
		if(screens[i].tab.header == tabAsDomObj) {
			activeScreen = screens[i];
			break;
		}
	}

	$("#tabs-header > li").css({backgroundColor: "white"});
	if(activeScreen.currentGrid == activeScreen.tab.content.grid) {
		activeScreen.tab.header.style.backgroundColor = "#ffffe0";
		$("#tabs-content").css({backgroundColor: "#ffffe0"});
	} else {
		activeScreen.tab.header.style.backgroundColor = "#fffff5";
		$("#tabs-content").css({backgroundColor: "#fffff5"});
	}
	/*
  $currentDropArea.droppable("destroy");
  $currentDropArea = $("> .grid-stack", activeScreen.tab.content).droppable({
                         drop: handleDropEvent
                     });*/
}

function createTab(screen, headerId, contentId) {

	$("#tabs-header > li").css({backgroundColor: "white"});

	var header = document.createElement("li");
	header.style.display = "flex";
	header.style.backgroundColor = "#ffffe0";

	var tabName = document.createElement("a");
	tabName.id = headerId;
	tabName.href = "#" + contentId;
	tabName.style.paddingRight = "0";
	tabName.appendChild(document.createTextNode(screen.name));
	header.appendChild(tabName);

	var selectTabBtn = document.createElement("i");
	selectTabBtn.style.padding = ".5rem 0rem .5rem .5rem";
	selectTabBtn.style.transform = "rotate(-45deg)";
	selectTabBtn.className = "icon-pin";
	header.appendChild(selectTabBtn);

	$(selectTabBtn).on("click", function(e) {

		e.preventDefault();
		if(this.className == "icon-pin") {
			return;
		}

		this.className = "icon-pin";
		//TODO
	});

	var closeTabBtn = document.createElement("i");
	closeTabBtn.appendChild(document.createTextNode("\u00D7"));
	closeTabBtn.style.padding = ".5rem .5rem .5rem .2rem";
	closeTabBtn.className = "cursor-pointer";
	header.appendChild(closeTabBtn);

	$(closeTabBtn).on("click", function(e) {

		e.preventDefault();
		removeScreen(screen);
	});

	var content = document.createElement("div");
	content.id = contentId;
	content.style.minHeight = "100%";
	//content.style.overflowY = "visible";

	var contentGridStack = document.createElement("div");
	contentGridStack.className = "grid-stack";

	content.appendChild(contentGridStack);

	var $contentGridStack = $(contentGridStack);
	content.grid = $contentGridStack.gridstack({
		float: true
	}).data('gridstack');

	if(screen.$currentDropArea) {
		screen.$currentDropArea.droppable("destroy");
	}

	screen.currentGrid = content.grid;
	screen.$currentDropArea = $contentGridStack.droppable({
		drop: handleDropEvent
	});

	//content.grid.container.css({height: "100%"}); //TODO sistemare


	attachDragAndResizeListeners($contentGridStack);


	return {header: header, content: content};
}

function createScreen(name, isActive, externalId) {

	var internalId = numericalSequence.next();

	if(externalId != null && screens.length == 1 && screens[0].externalId == null && screens[0].cmpts.length == 0) {
		removeScreen(screens[0], true);
	}

	if(!name) {

		var busyNumbers = [], screenNumber;

		for(var i = 0; i < screens.length; i++) {
			var screen = screens[i];
			if(screen.externalId == null) {
				busyNumbers.push(parseInt(screen.name.replace("untitled screen", "").trim()));
			}
		}

		busyNumbers.sort(function(a, b) { return a-b; });

		for(var i = 0; i < busyNumbers.length; i++) {
			if(i+1 !== busyNumbers[i]) {
				screenNumber = i+1;
				break;
			}
		}

		if(screenNumber === undefined) {
			screenNumber = busyNumbers.length + 1;
		}

		name = "untitled screen " + screenNumber;
	}

	var screen = {id: internalId, name: name, cmpts: [], externalId: externalId, isChanged: false};
	screen.tab = createTab(screen, "screen-" + internalId + "-tab-header", "screen-" + internalId + "-tab-content");

	screens.push(screen);

	$tabsHeader.append(screen.tab.header);
	$tabsContent.append(screen.tab.content);

	if(isActive) {
		$(screen.tab.header.firstChild).trigger("click");
	}

	document.getElementById("tabs-content").style.backgroundColor = "rgb(255, 255, 224)";
	return screen;
}

function removeScreen(screen, force) {

	if(screen.isChanged) {
		//TODO show a nice confirmation modal
	}

	while(screen.cmpts.length > 0) {
		designer.removeCmpt(screen.cmpts[0].getId());
	}

	if(screens.length == 1 && screen.externalId == null) {

		if(force) {
			//$(screen.tab.header.firstChild).tab("dispose");

			$(screen.tab.content).remove();
			$(screen.tab.header).remove();

			screens = [];

		} else {
			screen.cmpts = [];
		}

		return;
	}

	if(screens.length == 1) {

		screens = [];
		activeScreen = createScreen(undefined, true, undefined);

	} else {

		var screenIndex = screens.indexOf(screen);

		if(activeScreen == screen) {
			var isLastOne = screenIndex === screens.length-1;

			if(isLastOne) {
				activeScreen = screens[screenIndex-1];
				$(activeScreen.tab.header.firstChild).trigger("click");
			} else {
				activeScreen = screens[screenIndex+1];
				$(activeScreen.tab.header.firstChild).trigger("click");
			}
		}

		screens.splice(screenIndex, 1);
	}

	$(screen.tab.content).remove();
	$(screen.tab.header).remove();

	activeScreen.tab.header.style.backgroundColor = "#ffffe0";
}

var $tabsHeader, $tabsContent;
var screens = [], activeScreen;

var $listScreenDialogContent;

var $currentDropArea;

$(function(e) {

	designer.init();

	$("#new-screen").on("click", function(e) {
		activeScreen = createScreen(undefined, true, undefined); 
	});

	$("#close-screen").on("click", function(e) {
		removeScreen(activeScreen);
	});

	$("#delete-screen").on("click", function(e) {
		deleteScreen(activeScreen);
	});

	$("#screens-list-filter").on("keyup", filterScreensList);

	var params = getQueryParams(document.location.search);
	document.getElementById("user-name").innerHTML = params["username"] ? params["username"] : "";

	$("#list-screens").click(listScreens);
	$("#save-screen").click(saveScreen);
	$("#save-screen-as").click(saveScreenAs);
	$("#preview-screen").click(enterPreviewMode);
	$("#sitemap-screen").click(sitemapScreen);
	$("#sitemap-screen").children().eq(1).html('add to starter');

	fancyTreeContainer = $("#tree");
	screensTreeContainer = $("#screens");
	myFunnyTree();

	var TABS_CONTENT_BOTTOM_MARGIN = 5;

	var $componentsList = $("#components-list");
	var componentsListHeaderOffsetY = $componentsList.get(0).getBoundingClientRect().top;
	$componentsList.css({height: $(window).height() - componentsListHeaderOffsetY});

	var tabContentOffsetY = $tabsContent.get(0).getBoundingClientRect().top;
	$tabsContent.css({height: $(window).height() - tabContentOffsetY - TABS_CONTENT_BOTTOM_MARGIN, overflow: "auto"});

	$listScreenDialogContent = $("#screens-list-dialog .dialog-content");
});

function openScreena(screenTitle) {
	return function() {openScreen(screenTitle, false);};
}

function deleteScreen(screen){

	var data = {delete: "", id: activeScreen.externalId, content: null};
	var screenToRemove = activeScreen;

	var doDelete = function() {
		$.ajax({
			url: screenLoader,
			method: "POST",
			data: data,
			error: function(jqXHR, textStatus, errorThrown) {
				console.log("error", jqXHR, textStatus, errorThrown);
			},
			success: function(data, textStatus, jqXHR) {

				var notify = Metro.notify;   
				notify.setup({
					width: 300,
					timeout: 3000
				});
				notify.create("Screen has been correctly deleted", "Deleted", {
					cls: "success no-border"
				});

				removeScreen(screenToRemove);
				screenToRemove = null;
			}
		});
	};

	Metro.dialog.create({
		title: "Screen Deletion",
		content: "<div>Delete the screen <i id='delete-screen-name'></i></div>",
		onOpen: function(dialog) { $("#delete-screen-name", dialog).get(0).innerHTML = activeScreen.name + "?"; },
		actions: [{
			caption: "Yes, delete it!",
			cls: "js-dialog-close alert",
			onclick: function(){
				doDelete();
			}
		},{
			caption: "No",
			cls: "js-dialog-close",
			onclick: function(){}
		}]
	});
}

function filterScreensList(e) {

	var searchText = this.value.trim().toLowerCase();

	if(!searchText && !currentFolder) {
		showFolders();
		return;
	}

	var screensList = document.createElement("ul");
	screensList.setAttribute("data-role", "listview");
	screensList.setAttribute("data-view", "table");
	screensList.setAttribute("data-structure", '{"date": true}');

	if(currentFolder) {
		for(var j = 0; j < currentFolder.screens.length; j++) {

			if(currentFolder.screens[j].title.toLowerCase().indexOf(searchText) != -1) {

				var screeen = currentFolder.screens[j], screenItem = document.createElement("li");
				var matches = screeen.title.match(new RegExp(searchText, "gi"));

				screenItem.setAttribute("data-icon", "<span class='mif-file-empty'>");
				screenItem.setAttribute("data-caption", screeen.title.replace(new RegExp(searchText, "gi"), "<span style='text-decoration: underline;'>" + matches[0] + "</span>"));
				screenItem.onclick = openScreena(screeen.id);

				var dateTokens = [];
				if(screeen.created_on) {

					var createdOn = new Date(screeen.created_on);
					var day = createdOn.getDate(), month = createdOn.getMonth() + 1, year = createdOn.getFullYear();
					dateTokens.push(day < 10 ? "0" + day : day);
					dateTokens.push(month < 10 ? "0" + month : month);
					dateTokens.push(year);
				}

				screenItem.setAttribute("data-date", dateTokens.join("/"));
				screensList.append(screenItem);
			}
		}

		$listScreenDialogContent.empty().append(screensList);
		return;
	}

	for(var i = 0; i < folders.length; i++) {
		var folder = folders[i];
		if(folder.user) {

			if(folder.user.toLowerCase().indexOf(searchText) != -1) {
				var matches = folder.user.match(new RegExp(searchText, "gi"));

				var screenItem = document.createElement("li");
				screenItem.setAttribute("data-icon", "<span class='mif-folder fg-orange'>");
				screenItem.setAttribute("data-caption", folder.user.replace(new RegExp(searchText, "gi"), "<span style='text-decoration: underline;'>" + matches[0] + "</span>"));
				screenItem.onclick = (function(f) {return function(){showFolder(f);};})(folder);

				screensList.append(screenItem); 
			}
		}

		for(var j = 0; j < folder.screens.length; j++) {

			if(folder.screens[j].title.toLowerCase().indexOf(searchText) != -1) {

				var screeen = folder.screens[j], screenItem = document.createElement("li");
				var matches = screeen.title.match(new RegExp(searchText, "gi"));

				screenItem.setAttribute("data-icon", "<span class='mif-file-empty'>");
				screenItem.setAttribute("data-caption", screeen.title.replace(new RegExp(searchText, "gi"), "<span style='text-decoration: underline;'>" + matches[0] + "</span>"));
				screenItem.onclick = openScreena(screeen.id);

				var dateTokens = [];
				if(screeen.created_on) {

					var createdOn = new Date(screeen.created_on);
					var day = createdOn.getDate(), month = createdOn.getMonth() + 1, year = createdOn.getFullYear();
					dateTokens.push(day < 10 ? "0" + day : day);
					dateTokens.push(month < 10 ? "0" + month : month);
					dateTokens.push(year);
				}

				screenItem.setAttribute("data-date", dateTokens.join("/"));
				screensList.append(screenItem);
			}
		}
	}

	$listScreenDialogContent.empty().append(screensList);
}

function showFolders() {

	currentFolder = null;
	$("#screens-list-filter").val("");

	$("#all-available-screens").show();
	$("#back-to-previous-list").hide();

	var screensList = document.createElement("ul");
	screensList.setAttribute("data-role", "listview");
	screensList.setAttribute("data-view", "table");
	screensList.setAttribute("data-structure", '{"date": true}');

	for(var i = 0; i < folders.length; i++) {
		var folder = folders[i];
		if(folder.user) {

			var screenItem = document.createElement("li");
			screenItem.setAttribute("data-icon", "<span class='mif-folder fg-orange'>");
			screenItem.setAttribute("data-caption", folder.user);
			screenItem.onclick = (function(f) {return function(){showFolder(f);};})(folder);

			screensList.append(screenItem);

		} else {

			for(var j = 0; j < folder.screens.length; j++) {

				var screeen = folder.screens[j], screenItem = document.createElement("li");

				screenItem.setAttribute("data-icon", "<span class='mif-file-empty'>");
				screenItem.setAttribute("data-caption", screeen.title);
				screenItem.onclick = openScreena(screeen.id);

				var dateTokens = [];
				if(screeen.created_on) {

					var createdOn = new Date(screeen.created_on);
					var day = createdOn.getDate(), month = createdOn.getMonth() + 1, year = createdOn.getFullYear();
					dateTokens.push(day < 10 ? "0" + day : day);
					dateTokens.push(month < 10 ? "0" + month : month);
					dateTokens.push(year);
				}

				screenItem.setAttribute("data-date", dateTokens.join("/"));
				screensList.append(screenItem);
			}
		}
	}

	$listScreenDialogContent.empty().append(screensList);
}

function showFolder(folder) {

	currentFolder = folder;

	$("#screens-list-filter").val("");

	var screensList = document.createElement("ul");
	screensList.setAttribute("data-role", "listview");
	screensList.setAttribute("data-view", "table");
	screensList.setAttribute("data-structure", '{"date": true}');

	for(var j = 0; j < folder.screens.length; j++) {

		var screeen = folder.screens[j], screenItem = document.createElement("li");

		screenItem.setAttribute("data-icon", "<span class='mif-file-empty'>");
		screenItem.setAttribute("data-caption", screeen.title);
		screenItem.onclick = openScreena(screeen.id);

		var dateTokens = [];
		if(screeen.created_on) {

			var createdOn = new Date(screeen.created_on);
			var day = createdOn.getDate(), month = createdOn.getMonth() + 1, year = createdOn.getFullYear();
			dateTokens.push(day < 10 ? "0" + day : day);
			dateTokens.push(month < 10 ? "0" + month : month);
			dateTokens.push(year);
		}

		screenItem.setAttribute("data-date", dateTokens.join("/"));
		screensList.append(screenItem);
	}

	$listScreenDialogContent.empty().append(screensList);

	$("#all-available-screens").add("#back-to-previous-list").toggle();
}

var folders = [], currentFolder = null;
function listScreens(e) {

	$.ajax({
		url: screenLoader,
		method: "POST",
		data: {list: ""},
		error: function(jqXHR, textStatus, errorThrown) {
			console.log("error", jqXHR, textStatus, errorThrown);
		},
		success: function(data, textStatus, jqXHR) {

			var foldersMap = {}, screensWithoutUser = {user: null, screens: []};

			folders = [];
			folders.push(screensWithoutUser);

			for(var i = 0; i < data.length; i++) {

				var screen = data[i], folder = foldersMap[screen.username];
				if(!folder) {
					if(!screen.username) {
						folder = screensWithoutUser;
					} else {
						folder = {user: screen.username, screens: []};
						folders.push(folder);
						foldersMap[screen.username] = folder;
					}
				}

				folder.screens.push(screen);
			}

			folders.sort(function(a, b) {

				if(!a.user && !b.user) {
					return 0;
				} else if(!a.user) {
					return 1;
				} else if(!b.user) {
					return -1;
				}

				var userA = a.user.toUpperCase();
				var userB = b.user.toUpperCase();

				if(userA < userB) {
					return -1;
				}

				if(userA > userB) {
					return 1;
				}

				return 0;
			});

			showFolders();
			Metro.dialog.open("#screens-list-dialog");
		}
	});
}

function openScreen(externalId, readOnly) {
	// console.log('openScreen(), externalId',externalId);
	$.ajax({
		url: screenLoader,
		method: "POST",
		data: {openScreenId: externalId},
		error: function(jqXHR, textStatus, errorThrown) {
			//TODO show a nice error modal
			console.log("error", jqXHR, textStatus, errorThrown);
		},
		success: function(data, textStatus, jqXHR) {
			var alreadyOpened;
			for(var i = 0; i < screens.length; i++) {
				var screen = screens[i];
				if(screen.externalId == data.id) {

					activeScreen = screen;

					if(screen.isChanged && confirm("Do you really want to overwrite \"" + data.name + "\"?")) {
						while(screen.cmpts.length > 0) {
							designer.removeCmpt(screen.cmpts[0].getId());
						}

						//for(var i = 0; i < data.cmpts.length; i++) {
						designer.buildScreen(data.cmpts, readOnly);
						//}
					}

					$(screen.tab.header.firstChild).trigger("click");
					alreadyOpened = true;
					break;
				}
			}

			if(!alreadyOpened) {

				//document.getElementById("screen-name").value = data.name;

				activeScreen = createScreen(data.name, true, data.id);

				//for(var i = 0; i < data.cmpts.length; i++) {
				designer.buildScreen(data.cmpts, readOnly);
				//}
			}
			//$screensListModal.modal("hide");    
			Metro.dialog.close("#screens-list-dialog");
			// if (typeof hideControls == 'function') hideControls();
		}
	});
}

function saveScreen(e) {

	var data = {content: JSON.stringify(designer.getActiveScreenCmptsPropsToObject())};
	var screenToSave = activeScreen;

	var doSave = function() {
		$.ajax({
			url: screenLoader,
			method: "POST",
			data: data,
			error: function(jqXHR, textStatus, errorThrown) {
				console.log("error", jqXHR, textStatus, errorThrown);
			},
			success: function(data, textStatus, jqXHR) {
				var notify = Metro.notify;   
				notify.setup({
					width: 300,
					timeout: 2500,
					distance: 2
				});
				notify.create("Screen has been correctly saved", "Saved", {
					cls: "success no-border"
				});

				screenToSave.externalId = data.id;
				screenToSave.name = data.name;
				screenToSave.isChanged = false;

				$("a", screenToSave.tab.header).get(0).innerHTML = screenToSave.name;
				screenToSave = null;
			}
		});
	};

	if(screenToSave.externalId != null) {

		data.update = "";
		data.id = screenToSave.externalId;
		data.name = screenToSave.name;

		doSave();

	} else {

		data.save = "";

		Metro.dialog.create({
			title: "Screen Name",
			content: "<div class='form-group'><input id='save-screen-name' type='text'></div>",
			actions: [{
				caption: "Save",
				cls: "js-dialog-close primary",
				onclick: function(dialog){
					data.name = $("#save-screen-name", dialog).val();
					doSave();
				}
			},{
				caption: "Close",
				cls: "js-dialog-close",
				onclick: function(){}
			}]
		});
	}
}

function saveScreenAs() {

	var data = {content: JSON.stringify(designer.getActiveScreenCmptsPropsToObject())};
	var screenToSave = activeScreen;

	var doSave = function() {
		$.ajax({
			url: screenLoader,
			method: "POST",
			data: data,
			error: function(jqXHR, textStatus, errorThrown) {
				console.log("error", jqXHR, textStatus, errorThrown);
			},
			success: function(data, textStatus, jqXHR) {
				var notify = Metro.notify;   
				notify.setup({
					width: 300,
					timeout: 3000
				});
				notify.create("Screen has been correctly saved", "Saved", {
					cls: "success no-border"
				});

				screenToSave.externalId = data.id;
				screenToSave.name = data.name;
				screenToSave.isChanged = false;

				$("a", screenToSave.tab.header).get(0).innerHTML = screenToSave.name;
				screenToSave = null;
			}
		});
	};

	Metro.dialog.create({
		title: "Screen Name",
		content: "<div class='form-group'><input id='save-screen-name' type='text'></div>",
		onOpen: function(dialog) { $("#save-screen-name", dialog).val(activeScreen.name); },
		actions: [{
			caption: "Save",
			cls: "js-dialog-close primary",
			onclick: function(dialog){
				data.save = "";
				data.name = $("#save-screen-name", dialog).val();
				doSave();
			}
		},{
			caption: "Close",
			cls: "js-dialog-close",
			onclick: function(){}
		}]
	});
}






	function getDate(ts) {
		const m = new Date(ts && ts>0? ts*1000: Date.now());
		var sec = m.getUTCSeconds();
		if (sec < 10) sec = `0${sec}`;
		var min = m.getUTCMinutes();
		if (min < 10) min = `0${min}`;
		return `${m.getUTCDate()}/${m.getUTCMonth() + 1}/${m.getUTCFullYear()} ${m.getUTCHours()}:${min}:${sec} UTC`;
	}

	function sseListener(event) {
		console.log(getDate()+' sseListener()', event);
		if (event.data === undefined) {
			console.log(getDate()+' PWMA Warning: missing event.data ',event);
			return;
		}
		const eventData = JSON.parse(event.data);
		if (eventData[0].src=='' && eventData[0].type=="heartbeat") console.log(getDate()+' - heartbeat');
		// else console.log(getDate()+' sseListener() ', eventData[0].value, eventData[0].src, eventData, event);
		if (eventData[0].src !== undefined) { // && eventData.data.error !== undefined && ((eventData.data.error == '' && eventData.data.value !== undefined) || eventData.data.error != '')) {
			label = eventData[0].src;
			val = eventData[0].value;
		}
		else {
			console.log(getDate()+' PWMA Warning: undetected eventData ',eventData);
			return;
		}
				var value = val;
				var srcsMapEntry = srcsMap[label];
				console.log('subscribeVar(), srcsMap, val', srcsMap, val);
				if (srcsMapEntry && srcsMapEntry.cmpts) {
					srcsMapEntry.values.push({date: new Date(), value: value});
					var cmpts = srcsMapEntry.cmpts;
					for(var i = 0; i < cmpts.length; i++) {
						console.log('subscribeVar(), value', value);
						cmpts[i].update(value);
					}
				}
		/*
		const ids = dataSrc[label];
		if (ids) for (i=0; i<ids.length; i++) {
			var delay = Math.abs(eventData[0].timestamp_ms - Date.now()/1000) > 2? '\nReceived: '+getDate(): '';
			const value = ($('#'+ids[i]).attr('data-src') && $('#'+ids[i]).attr('data-src').indexOf('[') > -1)? val[$('#'+ids[i]).attr('data-src').split('[')[1].split(']')[0]]: val;
			$('#'+ids[i]).attr("title", 'Value: '+val+'\nLast update: '+getDate(eventData[0].timestamp_ms)+delay+'\nUpdate method: SSE\n'); // Src: '+$('#'+ids[i]).attr('data-src')+'\nId: '+ids[i]+'\nError: '+eventData.data.error+'\nQuality: '+eventData.data.quality);
			if (typeof window[$('#'+ids[i]).attr('data-onUpdate')] === 'function') {
				window[$('#'+ids[i]).attr('data-onUpdate')](value, ids[i], eventData[0].timestamp_ms, eventData[0].quality);
			}
			else if ($('#'+ids[i]).prop("tagName") == 'INPUT') {
				if ($('#'+ids[i]).attr("type") == 'checkbox') $('#'+ids[i]).prop('checked', value);
				else $('#'+ids[i]).val($.isNumeric(value) ? value.toFixed(2): value);
			}
			else if ($('#'+ids[i]).prop("tagName") == 'IMG') {
				$('#'+ids[i]).attr("src", value == false || value === 'false' ? './img/ledred.png': './img/ledgreen.png');
			}
			else { // if ($('#'+ids[i]).prop("tagName") == 'TEXTAREA') {
				$('#'+ids[i]).html(value);
			}
			if (typeof tangoThresholds[ids[i]] === "object") {
				if (value < tangoThresholds[ids[i]].min_alarm || value > tangoThresholds[ids[i]].max_alarm) {
					$('#'+ids[i]).css('background-color', 'Red');
					$('#'+ids[i]).css('color', 'White');
				}
				else if (value < tangoThresholds[ids[i]].min_warning || value > tangoThresholds[ids[i]].max_warning) {
					$('#'+ids[i]).css('background-color', 'Yellow');
					$('#'+ids[i]).css('color', 'Black');
				}
				else {
					$('#'+ids[i]).css('background-color', 'White');
					$('#'+ids[i]).css('color', 'Black');
				}
			}
		}
		*/
		if ($('#lastUpdated').get(0)) $('#lastUpdated').val(getDate()); 
	}

	function subscribeVar(dataSrc) {
		console.log('subscribeVar()', dataSrc.substring(8));
		fetch(subscribeServer, {
			method: 'POST',
			// mode: "no-cors",
			// body: '{"channel":"rchan","srcs":['+dataSrc.substring(8)+'],"type":"srcs"}\r\n\r\n'
			body: '{"channel":"rchan","srcs":[{"method":"s","options":["p"],"src":"'+dataSrc+'"}]}\r\n\r\n'
		})
		.then((response) => {
			if (response.status>=300) {
				console.log('PUMA Error, response', response);
			}
			else {
				return response.text();
				// return response.json();
			}  
		})
		.then((eventData) => {
			// console.log('subscribeVar(), eventData', eventData);
			const data = JSON.parse(eventData);
			console.log('subscribeVar(), data', data[0].src, data[0].value);
			for (subscribedIndex=0; subscribedIndex<data.length; subscribedIndex++) {
				console.log('subscribeVar(), PUMA OK, subscribedIndex, data.value', subscribedIndex, data[subscribedIndex].value, data[subscribedIndex]);
				var value = data[0].value;
				var srcsMapEntry = srcsMap[data[0].src];
				console.log('subscribeVar(), srcsMap', srcsMap);
				if (srcsMapEntry && srcsMapEntry.cmpts) {
					srcsMapEntry.values.push({date: new Date(), value: value});
					var cmpts = srcsMapEntry.cmpts;
					for(var i = 0; i < cmpts.length; i++) {
						cmpts[i].update(value);
					}
				}
			}
		});
	}


var source = new EventSource(sseServer);
source.onmessage = sseListener;






// ------------
// tree.js
// ------------

var globalVal;
var globalLabel;
var filter;
function myFunnyTree() {

	// INIT
	var $_GET = getQueryParams(document.location.search);
	if (typeof($_GET['conf']) !== 'undefined') {
		document.getElementById('conf').value = $_GET['conf'];
		initConf($_GET['conf']);
	}
	else {
		initConf(false);
	}
	initTree($_GET);
	console.log('treeService', treeService);

	// Setup the dnd listeners.
	/*var dropZone = document.getElementById('formula');
	dropZone.addEventListener('dragover', handleDragOver, false);
	dropZone.addEventListener('drop', handleTreeSelect, false);

	if (typeof($_GET['formula']) !== 'undefined') {
		var myPopup = new popup('https://pwma.elettra.eu/formulaeditor/formula_editor.html?conf='+$_GET['conf'], 'formula', 'width=670,height=800');
		myPopup.open();
	}*/
}

function popup(location, title, params) {
	newwindow=window.open(location,title,'height=800,width=400');
	if (window.focus) {newwindow.focus()}
	return false;
}

function extractTimeseries(dropData) {
	myproperty = dropData.split('</property>');
	mystring = myproperty[0].split('string>');
	myts = mystring[1].split('<');
	return myts[0];
}

function initTree($_GET) {
	if (!$('#tree').length) return;
	var source_url = treeService;
	$("#tree").fancytree({
		autoScroll: true,
		source: {
			url: source_url + (filter ? "&filter=" + filter : "")
		},
		lazyLoad: function(event, data) {
			var node = data.node;
			// Issue an ajax request to load child nodes
			data.result = {
				url: treeService + (filter ? "&filter=" + filter : ""),
				data: {key: node.key}
			}
			console.log('lazyLoad::data', data);
		},
		click: function(event, data) {

			if(data.node.children || data.node.folder || (data.targetType != "icon" && data.targetType != "title")) {
				return true;
			}

			console.log('click::data', data);
			if (data.targetType == 'icon' || data.targetType == 'title') { //expander || icon || title
				// console.log('click::data.node.key', data.node.key);
				if (data.node.key.indexOf('formula') == 0) {
					const formula = data.node.key.split('/').slice(-1)[0];
					if (document.getElementById('formula').value=='name') {
						catchVarName('formula/'+formula);
					}
					else {
						// console.log(`fetch(./tree.php?formula=${formula})`);
						fetch(`https://pwma.elettra.eu/formulaeditor/tree.php?formula=${formula}`)
							.then(response => {
							if (response.status>=300) {
								console.log('PWMA Error: ', response, obj);
							}
							else {
								return response.json();
							}  
						})
							.then((eventData) => {
							catchVarName(eventData);
						});
					}
				}
				else {
					catchVarName(data.node.key);
				}

			}
			return true;// Allow default processing
		},
		clickFolderMode: 2,
		persist: true
	});
}

function getQueryParams(qs) {
	qs = qs.split("+").join(" ");
	var params = {},
		tokens,
		re = /[?&]?([^=]+)=([^&]*)/g;
	while (tokens = re.exec(qs)) {
		params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
	}
	return params;
}

function handleTreeSelect(evt) {
	console.log('handleTreeSelect');
	evt.stopPropagation();
	evt.preventDefault();
	attr = extractTimeseries(evt.dataTransfer.getData("text"));
	// attr = evt.dataTransfer.getData('application/taurus-device'); does this work with taurus?
	addTs = evt.dataTransfer.dropEffect=='copy';
	console.log('get', treeService+'&searchkey='+attr);
	$.get(treeService+'&searchkey='+attr, function(data) {
		if (typeof(data[0]) !== 'undefined') {
			// console.log(document.getElementById('ts').value);
			var ts = (addTs && document.getElementById('ts').value.length)? document.getElementById('ts').value+';'+data[0]: data[0];
			updateLink(ts);
			document.getElementById('ts').value = ts;
		}
	});
}

function handleDragOver(evt) {
	console.log(evt);
	evt.stopPropagation();
	evt.preventDefault();
	evt.dataTransfer.dropEffect = 'plot'; // Explicitly show this is a copy.
}

function strtr(myString, replaceArray){
	var oldString ;
	for (var i in replaceArray) {
		oldString = '';
		while (myString !== oldString) {
			oldString = myString;
			myString = oldString.replace(i,replaceArray[i]);
		}
	}
	return myString;
}

function catchVarName(param) {

	var $src = $("#edit-cmpt-section-fields [id$=src]");
	$src.get(0).value = param;

	var cmpt = cmptsMapById[$src.attr("id").replace("-src", "")];

	if(cmpt.category == designer.categories.SCALARS) {
		getSrcInfo(param, cmpt);
	} else if(cmpt.category == designer.categories.ARRAYS) {
		cmpt.realUpdate = cmpt.update; cmpt.update = tmpHack; cmpt.update.cmpt = cmpt;
		subscribeSrc(cmpt, param);
	}

	fancyTreeContainer.toggle();
}

var tmpHack = function(values) {
	if(values == 'n.a.') return; console.log(values);

	var flagsContainer = document.getElementById("flags-container");
	flagsContainer.style.display = "block";

	flagsContainer.innerHTML = "";

	for(var j = 0; j < values.length; j++) {

		var flagContainer = document.createElement("div");
		flagContainer.className = "form-group";

		var flagLabel = document.createElement("label");
		flagLabel.appendChild(document.createTextNode("Flag-" + j));
		flagContainer.appendChild(flagLabel);

		var flagInput = document.createElement("input");
		flagInput.id = tmpHack.cmpt.getId() + "-flag-" + j;
		flagInput.type = "text";
		flagContainer.appendChild(flagInput);

		flagsContainer.appendChild(flagContainer);
	}

	if(values.length > 0) {
		tmpHack.cmpt.update = function() {};
		tmpHack.cmpt.update = tmpHack.cmpt.realUpdate;
	}
}


function sitemapScreen(e) {

	if(activeScreen.externalId == null) {
		Metro.infobox.create("<p>Screen must be saved</p>", "alert");
	} else {

		$.ajax({
			url: 'https://pwma-dev.elettra.eu/starter.php?append&id=' + activeScreen.externalId,
			method: "GET",
			//data: data,
			error: function(jqXHR, textStatus, errorThrown) {
				console.log("error", jqXHR, textStatus, errorThrown);
			},
			success: function(data, textStatus, jqXHR) {
				var notify = Metro.notify;   
				notify.setup({
					width: 300,
					timeout: 2500,
					distance: 2
				});
				notify.create("Screen has been correctly appended to starter", "Saved", {
					cls: "success no-border"
				});
			}
		});
	}
}

/*
 * SCREEN PREVIEW CODE
 */
function enterPreviewMode() {
	
	vm.show();
	document.addEventListener("keyup", onEscapeClickedExitPreviewMode);
}

function onEscapeClickedExitPreviewMode(e) {
	  
	if(e.code === "Escape") {
		vm.hide();
		document.removeEventListener("keyup", onEscapeClickedExitPreviewMode);  
	}
}

var buildXXX = function(cmpt, gridStack) {
				
	var width = cmpt.getWidth(), height = cmpt.getHeight();
	var x = cmpt.getX(), y = cmpt.getY();

	var placeholderWidget = $(
		"<div class='grid-stack-item' data-gs-width='" + width + "' " +
		"                             data-gs-height='" + height + "'>" +
		"  <div class='grid-stack-item-content' style='border: thin solid #d3d3d3;'>" +
		"    <div>" +
		"      <div class='cmpt-header'>" +
		"        <span class='cmpt-header-text'>" + name + "</span>" +
		"      </div>" +
		"    </div>" +
		"  </div>" +
		"</div>");

	gridStack.addWidget(placeholderWidget, x, y);
	
	//build cmpt
	if(cmpt.getChildren() && cmpt.getChildren().length > 0) {
	
		var $ccc = $("<div class='grid-stack'></div>");
		$(".cmpt-header", placeholderWidget).after($ccc);
		$ccc = $ccc.gridstack({
			float: true
		}).data('gridstack');	
		
		for(var i = 0; i < cmpt.getChildren().length; i++) {
			buildXXX(cmpt.getChildren()[i], $ccc);
		}
	}
};

var previewGridStack;

var vm = new Vue({
	el: "#preview",
	data: {
		isVisible: false
	},
	methods: {
		show: function() {
			
			this.isVisible = true;
			
			var currentScreen = designer.tmpXXX();
			for(var i = 0; i < currentScreen.cmpts.length; i++) {
				buildXXX(currentScreen.cmpts[i], previewGridStack);
			/*
				var name = currentScreen.cmpts[i].getCmptName();
				
				var width = currentScreen.cmpts[i].getWidth(), height = currentScreen.cmpts[i].getHeight();
				var x = currentScreen.cmpts[i].getX(), y = currentScreen.cmpts[i].getY();
				
				var placeholderWidget = $(
					"<div class='grid-stack-item' data-gs-width='" + width + "' " +
					"                             data-gs-height='" + height + "'>" +
					"  <div class='grid-stack-item-content' style='border: thin solid #d3d3d3;'>" +
					"    <div>" +
					"      <div class='cmpt-header'>" +
					"        <span class='cmpt-header-text'>" + name + "</span>" +
					"      </div>" +
					"    </div>" +
					"  </div>" +
					"</div>");
			
				previewGridStack.addWidget(placeholderWidget, x, y);*/
			}
			
			previewGridStack.disable(); setTimeout(function() { document.getElementById("aaa").style.opacity = 0; }, 3000)
		},
		hide: function() {
			
			this.isVisible = false;
			
			previewGridStack.enable();
			previewGridStack.removeAll();
		}
	},
	mounted: function() {
			
		previewGridStack = $("#preview-grid-stack").gridstack({
			//TODO float serve altrimenti la griglia non si insgrandisce
			float: true
		}).data('gridstack');	
	
	},
	template:
		"<div v-show='isVisible' style='background: white; position: absolute; height: 1000px; width: 100%; top: 0; left: 0; z-index: 1000;'>" +
	    "  <div style='margin: 20px 15px;'>" + 
		"    <div id='aaa' style='position: fixed; width: 100%; top: 0; left: 0; transition: opacity 2s ease-in-out;'>" +
		"      <div style='background: #777; color: white; margin: 10px auto; width: 300px; padding: 10px 0; text-align: center; font-size: 1.1em; z-index: 1000;'>" +
		"        Press <span style='border: 2px solid #ddd; padding: 2px 4px;'>ESC</span> to exit Preview Mode" +
	    "      </div>" +
	    "    </div>" +
	    "    <div id='preview-grid-stack' class='grid-stack'></div>" +
	    "  </div>" +
		"</div>"
});

//https://github.com/OfficeDev/office-ui-fabric-core

/*
padding: 0 1rem 0 3.75rem;
line-height: .875rem;
text-decoration: none;
display: block;
position: relative;
height: 52px;
background-color: inherit;
color: inherit;
width: 100%;
*/