<!doctype html>
<html lang="en">
	<head>
		<title>Knob admin</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<link rel="stylesheet" href="../lib/bootstrap4/bootstrap.min.css">
		<script src="../lib/bootstrap4/jquery.slim.min.js"></script>
		<script src="../lib/bootstrap4/bootstrap.bundle.min.js"></script>	
	</head>
	<body>
<?php
	// require_once('./conf/conf.php');
	define("TMPFILE", '/run/knob/launch_');
	define("LOGFILE", './log/admin_');
	define('ELETTRA_LDAP_SERVER', 'ldap.elettra.eu');
	define('ELETTRA_LDAP_DN', 'ou=People,dc=elettra,dc=eu');
	require_once("../conf.php");
	require_once("../uti.php");
	$sql = open_db();
	$username = '';

	//-----------------------------------------------------------------------------
	function elettra_ldap_auth($_username, $_password) {
		$elettra_ldap_error = false;
		$ldap_url = 'ldaps://'.ELETTRA_LDAP_SERVER.':636/';
		if (!function_exists('ldap_connect')) {
			$elettra_ldap_error = "LDAP module not installed in PHP";
			return $elettra_ldap_error;
		}
		$ldap = ldap_connect($ldap_url);
		$elettra_ldap_error = "$ldap_url\n";
		if (!$ldap) {
			$elettra_ldap_error = "Could not connect to $ldap_url";
			return $elettra_ldap_error;
		}
		ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
		$password = trim(stripslashes($_password));
		$username = trim(stripslashes($_username));
		if (empty($password)) {
			@ldap_close($ldap);
			$elettra_ldap_error = "empty password";
			return $elettra_ldap_error;
		}
		if ($ldap) {
			$user_search = ldap_search($ldap, ELETTRA_LDAP_DN, "(uid=$username)");
			if (!$user_search) {
				$elettra_ldap_error ="Error in search query ($ldap_url): ".ldap_error($ldap);
				return $elettra_ldap_error;
			}
			$user_get = ldap_get_entries($ldap, $user_search);
			if (!$user_get) {
				$elettra_ldap_error = 'user not found';
				@ldap_close($ldap);
				return $elettra_ldap_error;
			}
			$user_entry = ldap_first_entry($ldap, $user_search);
			if (!$user_entry) {
				$elettra_ldap_error = 'user not found';
				@ldap_close($ldap);
				return $elettra_ldap_error;
			}
			$user_dn = ldap_get_dn($ldap, $user_entry);
			if (!$user_dn) {
				$elettra_ldap_error = 'user not found';
				@ldap_close($ldap);
				return $elettra_ldap_error;
			}
			if (@ldap_bind($ldap, $user_dn, $password)) {
				$elettra_ldap_error = 'alias';
				if ($user_get && $user_get['count']) {
					// $login = array('realname' => $user_get[0]['cn'][0]);
					$elettra_ldap_error = 'Login OK';
				}
				@ldap_close($ldap);
			} 
			else {
				$elettra_ldap_error = 'Attention! Wrong password, please try again';
				@ldap_close($ldap);
				return $elettra_ldap_error;
			}
		} 
		else {
			$elettra_ldap_error = 'ldap connection';
		}
		return $elettra_ldap_error;
	}
	// ----------------------------------------------------------------
	// check access as administrator
	function check_admin_access() {
		global $debug, $sql, $username;
		$remote = $_SERVER['REMOTE_ADDR'];
		$forwarded = isset($_SERVER['HTTP_X_FORWARDED_FOR'])? $_SERVER['HTTP_X_FORWARDED_FOR']: 0;
		session_start();
		$yy = date('Y');
		if (isset($_REQUEST['logout'])) {
			$_SESSION['token'] = '';
			die("<script>document.location='./index.php';</script>");
		}
		else if (empty($_REQUEST['elettra_ldap_email']) && isset($_SESSION['token'])) {
			$webtokenExpirationSeconds = 36000; // 10 hh
			$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND EXTRACT(EPOCH FROM NOW()-date)<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
			if (empty($data)) {sleep(2); if (isset($_REQUEST['debug'])) echo "IP: $remote<br>"; emit_nav(''); die("<form method='post' action='?'>username <input type='text' name='elettra_ldap_email'><br><br>password <input type='password' name='elettra_ldap_password'> <input type='submit'></form></div></body></html>\n");}
			$username = $data[0]['username'];
			return;	  
		}
		if (isset($_REQUEST['elettra_ldap_email']) and isset($_REQUEST['elettra_ldap_password'])) {
			$email = $_REQUEST['elettra_ldap_email'];
			$password = $_REQUEST['elettra_ldap_password'];
			$r = elettra_ldap_auth($email, $password);
			if ($r != "Login OK") {emit_nav(''); die("login failed<br>$r<br>");}
			for ($i=0,$token=""; $i<5; $i++) {
				$token .= sprintf("%02x", rand(0, 256));
			}
			$_SESSION['token'] = $token;
			$data = $sql->sql_secure("INSERT INTO userlog_$yy (date,webtoken,username,ip) VALUES (NOW(),$1,$2,$3)", array($token, $email, $_SERVER['REMOTE_ADDR']));
			$username = $email;
		}
		else {			
			emit_nav('');
			die("Please enter Elettra credentials<br><br><form method='post' action='?'>username <input type='text' name='elettra_ldap_email'><br><br>password <input type='password' name='elettra_ldap_password'><br><br><input type='submit' value='submit'></form><br /></div></body></html>\n");
		}
	}
	function emit_nav($username) {
		$u = empty($username)? '': "<span style='color: black; margin-right: 1em;'>welcome $username</span><a class='btn btn-primary' href='?logout'>logout</a>";
		echo "		<nav class='navbar navbar-expand-sm bg-dark navbar-dark justify-content-end' style='background-color: #d9edf7 !important;'>
			<ul class='navbar-nav mr-auto' id='text'><li><table><tr>
				<td><a href='./index.php' border='0'><img src='../img/puma.svg' class='media-object' style='width:40px;height:40px; margin-left: -12px;'></a>
				<td><a href='./admin.php'><h2 style='color: black;'>Admin</a><td>
			</tr></table></li></ul> $u
		</nav>
		<div style='margin: 10px;'>\n";
	}

	check_admin_access();
	emit_nav($username);
	$yy = date('Y');
	$emergency = file_get_contents(TMPFILE."emergency");
	$remote_ip = $_SERVER['REMOTE_ADDR'];
	$remote_host = gethostbyaddr($ip);
	if (isset($_REQUEST['stop'])) {
		if (empty($emergency) || strpos($emergency,'stop')===false) {
			file_put_contents(TMPFILE.'emergency', 'stop');
			$emergency = 'stop';
			file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." STOP by $username from $remote_ip $remote_host\n", FILE_APPEND | LOCK_EX);
		}
	}
	if (isset($_REQUEST['log'])) {
		file_put_contents(LOGFILE.'access_'.$yy.'.log', date('Y-m-d H:i:s')." {$_REQUEST['log']} by $username from $remote_ip $remote_host\n", FILE_APPEND | LOCK_EX);
		$year = isset($_REQUEST['year'])? $_REQUEST['year']-0: $yy;
		echo "<pre>";
		readfile("./log/{$_REQUEST['log']}_$year.log");
		die("</pre>");
	}
	if (isset($_REQUEST['start'])) {
		if (strpos($emergency,'stop')!==false) {
			$d = dirname(TMPFILE);
			$dir = scandir($d);
			foreach ($dir as $f) {
				if (strpos($f, 'launch')===false || strpos($f, 'seed')!==false || strpos($f, 'emergency')!==false) continue;
				file_put_contents("$d/$f", '');
			}
			file_put_contents(LOGFILE.$yy.'.log', date('Y-m-d H:i:s')." START by $username from $remote_ip $remote_host\n", FILE_APPEND | LOCK_EX);
			file_put_contents(TMPFILE.'emergency', '');
			unlink(TMPFILE.'emergency');
			$emergency = '';
		}
	}
	$launcher = in_array($username, $admin_knob)? "<br><br><br>edit wLauncher JSON <a class='btn btn-success' href='https://puma-01.elettra.eu/lib/fm.php?open_editor=/var/www/html/knob/conf/launcher.json' target='_blank'>local</a> <a class='btn btn-danger' href='https://gitlab.elettra.eu/puma/client/web/-/blob/master/knob/conf/launcher.json' target='_blank'>repo</a><br><br>
	<br><br><iframe src='https://pwma.elettra.eu/knob' style='width: 100%; height: 700px; border:0; margin: -10px;'></iframe><br><br><iframe src='https://pwma.elettra.eu/knob/index.php?elettra' style='width: 100%; height: 700px; border:0; margin: -10px;'></iframe>": '';
	$stat = (strpos($emergency,'stop')!==false)? "<h2>Launcher and knobs are STOPPED!</h2><br><br><a class='btn btn-danger' href='./admin.php?start'>RESTART</a>": "<h3>Launcher and knobs are running</h3>press emergency button to stop the service<br><br><img src='./img/emergency_stop.jpg' style='cursor: pointer;' onclick=\"document.location='./admin.php?stop';\"><br><br>";
	echo "$stat<br>Warning: all actions are logged and monitored<br><br>
		logs:&nbsp;&nbsp;&nbsp;<a class='btn btn-primary' href='?log=launchwheel'>knob</a> <a class='btn btn-primary' href='?log=launch'>launcher</a> <a class='btn btn-primary' href='?log=admin'>admin</a><br><br>
		$launcher</div></body></html>\n";

?>
