	var setTime = 0;
	var throttlingTimer = null;
	var throttlingPeriod = 100;
	if (document.location.search.indexOf('throttlingPeriod=')>-1) throttlingPeriod = document.location.search.split('throttlingPeriod=')[1].split('&')[0]-0;
	var extcolor = '#fff';
	if (document.location.search.indexOf('extcolor=')>-1) extcolor = document.location.search.split('extcolor=')[1].split('&')[0].replace('%23','#');
	var extbackground = '#00a';
	if (document.location.search.indexOf('extbackground=')>-1) extbackground = document.location.search.split('extbackground=')[1].split('&')[0].replace('%23','#');
	var exthighlight = '#00e';
	if (document.location.search.indexOf('exthighlight=')>-1) exthighlight = document.location.search.split('exthighlight=')[1].split('&')[0].replace('%23','#');
	var intcolor = '#fff';
	if (document.location.search.indexOf('intcolor=')>-1) intcolor = document.location.search.split('intcolor=')[1].split('&')[0].replace('%23','#');
	var intbackground = '#080';
	if (document.location.search.indexOf('intbackground=')>-1) intbackground = document.location.search.split('intbackground=')[1].split('&')[0].replace('%23','#');
	var inthighlight = '#0b0';
	if (document.location.search.indexOf('inthighlight=')>-1) inthighlight = document.location.search.split('inthighlight=')[1].split('&')[0].replace('%23','#');
	var maxval = 10;
	if (document.location.search.indexOf('max=')>-1) maxval = document.location.search.split('max=')[1].split('&')[0]-0;
	var minval = 0;
	if (document.location.search.indexOf('min=')>-1) minval = document.location.search.split('min=')[1].split('&')[0]-0;
	var apply = false;
	if (document.location.search.indexOf('apply=')>-1) apply = document.location.search.split('apply=')[1].split('&')[0];
	var buttapply = false;
	if (document.location.search.indexOf('buttapply=')>-1) buttapply = document.location.search.split('buttapply=')[1].split('&')[0];
	var direction = -1;
	if (document.location.search.indexOf('direction=')>-1) direction = document.location.search.split('direction=')[1].split('&')[0]-0;
	var decimal = 3;
	if (document.location.search.indexOf('decimal=')>-1) decimal = document.location.search.split('decimal=')[1].split('&')[0]-0;
	var r2only = false;
	if (document.location.search.indexOf('r2only=')>-1) r2only = document.location.search.split('r2only=')[1].split('&')[0];
	var dot = document.location.search.indexOf('dot')>-1;
	var dark = document.location.search.indexOf('dark')>-1;
	var lastset = minval;
	if (document.location.search.indexOf('debug')>-1) console.log('min', minval,'max', maxval);
	var radius = (document.location.search.indexOf('r=')>-1)? document.location.search.split('r=')[1].split('&')[0]-0: 150;
	var marginx = (document.location.search.indexOf('marginx=')>-1)? document.location.search.split('marginx=')[1].split('&')[0]-0: 5;
	var marginy = (document.location.search.indexOf('marginy=')>-1)? document.location.search.split('marginy=')[1].split('&')[0]-0: 10;
	var width = (radius + marginx) * 2;
	var height = (radius + marginy) * 2;
	var ringwidth = (document.location.search.indexOf('ringwidth=')>-1)? document.location.search.split('ringwidth=')[1].split('&')[0]-0: 40;
	var circle = 'r2';
	var factor = {'r1': maxval-minval, 'r2': Math.pow(10, (2-decimal))};
	var value = {'r1': minval, 'r2': 0};
	var decimals = {'r1': decimal-2, 'r2': decimal};
	var v0, x, y, x1, y1, x0, y0;
	function decimalPrecision(n, d) {return Math.round(n * Math.pow(10, d)) / Math.pow(10, d);}
	// https://stackoverflow.com/questions/9614109/how-to-calculate-an-angle-from-points#9614122
	function angle(cx, cy, ex, ey) {
		var dy = ey - cy;
		var dx = ex - cx;
		var theta = Math.atan2(dy, dx); // range (-PI, PI]
		theta *= 180 / Math.PI; // rads to degs, range (-180, 180]
		//if (theta < 0) theta = 360 + theta; // range [0, 360)
		return theta;
	}
	function svgAppend(svg, elementType, attributes, innerHTML)  {
		var elem = document.createElementNS("http://www.w3.org/2000/svg", elementType);
		for (var i in attributes) elem.setAttribute(i, attributes[i]);
		if (typeof innerHTML != 'undefined') elem.innerHTML = innerHTML;
		svg.appendChild(elem);
	}
	function ringAppend(svg, id, cx, cy, r, width, major, middle, minor, max, style) {
		var color = id=='r1'? extcolor: intcolor;
		svgAppend(svg, 'circle', {id: id+'c', cx: cx, cy: cy, r: r-width/2, style:style+width});
		var g = document.createElementNS("http://www.w3.org/2000/svg", 'g');
		g.setAttribute("id", id);
		svg.appendChild(g);
		for (var i=0; i<minor; i++) {
			svgAppend(g, 'line', {id: 'minor'+id+i, x1: cx, y1: marginy+radius-r, x2: cx, y2: marginy+radius-r+width/4, transform: "rotate("+(direction*(360/minor*i))+", "+(cx)+", "+(cy)+")", style: 'cursor: pointer; fill:none; stroke:'+color+';stroke-width:1'});
		}
		for (i=0; i<middle; i++) {
			svgAppend(g, 'line', {id: 'middle'+id+i, x1: cx, y1: marginy+radius-r, x2: cx, y2: marginy+radius-r+width/2, transform: "rotate("+(direction*(360/middle*i))+", "+(cx)+", "+(cy)+")", style: 'cursor: pointer; fill:none; stroke:'+color+';stroke-width:1'});
		}
		if (document.location.search.indexOf('debug')>-1) console.log('id',id,'factor',factor[id],'major',major,'max',max);
		var units = ['', 'm', '&#181;', 'n', 'p', 'f'];
		for (i=0; i<major; i++) {
			var d = decimal - 1;
			if (max<0.1) d = decimal;
			var val = ((r==radius && !r2only)? minval:0)+i*max/major;
			var aval = Math.abs(val);
			var d3 = 0;
			if (aval!=0) while (aval<0.01 && d3<units.length-1) {aval = aval*1000; val = val*1000; d3++;}
			val = decimalPrecision(val,d)+'';
			if (dot) val = val.replace('0.','.');
			if (document.location.search.indexOf('debug')>-1) console.log('d', d, 'val', val, 'max', max);
			if (val.length > 8) val = val.substring(0,5);
			svgAppend(g, 'text', {id: 'n'+id+i, x: cx, y: marginy+radius-r+width*0.8, transform: "rotate("+(direction*(360/major*i))+", "+(cx)+", "+(cy)+")", style: 'fill:'+color+';font-family:Serif;text-anchor: middle; font-size: 20;'}, val+units[d3]);
		}
	}
	function initFactor(maxval, minval, decimal)  {
		factor = {'r1': maxval-minval, 'r2': Math.pow(10, (2-decimal))};
	}
	function initRing(skipdraw, maxval, minval, decimal)  {
		if (skipdraw==true) initFactor(maxval, minval, decimal);
		var major = factor.r1*10;
		var middle = factor.r1*20;
		var minor = factor.r1*Math.pow(10,(decimal-2));
		while (major>40) major = major / 10;
		if (major>25) major = major / 2;
		middle = major*2;
		if (major<6) major = major * 2;
		minor = major*10;
		factor.r2 = r2only? r2only: factor.r1/minor;
		if (skipdraw!=true) {
			var svg = document.getElementsByTagName('svg')[0];
			var color = dark? 'yellow': 'blue';
			svgAppend(svg, 'line', {x1: marginx+radius, y1: marginy-10, x2: marginx+radius, y2: marginy+(r2only? 1: 2)*ringwidth+20, style: 'cursor: pointer; fill:'+color+'; stroke:'+color+';stroke-width:3'});
			if (!r2only) ringAppend(svg, 'r1', marginx+radius, marginy+radius, radius, ringwidth, major, middle, minor, factor.r1, 'cursor: pointer; fill:none; stroke:'+extbackground+';stroke-width:');
			ringAppend(svg, 'r2', marginx+radius, marginy+radius, radius-(r2only? 0: ringwidth+5), ringwidth, 10, 20, 100, factor.r2, 'cursor: pointer; fill:none; stroke:'+intbackground+';stroke-width:');
			svgAppend(svg, 'text', {id: 'value', x: marginx+radius, y: marginy+radius, style:'stroke:white; stroke-width:0.5em; fill:black; paint-order:stroke; stroke-linejoin:round;font-family:Serif;text-anchor: middle; font-size: 25px;'});
		}
		return factor.r2;
	}
	function setVal(v) {
		if (typeof v == 'undefined') {
			v = lastset;
			lastset = null;
			throttlingTimer = null;
		}
		var t = + new Date();
		$("#value").html(v);
		if (lastset != v && apply != false) {
			if (t - setTime > throttlingPeriod) {
				setTime = t;
				fetch('https://puma-01.elettra.eu/write.php?var='+apply+'&val='+v);
			}
			else if (throttlingTimer == null) {
				throttlingTimer = settimeout(setVal, throttlingPeriod+100);
			}
		}
		lastset = v;
	}
	function myload() {
		if (dark) $('body').css('background-color', 'black');
		// $('body').css('background-color', dark? 'black': 'white');
		if (document.location.search.indexOf('debug')>-1) {$('#v1').show();$('#v2').show();}
		var svg = document.getElementsByTagName('svg')[0];
		svg.setAttribute("width", (width) + "px");
		svg.setAttribute("height", (height) + "px");
		initRing();
		if (buttapply!=false) $('#value').css('cursor', 'pointer');
		var mc = new Hammer(document.body);
		mc.add(new Hammer.Pinch({ threshold: 0 })).recognizeWith(mc.get('pan'));
		// let the pan gesture support all directions. this will block the vertical scrolling on a touch-device while on the element
		mc.get('pan').set({ direction: Hammer.DIRECTION_ALL });
		// $('#e12')
		v0 = minval;
		if (document.location.search.indexOf('val=')>-1) v0 = document.location.search.split('val=')[1].split('&')[0]-0;
		/*
		value.r1 = Math.floor(v0*(10**(decimal-2)))/(10**(decimal-2));
		value.r2 = v0 - value.r1;
		if (r2only) {value.r2 = v0 % r2only; value.r1 = v0 - value.r2;}
		*/
		value.r2 = v0 % factor.r2; value.r1 = v0 - value.r2;
		if (document.location.search.indexOf('debug')>-1) console.log('value', value, 'factor', factor);
		x0=radius+marginx;
		y0=radius+marginy;
		a0=0;
		a1={'r1': -1*direction*(value.r1-minval)*360/(maxval-minval), 'r2': -1*direction*value.r2/factor.r2*360};
		$("#r1").attr("transform", "rotate("+(a1.r1)+" "+(radius+marginx)+" "+(radius+marginy)+")");
		$("#r2").attr("transform", "rotate("+(a1.r2)+" "+(radius+marginx)+" "+(radius+marginy)+")");
		setVal(v0);
		// mc.on("panstart panleft panright panup pandown tap press pinchstart pinchmove", function(ev) {
		mc.on("panstart panleft panright panup pandown panend tap press", function(ev) {
			if (ev.type == 'tap') {
				x = ev.center.x;
				y = ev.center.y;
				if (ev.target.id=='value' && buttapply!=false) {
					console.log($('#value').text());
					fetch(decodeURIComponent(buttapply)+$('#value').text());
					if ( self !== top ) {
						parent.postMessage(decodeURIComponent(buttapply)+$('#value').text(), '*');
					}
				}
			}
			else if (ev.type == 'panend') {
				$('#r1c').css('stroke',extbackground);
				$('#r2c').css('stroke',intbackground);
			}
			else if (ev.type == 'press' || ev.type == 'panstart') {
				x = ev.center.x;
				y = ev.center.y;
				var r2 = Math.pow(x-x0-marginx,2)+Math.pow(y-y0-marginy,2);
				if ((r2 > Math.pow(radius-ringwidth-10,2)) && (r2 < Math.pow(radius+5,2))) 
					circle='r1';
				else if ((r2 <= Math.pow(radius-ringwidth-10,2)) && (r2 > Math.pow(radius-2*ringwidth-20,2)))
					circle='r2';
				else {
					circle = '';
					return;
				}
				if (r2only) {if (circle=='r1') circle='r2'; else circle = ''; return;}
				$('#r1c').css('stroke',circle=='r1'? exthighlight: extbackground);
				$('#r2c').css('stroke',circle=='r2'? inthighlight: intbackground);
				a0 = angle(x, y, x0, y0)-a1[circle];
			}
			else {
				x1 = x + ev.deltaX;
				y1 = y + ev.deltaY;
				var newangle = angle(x1, y1, x0, y0) - a0;
				var remindtolerance = 80;
				var remindadjust = direction==-1? 0: -0.0001;
				if (document.location.search.indexOf('debug')>-1) console.log('a1.r2',a1.r2,(3600+a1.r2-0.0001)%360,'newangle',newangle,(3600+newangle)%360,'value.r1', value.r1, 'min',minval); 
				if (circle=='r2') {
					if ((3600+a1.r2+remindadjust)%360>(360-remindtolerance) && (3600+newangle)%360<remindtolerance && value.r1<maxval-factor.r2) {
						value.r1 = value.r1-(direction*factor.r2); 
						$("#r1").attr("transform", "rotate("+(direction*((value.r1-minval)/factor.r1*-360))+" "+(radius+marginx)+" "+(radius+marginy)+")");
					}
					if ((3600+a1.r2+remindadjust)%360<remindtolerance && (3600+newangle)%360>(360-remindtolerance) && value.r1>minval) {
						value.r1 = value.r1+(direction*factor.r2); 
						$("#r1").attr("transform", "rotate("+(direction*((value.r1-minval)/factor.r1*-360))+" "+(radius+marginx)+" "+(radius+marginy)+")");
					}
					a1.r1 = -1*direction*(value.r1-minval)*360/(maxval-minval);
				}
				// inhibit the passage from maxval to minval and viceversa
				if (circle=='r1') {
					if ((3600+a1.r1+remindadjust)%360>(360-remindtolerance) && (3600+newangle)%360<remindtolerance) {
						$("#"+circle).attr("transform", "rotate(0 "+(radius+marginx)+" "+(radius+marginy)+")");
						setVal(maxval);
						return;
					}
					if ((3600+a1.r1+remindadjust)%360<remindtolerance && (3600+newangle)%360>(360-remindtolerance)) {
						$("#"+circle).attr("transform", "rotate(0 "+(radius+marginx)+" "+(radius+marginy)+")");
						setVal(minval);
						return;
					}
				}
				a1[circle] = newangle;
				$("#"+circle).attr("transform", "rotate("+(a1[circle])+" "+(radius+marginx)+" "+(radius+marginy)+")");
				var cval = ((3600+a1[circle])%360)/360*factor[circle]+(circle=='r1'? minval: 0);
				var cprec = factor.r2 * (circle=='r2'? 0.01: 1);
				if (document.location.search.indexOf('debug')>-1) console.log('cval', cval, 'cprec', cprec, 'cval/cprec', cval/cprec, 'Math.round(cval/cprec)*cprec', Math.round(cval/cprec)*cprec);
				value[circle] = -1*direction*Math.round(cval/cprec)*cprec;
				if (document.location.search.indexOf('debug')>-1) console.log('value[circle]', value[circle], 'factor.r2', factor.r2, 'factor.r2 - 0 + value[circle]', factor.r2 - 0 + value[circle]);
				if (circle=='r2') value[circle] = (factor.r2 - 0 + value[circle]) % factor.r2;
				$("#v1").html(value.r1); $("#v2").html(value.r2);
				if (document.location.search.indexOf('debug')>-1) console.log(a1[circle], (3600+a1[circle])%360, value[circle]);
				var v = value.r1 + value.r2 % factor.r2;
				if (v >= maxval) v = maxval - 1 + value.r2 % factor.r2;
				if (v < minval) v = minval + value.r2 % factor.r2;
				cprec = factor.r2 * 0.01;
				if (document.location.search.indexOf('debug')>-1) console.log('setVal', decimal, factor, 'cprec', cprec);
				setVal((Math.round(v/cprec)*cprec).toFixed(Math.max(0,-Math.log10(cprec))));
			}
		}, {passive: true});
	}
