// jshint esversion: 6
// ------------
// tree.js
// ------------

	var treeService = ''; // to be initialized in treeConf() method
	var globalVal;
	var globalLabel;

	// INIT
	const $_GET = getQueryParams(document.location.search);
	const speechToken = typeof($_GET['token']) === 'undefined'? Math.floor(Math.random() * 1000000000000): $_GET['token'];
	if (typeof($_GET['conf']) !== 'undefined') {
		document.getElementById('conf').value = $_GET['conf'];
		initConf($_GET['conf']);
	}
	else {
		initConf(false);
	}
	initTree($_GET);
	console.log('treeService', treeService);

	function popup(location, title, params) {
		newwindow=window.open(location,title,'height=800,width=400');
		if (window.focus) {newwindow.focus();}
		return false;
	}

	function extractTimeseries(dropData) {
		myproperty = dropData.split('</property>');
		mystring = myproperty[0].split('string>');
		myts = mystring[1].split('<');
		return myts[0];
	}

	function initTree($_GET) {
		if (!$('#tree').length) return;
		var source_url = treeService;
		$("#tree").fancytree({
			autoScroll: true,
			source: {
				url: source_url
			},
			lazyLoad: function(event, data) {
				var node = data.node;
				// Issue an ajax request to load child nodes
				data.result = {
					url: treeService+'&n='+data.node.span.children[2].children[0].id,
					data: {key: node.key+'/*'}
				};
				console.log('lazyLoad::data', data.node.span.children[2].children[0].id);
			},
			click: function(event, data) {
				console.log('click::data', data);
				if (data.targetType == 'icon' || data.targetType == 'title') {
					console.log('click::icon, data.node', data.node.key);
					return append2formula(data.node.key);
				}
				return true;// Allow default processing
			},
			clickFolderMode: 2,
			persist: true
		});
		subscribeSpeech();
	}

	function getQueryParams(qs) {
		qs = qs.split("+").join(" ");
		var params = {},
				tokens,
				re = /[?&]?([^=]+)=([^&]*)/g;
		while (tokens = re.exec(qs)) {
			params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
		}
		return params;
	}

	let dlocation = $('#eGiga2m');
	let dindex = 1;
	async function treeSelect(msg) {
		try {
			console.log('tree.js, treeSelect('+msg+')');
			console.trace();
			if (msg[0]=='n') msg = msg.substring(1); else return;
			if (msg == 'up') {document.getElementById('tree').children[0].scrollTop = Math.max(0, document.getElementById('tree').children[0].scrollTop - window.innerHeight*0.7); return;}
			if (msg == 'down') {document.getElementById('tree').children[0].scrollTop = document.getElementById('tree').children[0].scrollTop + window.innerHeight*0.7; return;}
			// var token = 'frame1'; var iframe = $('#iframe1'); $('[tokenid=' + token + ']', iframe.contents());
			// const redirect = 'http://fcs-proxy-01.elettra.eu/egiga2m/lib/service/redirect_service.php?conf=elettra&start=last 8 hours&s=hv_p1/Voltage';
			if (msg.toLowerCase().replace(' ','').indexOf('egiga')>-1) {
				while (dindex<10 && $("#frame"+dindex).contents().length) {dlocation = $("#frame"+dindex).contents().find('#eGiga2m').eq(0); dindex++;}
				console.log(dindex, $("#frame"+dindex).contents().length, dlocation, dlocation.attr('href'));
				document.location = dlocation.attr('href');
			}
			let id = msg.split("_");
			console.log(msg, id);
			if (isNaN(id[id.length-1])) {
				const t = id.pop();
				const idClass = id.length==0? '': ('.n'+id.join('_'));
				console.log('t+idClass .'+t+idClass+', id:'+id);
				msg = $('.'+t+idClass)[0].attr('id');
				console.log('msg: '+msg);
				id = msg.split("_");
			}
			if (typeof $('#n'+msg)[0] == 'undefined') {fetch("./panther/speech/talk.php?ctreeresult=err1:"+msg+" not found&token="+speechToken, {cache: "no-store"}); return;}
			const resp = id[id.length-1] + '_' + $('#n'+msg)[0].className.split(' ').pop();
			const url = "./panther/speech/talk.php?ctreeresult="+resp+"&token="+speechToken;
			console.log('resp', resp, url);
			await fetch(url, {cache: "no-store"});
			if (id.length>4) $('#n'+msg).parent().click();
			else {
				if (typeof $('#n'+msg).parent().parent().children()[0] == 'undefined') {fetch("./panther/speech/talk.php?ctreeresult=err2:"+msg+" not found&token="+speechToken, {cache: "no-store"}); return;}
				$('#n'+msg).parent().parent().children()[0].click();
			}
		}
		catch (e) {console.log('err: '+e);fetch("./panther/speech/talk.php?ctreeresult=err3:"+e+"&token="+speechToken, {cache: "no-store"});}
	}

	function myFocus() {
		window.focus();
		return 98759;
	}

	function handleTreeSelect(evt) {
		console.log('handleTreeSelect');
		evt.stopPropagation();
		evt.preventDefault();
		attr = extractTimeseries(evt.dataTransfer.getData("text"));
		// attr = evt.dataTransfer.getData('application/taurus-device'); does this work with taurus?
		addTs = evt.dataTransfer.dropEffect=='copy';
		console.log('get', treeService+'&searchkey='+attr, evt);
		$.get(treeService+'&searchkey='+attr, function(data) {
			if (typeof(data[0]) !== 'undefined') {
				var ts = (addTs && document.getElementById('ts').value.length)? document.getElementById('ts').value+';'+data[0]: data[0];
				updateLink(ts);
				document.getElementById('ts').value = ts;
			}
		});
	}

	async function subscribeSpeech() {
		// console.log('subscribeSpeech()', 1, 2);
		let response = await fetch("./panther/speech/talk.php?ujive=1&token="+speechToken, {cache: "no-store"});
		if (response.status == 502) {
			await subscribeSpeech();
		} else if (response.status != 200) {
			// An error - let's show it
			// console.log('subscribeSpeech() ERROR ', response.statusText);
			// Reconnect in one second
			await new Promise(resolve => setTimeout(resolve, 1000));
			await subscribeSpeech();
		} else {
			// Get and show the message
			let message = await response.text();
			if (message == 'unload') {console.log('UNLOADED'); return;}
			// console.log('subscribeSpeech()', message);
			await treeSelect(message);
			// return feedback
			// fetch("./panther/speech/talk.php?ujiveresult="+msg+"&token="+speechToken, {cache: "no-store"});
			// Call subscribeSpeech() again to get the next message
			await subscribeSpeech();
		}
	}
	// window.onbeforeunload = function(){
	window.onunload = function(){
		fetch("./panther/speech/talk.php?ctree=unload&token="+speechToken, {cache: "no-store"});
		alert('Are you sure you want to leave?');
	};

	function handleDragOver(evt) {
		evt.stopPropagation();
		evt.preventDefault();
		evt.dataTransfer.dropEffect = 'plot'; // Explicitly show this is a copy.
	}

	// Setup the dnd listeners.
	var dropZone = document.getElementById('formula');
	dropZone.addEventListener('dragover', handleDragOver, false);
	dropZone.addEventListener('drop', handleTreeSelect, false);

	function strtr(myString, replaceArray){
		var oldString ;
		for (var i in replaceArray) {
			oldString = '';
			while (myString !== oldString) {
				oldString = myString;
				myString = oldString.replace(i,replaceArray[i]);
			}
		}
		return myString;
	}

	if (typeof($_GET['formula']) !== 'undefined') {
		var myPopup = new popup('./formula_editor.html?conf='+$_GET['conf'], 'formula', 'width=670,height=800');
		myPopup.open();
	}
