<?php
	if (!isset($_REQUEST['s']) || $_REQUEST['s']!='open') header("Content-Type: application/json");
	require_once("./conf.php");
	require_once("./uti.php");
	$sql = open_db();

	if (isset($_REQUEST['create_screen'])) {
		$query = "CREATE TABLE screen(
		 id serial PRIMARY KEY,
		 username VARCHAR (50),
		 ip INET,
		 title VARCHAR (200),
		 created_on TIMESTAMP default statement_timestamp(),
		 last_update TIMESTAMP,
		 category TEXT[],
		 content JSON,
		 s TEXT
		);";
		$res = $sql->sql_query($query);
		if (!$res) {file_put_contents("./screens/{$_REQUEST['name']}.json", "$query<br>\nErrormessage: %s\n".$sql->sql_error());}
	}

	$yy = date('Y');
	session_start();
	$username = '';
	if (!isset($_SESSION['token'])) {
		if (!empty($_REQUEST['username'])) $username = $_REQUEST['username'];
	} // die(json_encode('Error: user not logged.'));
	else {
		$webtokenExpirationSeconds = 28800; // 8 hh
		$data = $sql->sql_secure("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND $timediff<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", array($_SESSION['token']));
		if (isset($_REQUEST['debug'])) die(json_encode(array("SELECT * FROM userlog_$yy WHERE webtoken='{$_SESSION['token']}' AND $timediff<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1",$data)));
		if (empty($data)) die(json_encode('Error: invalid user login.'));
		$username = $data[0]['username'];
	}
	$loguser = empty($username)? '': $username;
	if (isset($_REQUEST['s'])) {
		if ($_REQUEST['s']=='insert') {
			$f = explode('/', $_REQUEST['file']);
			$file = array_pop($f);
			$data = $sql->sql_secure("SELECT COUNT(*) AS n FROM screen WHERE username=$1 AND title=$2", array($username, $file));
			header("Content-Type: application/json");
			if ($data[0]['n']-0 > 0) die(json_encode(array('name'=>$_REQUEST['file'], 'query'=>$query, 'err'=>"Warning: screen already exists.")));
			$category = null;
			if (!empty($f)) $category = "{'".implode("','", $f)."'}";
			$s = file_get_contents("/var/www/html/spa/{$_REQUEST['file']}.html");
			$now = date('Y-m-d');
			$query = "INSERT INTO screen (username,ip,created_on,last_update,title,category,s) VALUES ($1, $2, '2020-01-01', '$now', $3, $4, $5)";
			$stmt = $sql->sql_secure($query, array($username, $_SERVER['REMOTE_ADDR'], $file, $category, $s));
			$err = $sql->sql_error();
			die(json_encode(array('name'=>$_REQUEST['file'], 'id'=>(int)$sql->last_insert_id(), 'query'=>$query, 'err'=>$err)));
		}
		if ($_REQUEST['s']=='update') {
			$f = explode('/', $_REQUEST['file']);
			$file = array_pop($f);
			$category = null;
			if (!empty($f)) $category = "{'".implode("','", $f)."'}";
			$now = date('Y-m-d H:i:s');
			$query = "UPDATE screen (last_update,category,s) VALUES ('$now', $1, $2) WHERE username=$3 AND title=$4";
			$stmt = $sql->sql_secure($query, array($category, $_REQUEST['content'], $username, $file));
			$err = $sql->sql_error();
			header("Content-Type: application/json");
			die(json_encode(array('name'=>$_REQUEST['file'], 'query'=>$query, 'err'=>$err)));
		}
		if ($_REQUEST['s']=='list') {
			$orderby = 'title';
			$columns = array('id','title','username','created_on','last_update');
			if (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], $columns)) $orderby = $_REQUEST['orderby'];
			$desc = isset($_REQUEST['desc'])? " DESC": '';
			$s = array();
			if (empty($_REQUEST['username'])) {
				$data = $sql->sql_select("id,title,username,created_on,last_update, LENGTH(s) AS length", 'screen', "NOT s IS NULL ORDER BY $orderby$desc");
			}
			else {
				$data = $sql->sql_secure("SELECT id,title,username,created_on,last_update, LENGTH(s) AS length FROM screen WHERE NOT s IS NULL AND username=$1 ORDER BY $orderby$desc", array($_REQUEST['username']));
			}
			if ($sql->sql_error()) echo $sql->sql_error()."<br>\n";
			if (isset($_REQUEST['debuglist'])) echo "SELECT id,title,username,created_on,last_update FROM screen WHERE NOT s IS NULL ORDER BY $orderby;{$_REQUEST['username']}<br>\n".json_encode($data);
			foreach ($data as $d) {
				$s[] = array('id'=>(int)$d['id'],'title'=>empty($d['title'])? 'NO TITLE': $d['title'],'username'=>$d['username'],'created_on'=>$d['created_on'],'last_update'=>$d['last_update'],'length'=>$d['length']);
			}
			header("Content-Type: application/json");
			die(json_encode($s));
		}
		if ($_REQUEST['s']=='open') {
			if (!empty($_REQUEST['id'])) {
				$data = $sql->sql_secure("SELECT * FROM screen WHERE id=$1", array($_REQUEST['id']));
			}
			else if (!empty($_REQUEST['title'])) {
				$data = $sql->sql_secure("SELECT * FROM screen WHERE title=$1", array($_REQUEST['title']));
			}
			else die("Error: screen not specified, please use id or title");
			// save user access to screen
			$d = $sql->sql_secure("INSERT INTO userscreenlog_$yy (username, screenid, date, ip) VALUES ($1, $2, NOW(), $3)", array($loguser, $data[0]['id'], $_SERVER['REMOTE_ADDR']));
			die($data[0]['s']);
		}
	}
	header("Content-Type: application/json");

	if (isset($_REQUEST['save'])) {
		$stmt = $sql->sql_secure("INSERT INTO screen(username,ip,title,content) VALUES($1, $2, $3, $4)", array($username, $_SERVER['REMOTE_ADDR'], $_REQUEST['name'], $_REQUEST['content']));
		$err = $sql->sql_error();
		echo json_encode(array('name'=>$_REQUEST['name'], 'id'=>(int)$sql->last_insert_id(), 'err'=>$err));
	}

    if(isset($_REQUEST['update'])) {
		if (strpos($_REQUEST['name'], '.')!==false) die(json_encode('Invalid screen name.'));
		$stmt = $sql->sql_secure("UPDATE screen SET title = $2, content = $3 WHERE id = $1", array($_REQUEST['id'], $_REQUEST['name'], $_REQUEST['content']));
		$err = $sql->sql_error();
		if (empty($err)) {
			$sql->sql_secure("INSERT INTO screenlog_$yy (username,id,valid_until,title,content) VALUES($1, $2, NOW(), $3, $4)", array($username, $_REQUEST['id'], $_REQUEST['name'], $_REQUEST['content']));
		}
		echo json_encode(array('id'=>(int)$_REQUEST['id'],'name'=>$_REQUEST['name'], 'err'=>$err));
    }

    if(isset($_REQUEST['delete'])) {
		if ($_REQUEST['id']-0 < 1) die(json_encode('Invalid screen id.'));
		$stmt = $sql->sql_secure("INSERT INTO screenlog_$yy SELECT $1 AS username, id, NOW() AS valid_until, title, content FROM screen WHERE id=$2", array($username, $_REQUEST['id']));
		$stmt = $sql->sql_secure("DELETE from screen WHERE id = $1", array($_REQUEST['id']));
		$err = $sql->sql_error();
		echo json_encode(array('err'=>$err));
    }

	if (isset($_REQUEST['list'])) {
		$orderby = 'title';
		$columns = array('id','title','username','created_on');
		if (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], $columns)) $orderby = $_REQUEST['orderby'];
		$desc = isset($_REQUEST['desc'])? " DESC": '';
		$s = array();
		$data = $sql->sql_secure("SELECT id,title,username,created_on FROM screen WHERE NOT content IS NULL ORDER BY $1", array($orderby.$desc));
		if (isset($_REQUEST['debug'])) echo "SELECT id,title,username,created_on FROM screen ORDER BY $orderby;<br>\n";
		foreach ($data as $d) {
			$s[] = array('id'=>(int)$d['id'],'title'=>empty($d['title'])? 'NO TITLE': $d['title'],'username'=>$d['username'],'created_on'=>$d['created_on']);
		}
		header("Content-Type: application/json");
		die(json_encode($s));
		// echo "<pre>\n"; print_r($data); echo "</pre>\n"; exit();
	}

	if (isset($_REQUEST['listScreens'])) {
		$dir = './screens';
		$list = array();
		if ($dh = opendir($dir)) {
			while (($file = readdir($dh)) !== false) {
				if (strpos($file, '.json')!==false) {
					$list[] = $file;
				}
			}
		}
		echo json_encode($list);
	}
	$loguser = empty($username)? '': $username;
	if (isset($_REQUEST['openScreenFile']) and (strpos($_REQUEST['openScreen'], '.json')!==false) and (strlen($_REQUEST['openScreen']) < 100)) readfile("./screens/".$_REQUEST['openScreen']);
	if (isset($_REQUEST['openScreen']) and (strlen($_REQUEST['openScreen']) < 100)) {
		$data = $sql->sql_secure("SELECT * FROM screen WHERE title=$1", array($_REQUEST['openScreen']));
		// save user access to screen
		$d = $sql->sql_secure("INSERT INTO userscreenlog_$yy (username, screenid, date, ip) VALUES ($1, $2, NOW(), $3)", array($loguser, $data[0]['id'], $_SERVER['REMOTE_ADDR']));
		die(json_encode(array('id'=>intval($data[0]['id']),'name'=>$data[0]['title'],'cmpts'=>json_decode($data[0]['content']))));
	}
	if (isset($_REQUEST['openScreenId']) and (strlen($_REQUEST['openScreenId']) < 12)) {
		$data = $sql->sql_secure("SELECT * FROM screen WHERE id=$1", array($_REQUEST['openScreenId']));
		// save user access to screen
		$d = $sql->sql_secure("INSERT INTO userscreenlog_$yy (username, screenid, date, ip, filename) VALUES ($1, $2, NOW(), $3, '')", array($loguser, $_REQUEST['openScreenId'], $_SERVER['REMOTE_ADDR']));
		die(json_encode(array('id'=>intval($data[0]['id']),'name'=>$data[0]['title'],'cmpts'=>json_decode($data[0]['content']))));
	}
	if (isset($_REQUEST['logFileScreen']) and (strlen($_REQUEST['logFileScreen']) < 100)) {
		$d = $sql->sql_secure("INSERT INTO userscreenlog_$yy (username, screenid, date, ip, filename) VALUES ($1, 0, NOW(), $2, $3)", array($loguser, $_SERVER['REMOTE_ADDR'], $_REQUEST['logFileScreen']));
		die(json_encode($sql->sql_error()));
	}
	if ($elettra_screens) require_once('./elettra_screens.php');
?>
