/* jshint esversion: 6 */
// TODO deduplication using https://developer.mozilla.org/en-US/docs/Web/API/Service_Worker_API

const urlSearch = document.location.search;
const dataSrc = {};
const tangoThresholds = {};
const notSubscribed = [];
const pumaReplace = {};
var gauges = [];
var myInterval = 0;
var intervalMs = 1000;
var intervalCounter = 0;
var subperiodNumber = 4;
var subperiodCounter = 0;
var popupWindow = null;
var lastId = 0;
var tok = {id: 0, ttl: 0, exp: 0};
var tokInterval = -1;
var srcArray = [];
var srcIndex = 0;
var heartbeat = 0;

	if (urlSearch.indexOf('debug=list')>-1) {
		var allfunctions=[];
		for ( var i in window) {
			if((typeof window[i]).toString()=="function" && window[i].toString().indexOf("native")==-1){
				allfunctions.push(window[i].name);
			}
		}
		console.table(allfunctions);
	}

	function cmdPrompt(cmd, param) {
		const p = typeof param === 'undefined'? '': '&param='+param;
		if (!window.popupWindow) {    // has not yet been defined
			popupWindow = window.open(cmdServer+'?varDetail='+cmd+'&type=commands&closeDelay=2'+p, 'cmd', 'width=600,height=300');
		}
		else {   // has been defined
			if (!popupWindow.closed) {
				popupWindow.focus();
			}
			else {
				popupWindow = window.open(cmdServer+'?varDetail='+cmd+'&type=commands&closeDelay=2'+p, 'cmd', 'width=600,height=300');
			}
		}
	}

	function getDate(ts) {
		const m = new Date(ts && ts>0? ts*1000: Date.now());
		var sec = m.getUTCSeconds();
		if (sec < 10) sec = `0${sec}`;
		var min = m.getUTCMinutes();
		if (min < 10) min = `0${min}`;
		return `${m.getUTCDate()}/${m.getUTCMonth() + 1}/${m.getUTCFullYear()} ${m.getUTCHours()}:${min}:${sec} UTC`;
	}

	function updateTok() {
		if (Date.now()/1000 < tok.exp-30) return;
		if (Date.now()/1000 - heartbeat > 12) {
			if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('updateTok(), LATE', Date.now()/1000, heartbeat);
			tok.id = 0;
			subscribeSrc();
			return;
		}
		var url = rchanServer + "?json&port=8443&tok="+tok.id;
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('updateTok(), tokInterval', tokInterval, url);
		fetch(url)
		.then((response) => {
			if (response.status>=300) {
				console.log('PUMA Error, response', response);
			}
			else {
				return response.text();
			}  
		})
		.then((eventData) => {
			const data = JSON.parse(eventData);
			if (data[0].err) {
				tok.id = 0;
				subscribeSrc();
			}
			else {
				tok = data[0];
				if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('updateTok(), eventData', data[0].id, data[0].ttl, data);
			}
		})
		.catch((err) => {
				console.log('PUMA ERROR', err);
		});
	}

	function setPollingPeriod(t) {
		intervalMs = t;
	}

	function setSubPeriodNumber(n) {
		subperiodNumber = n;
	}

	function detectState(myvalue, id) {
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('detectState()',myvalue, id);
		const state = ['ON','OFF','CLOSED','OPENED','INSERT','EXTRACT','MOVING','STANDBY','FAULT','INIT','RUNNING','ALARM','DISABLE','UNKNOWN'];
		const stateBackgroundColor = ['green','white','white','green','white','green','LightBlue','yellow','red','beige','DarkGreen','orange','magenta','grey'];
		const stateColor = ['white','black','black','white','black','white','black','black','white','black','white','black','white','white'];
		const index = typeof(myvalue) === 'string'? $.inArray(myvalue, state): myvalue-0;
		$('#'+id).val(state[index]);
		$('#'+id).css('background-color', stateBackgroundColor[index]);
		$('#'+id).css('color', stateColor[index]);
	}

	function setValue(label, val, timestamp, quality, err) {
		const ids = dataSrc[label];
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('setValue()',label, val, timestamp, quality, err);
		if (ids) for (i=0; i<ids.length; i++) {
			var delay = Math.abs(timestamp - Date.now()/1000) > 2? '\nReceived: '+getDate(): '';
			const value = ($('#'+ids[i]).attr('data-src') && $('#'+ids[i]).attr('data-src').indexOf('[') > -1)? val[$('#'+ids[i]).attr('data-src').split('[')[1].split(']')[0]]: val;
			$('#'+ids[i]).attr("title", 'Value: '+val+'\nSrc: '+$('#'+ids[i]).attr('data-src')+'\nLast update: '+getDate(timestamp)+delay+'\nUpdate method: SSE\n'); // Src: '+$('#'+ids[i]).attr('data-src')+'\nId: '+ids[i]+'\nError: '+eventData.data.error+'\nQuality: '+eventData.data.quality);
			if (typeof window[$('#'+ids[i]).attr('data-onupdate')] === 'function') {
				window[$('#'+ids[i]).attr('data-onupdate')](value, ids[i], timestamp, quality, err);
			}
			else if (typeof window[$('#'+ids[i]).attr('data-onupdate')] === 'function') {
				if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('data-onupdate', $('#'+ids[i]).attr('id'), value);
				window[$('#'+ids[i]).attr('data-onupdate')](value, ids[i], timestamp, quality, err);
			}
			else if ($('#'+ids[i]).hasClass("gauge")) {
				if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('setValue gauges()', $('#'+ids[i]).attr('id'), value);
				// gauges[$('#'+ids[i]).attr('id')].redraw(value);
			}
			else if ($('#'+ids[i]).prop("tagName") == 'INPUT') {
				if ($('#'+ids[i]).attr("type") == 'checkbox') $('#'+ids[i]).prop('checked', value);
				else $('#'+ids[i]).val($.isNumeric(value) ? value.toFixed(2): value);
			}
			else if ($('#'+ids[i]).prop("tagName") == 'IMG') {
				$('#'+ids[i]).attr("src", value == false || value === 'false' ? './img/ledred.png': './img/ledgreen.png');
			}
			else { // if ($('#'+ids[i]).prop("tagName") == 'TEXTAREA') {
				$('#'+ids[i]).html(value);
			}
			if (typeof tangoThresholds[ids[i]] === "object") {
				if (value < tangoThresholds[ids[i]].min_alarm || value > tangoThresholds[ids[i]].max_alarm) {
					$('#'+ids[i]).css('background-color', 'Red');
					$('#'+ids[i]).css('color', 'White');
				}
				else if (value < tangoThresholds[ids[i]].min_warning || value > tangoThresholds[ids[i]].max_warning) {
					$('#'+ids[i]).css('background-color', 'Yellow');
					$('#'+ids[i]).css('color', 'Black');
				}
				else {
					$('#'+ids[i]).css('background-color', 'White');
					$('#'+ids[i]).css('color', 'Black');
				}
			}
		}
	}
// var plc_int_ll02 = false; var llk = [];
	function sseListener(event) {
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('sseListener()', event, JSON.parse(event.data)[0]);
		if (event.data === undefined) {
			console.log(getDate()+' PUMA Warning: missing event.data ',event);
			return;
		}
		const eventData = JSON.parse(event.data);
		if (eventData[0].src=='' && eventData[0].type=="heartbeat") {
			d = new Date();
			if (document.getElementById('heartbeat')) document.getElementById('heartbeat').innerHTML = 'heartbeat: '+d.toLocaleString(); 
			console.log(getDate()+' - heartbeat '+d.toLocaleString(), event);
			d = null;
			return;
		}
		for (eventDataIndex=0; eventDataIndex<eventData.length; eventDataIndex++) {
			if (eventData[eventDataIndex].src !== undefined) { // && eventData.data.error !== undefined && ((eventData.data.error == '' && eventData.data.value !== undefined) || eventData.data.error != '')) {
				if (document.location.search.indexOf('&pumadebug')>-1) {console.log('sseListener()', eventData[eventDataIndex].src, eventData[eventDataIndex].value);}
				label = eventData[eventDataIndex].src;
				val = eventData[eventDataIndex].value;
			}
			else if (eventData[0].type=="heartbeat") {
				console.log(getDate()+' heathbeat ',eventData[0].timestamp_us);
				heartbeat = eventData[0].timestamp_us;
				return;
			}
			else {
				console.log(getDate()+' PUMA Warning: undetected eventData ', eventData, eventData[0], eventData[0].type);
				return;
			}
			const ids = dataSrc[label];

			if (ids) for (i=0; i<ids.length; i++) {
				var delay = Math.abs(eventData[eventDataIndex].timestamp_ms - Date.now()/1000) > 2? '\nReceived: '+getDate(): '';
				const value = ($('#'+ids[i]).attr('data-src') && $('#'+ids[i]).attr('data-src').indexOf('[') > -1)? val[$('#'+ids[i]).attr('data-src').split('[')[1].split(']')[0]]: val;
				$('#'+ids[i]).attr("title", 'Value: '+val+'\nLast update: '+getDate(eventData[eventDataIndex].timestamp_ms)+delay+'\nUpdate method: SSE\nSrc: '+$('#'+ids[i]).attr('data-src')+'\n'); // Src: '+$('#'+ids[i]).attr('data-src')+'\nId: '+ids[i]+'\nError: '+eventData.data.error+'\nQuality: '+eventData.data.quality);
				if (typeof window[$('#'+ids[i]).attr('data-onUpdate')] === 'function') {
					window[$('#'+ids[i]).attr('data-onUpdate')](value, ids[i], eventData[eventDataIndex].timestamp_ms, eventData[eventDataIndex].quality);
				}
				else if (typeof window[$('#'+ids[i]).attr('data-onupdate')] === 'function') {
					// console.log('sseListener(), data-onupdate', $('#'+ids[i]).attr('id'), value);
					window[$('#'+ids[i]).attr('data-onupdate')](value, ids[i], eventData[eventDataIndex].timestamp_ms, eventData[eventDataIndex].quality);
				}
				else if ($('#'+ids[i]).hasClass("gauge")) {
					gauges[$('#'+ids[i]).attr('id')].redraw(value);
				}
				else if ($('#'+ids[i]).prop("tagName") == 'INPUT') {
					if ($('#'+ids[i]).attr("type") == 'checkbox') $('#'+ids[i]).prop('checked', value);
					else $('#'+ids[i]).val($.isNumeric(value) ? value.toFixed(2): value);
				}
				else if ($('#'+ids[i]).prop("tagName") == 'IMG') {
					$('#'+ids[i]).attr("src", value == false || value === 'false' ? './img/ledred.png': './img/ledgreen.png');
				}
				else { // if ($('#'+ids[i]).prop("tagName") == 'TEXTAREA') {
					$('#'+ids[i]).html(value);
				}
				if (typeof tangoThresholds[ids[i]] === "object") {
					if (value < tangoThresholds[ids[i]].min_alarm || value > tangoThresholds[ids[i]].max_alarm) {
						$('#'+ids[i]).css('background-color', 'Red');
						$('#'+ids[i]).css('color', 'White');
					}
					else if (value < tangoThresholds[ids[i]].min_warning || value > tangoThresholds[ids[i]].max_warning) {
						$('#'+ids[i]).css('background-color', 'Yellow');
						$('#'+ids[i]).css('color', 'Black');
					}
					else {
						$('#'+ids[i]).css('background-color', 'White');
						$('#'+ids[i]).css('color', 'Black');
					}
				}
			}
		}
		if ($('#lastUpdated').get(0)) $('#lastUpdated').val(getDate()); 
	}

	function wsListener(event){
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('wsListener()', event, JSON.parse(event.data)[0]);
		if (event.data === undefined) {
			console.log(getDate()+' PUMA Warning: missing event.data ',event);
			return;
		}
		const eventData = JSON.parse(event.data);
		var label = null;
		var val = null;
		if (eventData.formula) {
			label = `formula/${eventData.label}`;
			val = eventData.value;
		}
		else if (eventData.data !== undefined && eventData.data.error !== undefined && ((eventData.data.error == '' && eventData.data.value !== undefined) || eventData.data.error != '')) {
			label = eventData.event;
			val = eventData.data.error == ''? eventData.data.value: eventData.data.error;
			if (eventData.data.error != '') console.log(getDate()+' PUMA Warning: data error ',eventData);
		}
		else {
			console.log(getDate()+' PUMA Warning: undetected eventData ',eventData);
			return;
		}
		const ids = dataSrc[label];
		// console.log(getDate()+' wsListener(), eventData',eventData);
		if (ids) for (i=0; i<ids.length; i++) {
			// console.log(getDate()+' wsListener()', event, i, $('#'+ids[i]).attr("title"));
			var delay = Math.abs(eventData.data.timestamp - Date.now()/1000) > 2? '\nReceived: '+getDate(): '';
			const value = ($('#'+ids[i]).attr('data-src') && $('#'+ids[i]).attr('data-src').indexOf('[') > -1)? val[$('#'+ids[i]).attr('data-src').split('[')[1].split(']')[0]]: val;
			$('#'+ids[i]).attr("title", 'Value: '+eventData.data.value+'\nLast update: '+getDate(eventData.data.timestamp)+delay+'\nUpdate method: webSocket\nSrc: '+$('#'+ids[i]).attr('data-src')+'\nId: '+ids[i]+'\nError: '+eventData.data.error+'\nQuality: '+eventData.data.quality);
			// if ($('#'+ids[i]).prop("tagName")!='INPUT') console.log(ids[i], $('#'+ids[i]).prop("tagName"));
			if (typeof window[$('#'+ids[i]).attr('data-onUpdate')] === 'function') {
				window[$('#'+ids[i]).attr('data-onUpdate')](value, ids[i], eventData.data.timestamp, eventData.data.quality);
			}
			else if ($('#'+ids[i]).hasClass("gauge")) {
				// console.log("gauge", el, value, updateMethod, eventData);
				gauges[$('#'+ids[i]).attr('id')].redraw(value);
			}
			else if ($('#'+ids[i]).prop("tagName") == 'INPUT') {
				if ($('#'+ids[i]).attr("type") == 'checkbox') $('#'+ids[i]).prop('checked', value);
				else $('#'+ids[i]).val($.isNumeric(value) ? value.toFixed(2): value);
			}
			else if ($('#'+ids[i]).prop("tagName") == 'IMG') {
				$('#'+ids[i]).attr("src", value == false || value === 'false' ? './img/ledred.png': './img/ledgreen.png');
			}
			else { // if ($('#'+ids[i]).prop("tagName") == 'TEXTAREA') {
				$('#'+ids[i]).html(value);
			}
			if (typeof tangoThresholds[ids[i]] === "object") {
				if (value < tangoThresholds[ids[i]].min_alarm || value > tangoThresholds[ids[i]].max_alarm) {
					$('#'+ids[i]).css('background-color', 'Red');
					$('#'+ids[i]).css('color', 'White');
				}
				else if (value < tangoThresholds[ids[i]].min_warning || value > tangoThresholds[ids[i]].max_warning) {
					$('#'+ids[i]).css('background-color', 'Yellow');
					$('#'+ids[i]).css('color', 'Black');
				}
				else {
					$('#'+ids[i]).css('background-color', 'White');
					$('#'+ids[i]).css('color', 'Black');
				}
			}
		}
		if ($('#lastUpdated').get(0)) $('#lastUpdated').val(getDate()); 
	}

	function Threshold() {
	   this.min_alarm = null;
	   this.min_warning = null;
	   this.max_warning = null;
	   this.max_alarm = null;
	}
	function addTangoThreshold(src, id, threshold) {
		// console.log('addTangoThreshold src', src);
		$.getJSON(`${restServer}/cs/${src}/${threshold}`, function(data) {
			// console.log('addTangoThreshold data', data);
			if (data && $.isNumeric(data[0])) {
				if (typeof tangoThresholds[id] !== "object") tangoThresholds[id] = new Threshold();
				tangoThresholds[id][threshold] = data[0];
			}
		});
	}

	function initVar() {
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('initVar()', $('.puma').length);
		initializeGauges();
		for (i=0; i<$('.puma').length; i++) {
			// detect data-src or signal warning and skip iteration
			if (typeof $('.puma').eq(i).attr('data-src') === typeof undefined || $('.puma').eq(i).attr('data-src') === false) {
				console.log(getDate()+' PUMA Warning: missing data-src attribute for id: '+$('.puma').eq(i).attr('id'));
				continue;
			}
			if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('data-src(full)', $('.puma').eq(i).attr('data-src'));
			var src = $('.puma').eq(i).attr('data-src').indexOf('[')>-1? $('.puma').eq(i).attr('data-src').split('[')[0].toLowerCase().replace('tango://',''): $('.puma').eq(i).attr('data-src').toLowerCase().replace('tango://','');
			if (src.indexOf('{') > -1) {
				for (var p in pumaReplace) {
					src = src.split('{'+p+'}').join(pumaReplace[p]);
				}
				console.log('initVar(),', src); //{'+p+'}', pumaReplace[p], src.split('{'+p+'}'));
			}
			if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('data-src', src);
			var id = $('.puma').eq(i).attr('id');
			if (typeof src === typeof undefined || src === false) {
				console.log(getDate()+' PUMA Warning: missing data-src attribute for id: '+id);
				continue;
			}
			// add ID only if missing
			if (typeof id === typeof undefined || id === false) {
				for (j=lastId; j<1000; j++) {
					id = `id${j}`;
					if (document.getElementById('#'+id) === null) {
						lastId = j+1;
						$('.puma').eq(i).attr('id', id);
						console.log(getDate()+' PUMA Warning: missing id, added: '+id);
						break;
					}
				}
			}
			// insert in data-src data structure
			if (typeof dataSrc[src] !== "undefined") {dataSrc[src].push(id);} else {dataSrc[src] = [id];}
			if (!$('.puma').eq(i).hasClass("hidden")) srcArray.push(src);
			// console.log('attr('+i+'): '+src+', id: '+id;
			$('.puma').eq(i).val('???');
			if ($('.puma').eq(i).attr("class").indexOf('tangoThresholds') > -1 ) {
				addTangoThreshold(src, id, 'min_alarm');
				addTangoThreshold(src, id, 'min_warning');
				addTangoThreshold(src, id, 'max_warning');
				addTangoThreshold(src, id, 'max_alarm');
			}
		}
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.table(srcArray);
		const eventData = subscribeSrc();
		// console.log('dataSrc', dataSrc);
	}

	function elementValue(el, value, updateMethod, eventData) {
		if (el.hasClass("gauge")) {
			// console.log("gauge", el, value, updateMethod, eventData);
			gauges[el.attr('id')].redraw(value);
		}
		else if (el.prop("tagName") == 'INPUT') {
			if (el.attr("type") == 'checkbox') el.prop('checked', value);
			else el.val($.isNumeric(value) ? value.toFixed(2): value);
		}
		else if (el.prop("tagName") == 'IMG') {
			el.attr("src", value == false || value === 'false' ? './img/ledred.png': './img/ledgreen.png');
		}
		else if (el.prop("tagName") == 'TEXTAREA') {
			el.val(value);
		}
		else { 
			el.html(value);
		}
		el.attr("title", 'Value: '+value+'\nLast update: '+getDate(eventData.timestamp)+'\nUpdate method: '+updateMethod+'\nSrc: '+el.attr('data-src')+'\nError: '+eventData.error+'\nQuality: '+eventData.quality);
	}
	window.addEventListener('beforeunload', function (e) {
		console.log('PUMA Notice, beforeunload', e, evtSource.readyState);
		if (evtSource.readyState<2) evtSource.close();
		window.clearInterval(myInterval);
		// Chrome requires returnValue to be set
		// e.returnValue = '';
	});
	var myHeaders = new Headers();
	myHeaders.append('pragma', 'no-cache');
	myHeaders.append('cache-control', 'no-cache');
	function appendToStorage(name, data){
		var old = localStorage.getItem(name);
		if (old === null) old = ""; else old = old+" \n";
		localStorage.setItem(name, old + data);
	}
	function getDate() {
		var temp = new Date();
		return padStr(temp.getFullYear()) + '-' +
					  padStr(1 + temp.getMonth()) + '-' +
					  padStr(temp.getDate()) + ' ' +
					  padStr(temp.getHours()) + ':' +
					  padStr(temp.getMinutes()) + ':' +
					  padStr(temp.getSeconds());
	}

	function padStr(i) {
		return (i < 10) ? "0" + i : "" + i;
	}
	function subscribeSrc() {
		if (!srcArray) return;
		var srcs = srcArray.slice(srcIndex,srcIndex+50).join(',');
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('subscribeSrc()', srcIndex, srcArray.slice(srcIndex,srcIndex+50), rchanServer + '?json&subscribe&src=' + srcs + (tok.id>0? '&tok='+tok.id: ''));
		if (srcArray.length-srcIndex > 50) {
			setTimeout(subscribeSrc, 100);
		}
		fetch(rchanServer + '?json&subscribe&src=' + srcs + (tok.id>0? '&tok='+tok.id: ''))
		.then((response) => {
			if (response.status>=300) {
				console.log('PUMA Error, response', response);
				appendToStorage('log', getDate()+' LOG_ERR subscribe '+response.status);
			}
			else {
				return response.text();
				// return response.json();
			}  
		})
		.then((eventData) => {
			const data = JSON.parse(eventData);
			var period = 0;
			for (subscribedIndex=0; subscribedIndex<data.length; subscribedIndex++) {
				if (subscribedIndex==data.length-1) {
					if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('SUBSCRIBE, data', data, subscribedIndex); 
					tok = data[subscribedIndex]; 
					period = tok.ttl-30;
					if (period < 1) period = tok.ttl/2;
					continue;
				}
				if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('subscribeSrc', subscribedIndex, data[subscribedIndex]);
				// setValue(data[subscribedIndex].src, data[subscribedIndex].value, data[subscribedIndex].timestamp_ms, data[subscribedIndex].quality, data[subscribedIndex].err);
				setValue(data[subscribedIndex].src, data[subscribedIndex].value, data[subscribedIndex].timestamp_ms, true, data[subscribedIndex].err);
			}
			if (period>0 && tokInterval==-1) tokInterval = window.setInterval(updateTok, 4000);
			if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) {console.log('SUBSCRIBE, period', period, tokInterval); console.table(srcArray);}
			appendToStorage('log', getDate()+' LOG_INFO subscribe OK');
		})
		.catch((err) => {
			appendToStorage('log', getDate()+' LOG_ERR subscribe '+err);
		});
		srcIndex = srcIndex + (srcArray.length-srcIndex>50? 50: srcArray.length);
	}
	function subscribeId(idArray, srcArray) {
		if (urlSearch.indexOf('debug=all')>-1 || urlSearch.indexOf('debug='+arguments.callee.name)>-1) console.log('subscribeId()', idArray, srcArray);
		var srcs = [];
		for (ii=0; ii<idArray.length; ii++) {
			var idFound = false;
			for (var di in dataSrc) {
				if (dataSrc[di]==idArray[ii]) {
					idFound = true;
					$('#'+idArray[ii]).removeClass('hidden');
					// srcs.push('{"keys":["src","method","options"],"method":"s","options":["p"],"src":"'+di+'"}');
					srcs.push(di);
				}
			}
			if (!idFound && srcArray) {
				if (typeof dataSrc[srcArray[ii]] !== "undefined") {dataSrc[srcArray[ii]].push(idArray[ii]);} else {dataSrc[srcArray[ii]] = [idArray[ii]];}
				// srcs.push('{"keys":["src","method","options"],"method":"s","options":["p"],"src":"'+di+'"}');
				srcs.push(di);
			}
		}
		fetch(rchanServer + '?json&subscribe&src=' + srcs.join(',') + (tok.id>0? '&tok='+tok.id: ''))
		/*fetch(subscribeServer, {
			method: 'POST',
			// headers: myHeaders,
			body: '{"channel":"rchan","srcs":['+srcs.join(',')+'],"type":"srcs"}\r\n\r\n'
		})*/
		.then((response) => {
			if (response.status>=300) {
				console.log('PUMA Error, response', response);
				appendToStorage('log', getDate()+' LOG_ERR subscribe '+response.status);
			}
			else {
				return response.text();
				// return response.json();
			}  
		})
		.then((eventData) => {
			const data = JSON.parse(eventData);
			for (subscribedIndex=0; subscribedIndex<data.length; subscribedIndex++) {
				setValue(data[subscribedIndex].src, data[subscribedIndex].value, data[subscribedIndex].timestamp_ms, data[subscribedIndex].quality, data[subscribedIndex].err);
			}
			console.log('SUBSCRIBE',idArray[0]);
			appendToStorage('log', getDate()+' LOG_INFO subscribe OK');
		})
		.catch((err) => {
			appendToStorage('log', getDate()+' LOG_ERR subscribe '+err);
		});
	}
	function unsubscribeId(idArray) {
		srcs = [];
		for (ii=0; ii<idArray.length; ii++) {
			for (var di in dataSrc) {
				if (dataSrc[di]==idArray[ii]) {
					// srcs.push('{"keys":["src","method","options"],"method":"u","options":["p"],"src":"'+di+'"}');
					srcs.push(di);
				}
			}
		}
		fetch(rchanServer + '?json&unsubscribe&src=' + srcs.join(',') + (tok.id>0? '&tok='+tok.id: ''))
		/*fetch(subscribeServer, {
			method: 'POST',
			body: '{"channel":"rchan","srcs":['+srcs.join(',')+'],"type":"srcs"}\r\n\r\n'
		})*/
		.then((response) => {
			if (response.status>=300) {
				console.log('PUMA Error, response', response);
				appendToStorage('log', getDate()+' LOG_ERR unsubscribe '+response.status);
			}
			else {
				return response.text();
				// return response.json();
			}
		})
		.then((eventData) => {
			console.log('UN-SUBSCRIBE',idArray[0]);
			appendToStorage('log', getDate()+' LOG_INFO unsubscribe OK');
		})
		.catch((err) => {
			appendToStorage('log', getDate()+' LOG_ERR unsubscribe '+err);
		});
	}
	function adaptToWidth() {
		if (typeof keepCollapsed != 'undefined' && keepCollapsed) return;
		if($(window).width()>=768) {
			for (blockIndex=0; blockIndex<$('.btn-block').length; blockIndex++) {
				$('.btn-block').eq(blockIndex).click();
			}
		}
	}

	function initReplace(replaceName, replaceValue) {
		pumaReplace[replaceName.toLowerCase()] = (''+replaceValue).toLowerCase();
		// console.log('pumaReplace', pumaReplace);
	}

	function replaceSrc(el) {
		let first = [];
		let last = [];
		let mySrc = el.attr('data-src');
		$.each( pumaReplace, function( key, value ) {
			// console.log(key, value);
			mySrc = mySrc.split('{'+key.toLowerCase()+'}').join(value.toLowerCase());
		});
		// console.log('mySrc', mySrc, pumaReplace);
		el.attr('data-src', mySrc);
	}

	function readVar(el) {
		// console.log('readVar()',el);
		if (el.attr('data-src').indexOf('{') > -1) replaceSrc(el);
		const obj = el.attr('data-src').split('[')[0];
		const url = obj.indexOf('formula')==0? `${restServer}/${obj}`: `${restServer}/${obj}`.replace('tango://','');
		// console.log('readVar()',url);
		// fetch(url, {mode: "no-cors"})
		fetch(url)
		.then((response) => {
			if (response.status>=300) {
				console.log('PUMA Error, response', response, obj);
			}
			else {
				// return response.text();
				return response.json();
			}  
		})
		.then((eventData) => {
			// eventData = eventData ? JSON.parse(eventData) : {};
			if (obj.indexOf('formula')!=0) {
				// console.log(eventData);
				var value = eventData.value;
				if (typeof window[el.attr('data-onUpdate')] === 'function' && !(eventData.error && eventData.error==520)) {
					window[el.attr('data-onUpdate')](value, el.attr('id'), eventData.timestamp);
				}
				else {
					elementValue(el, value, 'polling', eventData);
				}
			}
		})
		.catch((err) => {
			console.log(getDate()+` PUMA Error, fetch(${url}).catch(err)`, err, obj);
		});
	}

	function initPeriodicGet() {
		for (i=0; i<notSubscribed.length; i++) {
			readVar(notSubscribed[i]);
		}
		myInterval = setInterval(periodicGet, intervalMs/subperiodNumber);
		// initializeGauges();
	}

	function stopPeriodicGet() {
		clearInterval(myInterval);
	}


	function periodicGet() {
		/*
		intervalCounter++;
		subperiodCounter++;
		console.log('periodicGet()', notSubscribed.length);
		*/
		if (notSubscribed.length == 0) {
			intervalCounter = 0;
			return;
		}
		intervalCounter++;
		if (intervalCounter == 100) {
			subscribeVar(notSubscribed.shift());
			intervalCounter = 0;
		}
		subperiodCounter++;
		if (subperiodCounter >= subperiodNumber) subperiodCounter = 0;
		// console.log('notSubscribed', notSubscribed);
		for (i=0; i<notSubscribed.length; i++) {
			if ((i % subperiodNumber) == subperiodCounter) readVar(notSubscribed[i]);
		}
	}
			
	function initializeGauges() {
		// console.log('initializeGauges(), .gauge', $('.gauge'));
		$('.gauge').each(function() {
			// console.log('elem id', typeof $(this).attr('id'));
			// if (undefined !=$(this).attr('data-yellowZones'))
			if (typeof $(this).attr('id') == 'string') createGauge(
				$(this).attr('id'), 
				undefined !=$(this).attr('data-min')? $(this).attr('data-min')-0: 0,
				undefined !=$(this).attr('data-max')? $(this).attr('data-max')-0: 100,
				undefined !=$(this).attr('data-majorTicks')? $(this).attr('data-majorTicks')-0: 5, 
				undefined !=$(this).attr('data-minorTicks')? $(this).attr('data-minorTicks')-0: 4,
				$(this).attr('data-greenZones'),
				$(this).attr('data-yellowZones'),
				$(this).attr('data-redZones')
			);
		});
		// createGauge("currfil", "I fil.[mA]", 0, 2400 );
	}
			
	setTimeout(initPeriodicGet, 1000);


	function setupEventSource() {
		d = new Date();
		// console.log('new EventSource()',d.toLocaleString());
		evtSource = new EventSource(sseServer); 
		evtSource.onmessage = sseListener;
		evtSource.onopen = function(e) {
			// console.log('evtSource.onopen');
			reconnectFrequencySeconds = 1;
		};
		evtSource.onerror = function(e) {
			console.log('PUMA evtSource.onerror');
			evtSource.close();
			reconnectFunc();
		};
	}

	if (sseServer) {
		// https://stackoverflow.com/questions/24564030/is-an-eventsource-sse-supposed-to-try-to-reconnect-indefinitely
		var reconnectFrequencySeconds = 1;
		var evtSource;

		// Putting these functions in extra variables is just for the sake of readability
		var waitFunc = function() { return reconnectFrequencySeconds * 1000; };
		var tryToSetupFunc = function() {
			setupEventSource();
			reconnectFrequencySeconds *= 2;
			if (reconnectFrequencySeconds >= 15) {
				reconnectFrequencySeconds = 15;
			}
		};

		var reconnectFunc = function() { setTimeout(tryToSetupFunc, waitFunc()); };

		setupEventSource();
	}
	else if (wsServer) {
		var ws = new WebSocket(wsServer);
		// console.log('loadWsStatus, ws:', ws)
		if (ws) {
			ws.addEventListener('message', wsListener);
		}
	}
					
