<?php

	require_once("./conf.php");
	$sql = open_db();
	$sql2 = admin_open_db();
	if (isset($_REQUEST['stat'])) {
		$query = "SELECT CONCAT(srvnam, ':', port) AS srv, COUNT(*) AS n FROM service,srvconf,activity WHERE state='ACTIVE' AND service.conf_id=srvconf.conf_id AND activity.srv_id=service.id GROUP BY srvnam, port ORDER BY srvnam";
		$stmt = $sql2->sql_prepare($query, "qstat");
		$data = $sql2->sql_execute(array(), "qstat");
		$sum = 0; foreach($data as $d) { $sum += $d['n']; }
		foreach($data as $i=>$d) { $data[$i]['pc'] = $d['n']/$sum*100; $data[$i]['n'] = (int) $d['n']; }
		header('Content-Type: application/json');
		die(json_encode(array('data'=>$data,'datetime'=>date('Y-m-d H:i:s'),'sum'=>$sum)));
	}
	if (!isset($_REQUEST['table'])) {
		$query = "SELECT CONCAT(srvnam, ':', port) AS srv, COUNT(*) AS n FROM service,srvconf,activity WHERE state='ACTIVE' AND service.conf_id=srvconf.conf_id AND activity.srv_id=service.id GROUP BY srvnam, port ORDER BY srvnam";
		$stmt = $sql2->sql_prepare($query, "qstat");
		$data = $sql2->sql_execute(array(), "qstat");
		$sum = 0; foreach($data as $d) { $sum += $d['n']; }
		$xValues = $yValues = array();
		foreach($data as $d) { $y = round($d['n']/$sum*1000)/10; $yValues[] = $d['n']; $xValues[] = $d['srv']; }
		echo ('
		<!DOCTYPE html>
<html>
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.4/Chart.js"></script>
<body>

<canvas id="myChart" style="width:100%;max-width:600px"></canvas>

<script>
	function periodicGet() {
		fetch("https://puma-01.elettra.eu/status.php?stat")
		.then((response) => {
			if (response.status>=300) {
				console.log("PUMA Error, response", response);
			}
			else {
				return response.json();
			}  
		})
		.then((eventData) => {
			console.table(eventData);
			for (var i=0; i<eventData.length; i++) {
				xValues[i] = eventData[i].srv; // +"%";
				yValues[i] = eventData[i].n;
			}
			console.log(xValues, yValues);
			chart.data.labels = xValues;
			chart.data.datasets = [{
				backgroundColor: barColors,
				data: yValues
			}];
			chart.options.title.text = "server:port load balancing "+eventData.datetime+" src n: "+eventData.sum;
			chart.update();
		});
	}

myInterval = setInterval(periodicGet, 10000);

var xValues = ["'.implode('","', $xValues).'"];
var yValues = ['.implode(',', $yValues).'];
var barColors = [
  "orange",
  "green",
  "blue",
  "#b91d47",
  "#00aba9",
  "#2b5797",
  "#e8c3b9",
  "#1e7145",
];
var pieOptions = {
  events: false,
    title: {
      display: true,
      text: "server:port load balancing '.date('Y-m-d H:i:s').' src n: '.$sum.'"
    },
  animation: {
    duration: 150,
    easing: "easeOutQuart",
    onComplete: function () {
      var ctx = this.chart.ctx;
      ctx.font = Chart.helpers.fontString(Chart.defaults.global.defaultFontFamily, "normal", Chart.defaults.global.defaultFontFamily);
      ctx.textAlign = "center";
      ctx.textBaseline = "bottom";

      this.data.datasets.forEach(function (dataset) {

        for (var i = 0; i < dataset.data.length; i++) {
          var model = dataset._meta[Object.keys(dataset._meta)[0]].data[i]._model,
              total = dataset._meta[Object.keys(dataset._meta)[0]].total,
              mid_radius = model.innerRadius + (model.outerRadius - model.innerRadius)/2,
              start_angle = model.startAngle,
              end_angle = model.endAngle,
              mid_angle = start_angle + (end_angle - start_angle)/2;

          var x = mid_radius * Math.cos(mid_angle);
          var y = mid_radius * Math.sin(mid_angle);

          ctx.fillStyle = "#fff";
          if (i == 3){ // Darker text color for lighter background
            ctx.fillStyle = "#444";
          }
		  var pc = dataset.data[i]/total*100;
		  if (pc < 4) continue;
          var percent = String(Math.round(pc)) + "%";
          ctx.fillText(dataset.data[i], model.x + x, model.y + y);
          // Display percent in another line, line break doesn"t work for fillText
          ctx.fillText(percent, model.x + x, model.y + y + 15);
        }
      });               
    }
  }
};
var chart = new Chart("myChart", {
  type: "pie",
  data: {
    labels: xValues,
    datasets: [{
      backgroundColor: barColors,
      data: yValues
    }]
  },
  options: pieOptions
});
</script>

<br><br><br>');
	}
	ini_set('session.gc_maxlifetime', 8*3600);
	session_set_cookie_params(8*3600);
	session_start();
	$username = '';
	if (isset($_SESSION['token'])) {
		$webtokenExpirationSeconds = 28800; // 8 hh
		$yy = date('Y');
		$stmt = $sql->sql_prepare("SELECT * FROM userlog_$yy WHERE webtoken=$1 AND EXTRACT(EPOCH FROM NOW()-date)<$webtokenExpirationSeconds ORDER BY date DESC LIMIT 1", "q1");
		$data = $sql->sql_execute(array($_SESSION['token']), "q1");
		$username = $data[0]['username'];
	}
	if (!in_array($username, $admin)) die("Acces not granted");
	// echo "welcome $username<br>\n";

	$table = empty($_REQUEST['table'])? 'service': $_REQUEST['table'];
	$tableclass = !isset($_REQUEST['tableclass'])? 'table table-hover': $_REQUEST['tableclass'];
	$header = isset($_REQUEST['noheader'])? '': ($table=='service_history' || $table=='activity_history'? "<a href='./status.php'>home</a><br>": "<a href='./status.php?table=service_history'>service history</a> <a href='./status.php?table=activity_history'>activity history</a><br>");
	$query = empty($_REQUEST['query'])? "SELECT * FROM service ORDER BY expected DESC": $_REQUEST['query'];
	$paramArray = array();
	if ($table=='service') {$query = "SELECT * FROM service, srvconf WHERE service.conf_id=srvconf.conf_id";}
	if ($table=='activity') {$query = "SELECT * FROM activity WHERE srv_id=$1"; $paramArray = array($_REQUEST['id']);}
	if ($table=='service_history') $query = "SELECT * FROM service_history ORDER BY started DESC";
	if ($table=='activity_history') $query = "SELECT * FROM activity_history ORDER BY started DESC LIMIT 1000";

	$stmt = $sql2->sql_prepare($query, "q1");
	$data = $sql2->sql_execute($paramArray, "q1");
	echo "<head>
	<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css'>\n</head >\n$header<table class='$tableclass'>\n";
	foreach($data as $i=>$row) {
		if ($i==0 && !isset($_REQUEST['noheader'])) {
			echo "<tr>";
			foreach($row as $h=>$v) {
				if (isset($_REQUEST["skip$h"])) continue;
				echo "<th>$h</th>";
			}
			echo "</tr>\n";
		}
		echo "<tr>";
		foreach($row as $k=>$v) {
			if (isset($_REQUEST["skip$k"])) continue;
			if ($k=='expected' && $row['state']!== "INACTIVE") {
				$t = time() - strtotime($v);
				$color = $t>300? "200, 0, 0": ($t>30? "240, 200, 0": "0, 200, 0");
				echo "<td><span style='background: rgba($color, 0.7); border-radius: 10px; padding: 5px;'>$v</span></td>"; 
			} 
			else echo ($table=='service' && $k=='id' && $row['state']!='INACTIVE')? "<td><a onClick=\"$('#tr$v').toggle();\">$v</a></td>": "<td>$v</td>";
		}
		echo "</tr>\n"; 
		if ($table=='service') echo "<tr id='tr{$row['id']}' style='display: none;'><td colspan='100' style='padding:0;'><iframe style='width: 99%; border: 0; margin-left: 10px;' src='./status.php?table=activity&id={$row['id']}&noheader&skipsrv_id&skipchan&tableclass='></iframe></td></tr>\n";
	}
	die("</table>\n<script src='https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js' type='text/javascript'></script>
<script src='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/js/bootstrap.min.js'></script>");




	if (isset($_REQUEST['users'])) { 
		$data = $sql->sql_select('*', 'token', ($_REQUEST['users']=='all')? '1=1 ORDER BY username': 'id IN (SELECT DISTINCT tokenid FROM alarm) ORDER BY username');
		echo ($_REQUEST['users']=='all')? 'All ': 'Alarm subscribed ';
		echo "Users:<br><table>\n<tr><td>username</td><td>id</td><td>token</td></tr>";
		foreach ($data as $d) {
			echo "<tr><td>{$d['username']}</td><td><a href='?tokenid={$d['id']}&username={$d['username']}'>{$d['id']}</a></td><td>{$d['value']}</td></tr>";
		}
		die("</table><br>View ".(($_REQUEST['users']=='all')? "<a href='?users'>Alarm subscribed users</a>\n": "<a href='?users=all'>all users</a>\n"));
    }
	if (isset($_REQUEST['tokenid'])) {
		$username = strip_tags($_REQUEST['username']);
		echo "$username, tokenid: {$_REQUEST['tokenid']}<br>\n";
		if (isset($_REQUEST['alarm'])) {
			$stmt = $sql->sql_prepare("SELECT value FROM token WHERE id=$1", "q6");
			$data = $sql->sql_execute(array($_REQUEST['tokenid']), "q6");
			$token = $data[0]['value'];
			echo strip_tags($_REQUEST['alarm']);
			$stmt = $sql->sql_prepare("SELECT * FROM formula WHERE label=$1", "q5");
			$data = $sql->sql_execute(array($_REQUEST['alarm']), "q5");
			echo "<pre>"; print_r($data[0]); echo "</pre>
				<script>
				  function ackAlarm(alarm, token) {
				  	const url = '$host:10443/v1';
					console.log('ackAlarm(alarm, token)', `\${url}/formula/\${alarm} {${token}}`);
					fetch(`\${url}/formula/\${alarm}`, {
					  method: 'POST',
					  headers: {
						Accept: 'application/json',
						'Content-Type': 'application/json',
						token: token,
					  },
					  body: JSON.stringify({ack: 1}),
					})
					.then(response => {
					  console.log('ackAlarm(alarm, token), response', response);
				  	})
				  }
					  function subscribeAlarm(alarm, token) {
						const url = '$host:10443/v1';
						console.log('subscribeAlarm(alarm, token)', `\${url}/formula/\${alarm}`, token);
						fetch(`\${url}/formula/\${alarm}`, {
						  method: 'SUBSCRIBE',
						  headers: {
							Accept: 'application/json',
							'Content-Type': 'application/json',
							token: token,
							// username: '$username',
						  },
						  body: JSON.stringify({ack: 1}),
						})
						.then(response => {
						  console.log('subscribeAlarm(alarm, token), response', response);
						});
					  }
					  function unsubscribeAlarm(alarm, token) {
						const url = '$host:10443/v1';
						console.log('unsubscribeAlarm(alarm, token)', `\${url}/formula/\${alarm}`, token);
						fetch(`\${url}/formula/\${alarm}`, {
						  method: 'UNSUBSCRIBE',
						  headers: {
							Accept: 'application/json',
							'Content-Type': 'application/json',
							token: token,
						  },
						  body: JSON.stringify({ack: 1}),
						})
						.then(response => {
						  console.log('unsubscribeAlarm(alarm, token), response', response);
						});
					  }
				</script>
				<button onClick=\"ackAlarm('{$_REQUEST['alarm']}', '$token')\">ACK</button>
				<button onClick=\"subscribeAlarm('{$_REQUEST['alarm']}', '$token')\">Subscribe</button>
				<button onClick=\"unsubscribeAlarm('{$_REQUEST['alarm']}', '$token')\">Unsubscribe</button>
			<br>\n";
			$stmt = $sql->sql_prepare("SELECT * FROM alarmlog WHERE tokenId=$1 AND label=$2 ORDER BY date DESC", "q3");
			$data = $sql->sql_execute(array($_REQUEST['tokenid'],$_REQUEST['alarm']), "q3");
			echo "<table>\n<tr><td>date</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>ack&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>subscribe</td></tr>";
			if (!empty($data)) foreach ($data as $d) {
				echo "<tr><td> {$d['date']} </td><td>&nbsp;</td><td> {$d['ack']} </td><td> {$d['subscribe']} </td></tr>\n";
			}
			die("</table>\n");
		}
		if (isset($_REQUEST['delete'])) {
			$stmt = $sql->sql_prepare("DELETE FROM alarm WHERE tokenId=$1", "q2");
			$data = $sql->sql_execute(array($_REQUEST['tokenid']), "q2");
			echo "Deleted all alarms of $username<br><br>\n";
		}
		$stmt = $sql->sql_prepare("SELECT * FROM alarm WHERE tokenId=$1 ORDER BY label", "q4");
		$data = $sql->sql_execute(array($_REQUEST['tokenid']), "q4");
		echo "<a href='?tokenid={$_REQUEST['tokenid']}&delete'>delete</a><table>\n<tr><td>registered alarms:</td></tr>\n";
		if (!empty($data)) foreach ($data as $d) {
			echo "<tr><td><a href='?alarm={$d['label']}&tokenid={$d['tokenid']}&username=$username'>{$d['label']}</a></td></tr>";
		}
		die("</table>\n");
    }
	if (isset($_REQUEST['curl'])) {
		$ctx = stream_context_create(array('http'=>array('timeout' => 1)));
		$domains = array("srv-tango-srf.fcs.elettra.trieste.it","tom.ecs.elettra.trieste.it","srv-padres-srf.fcs.elettra.trieste.it","srv-ldm-srf.fcs.elettra.trieste.it","srv-tmx-srf.fcs.elettra.trieste.it","srv-tf-srf.fcs.elettra.trieste.it","srv-diproi-srf.fcs.elettra.trieste.it","srv-tmr-srf.fcs.elettra.trieste.it");
		$stat = array();
		foreach ($domains as $domain) {
			$stat[$domain] = array('curl'=>strlen(file_get_contents("$host:10443/v1/cs/tango://$domain:20000/*", false, $ctx)));
			exec("ping -c 1 $domain | grep received", $pingres, $pingerr);
			// echo "$domain<pre>"; print_r($pingres); echo "</pre><br>\n";
			$pingArray = explode(',',$pingres[0]);
			$stat[$domain]['ping'] = $pingerr==0 && strpos($pingArray[1], '1 received')!==false;
			unset($pingres);
			unset($pingerr);
		}
		echo "<pre>"; print_r($stat); echo "</pre><br>\n";
		exit(0);
	}
	if (isset($_REQUEST['sleep'])) {
		if ($_REQUEST['sleep']>0) sleep($_REQUEST['sleep']);
		die("sleep ".$_REQUEST['sleep']);
	}
	if (isset($_REQUEST['pidof'])) {
		exec('pidof canoned', $res, $err);
		$alarm = $err>0 || !(isset($res[0]));
		/*
		exec('ping -c 1 log | grep received', $pingres, $pingerr);
		$pingArray = explode(',',$pingres[0]);
		$ping = $pingerr==0 && strpos($pingArray[1], '1 received')!==false;
		*/
		// echo "ping: ".($ping?"OK":"NOK")."<br>err: $err<pre>"; print_r($pingres); print_r($pingArray); echo "</pre><br>\n";
		die("
		<html><head>
			  <title>PUMA status</title>
			  <meta http-equiv='refresh' content='10;?pidof'>".($alarm?"<link rel='SHORTCUT ICON' href='./img/led_yellow.gif' />": '')."
			  <meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
			  </head>
			  <body>".($alarm? "ERRORE, server canoned non funzionante": "OK")."
		</body></html>");
	}
	$s = file_get_contents("$host:10080/status");
	$status = json_decode($s);
	echo "<a href='?users'>users</a><br>\n<!--a href='./log/'>logs</a><br-->\n<pre>"; print_r($status); echo "</pre><br>\n";
?>
